Program firewhip;     // 17-07-2010

import "mod_screen";
import "mod_text";
import "mod_scroll";
import "mod_math";
import "mod_video";
import "mod_map";
import "mod_sound";
import "mod_draw";
import "mod_grproc";
import "mod_rand";
import "mod_file";
import "mod_regex";
import "mod_dir";
import "mod_sys";
import "mod_string";
import "mod_say";
import "mod_wm";
#ifdef WII_EXTENSIONS
import "mod_wpad";
#endif

#include "jkeys.lib"
#include "lang.lib"

CONST
    floor=0;                    // Para el proceso de la trampa-lanza
    der=1;
    izq=2;
    techo=3;
END

GLOBAL
    nivel=16;            // Numero de niveles
    vidas=5;             // Numero de vidas
    toques=5;            // Numero de toques hasta que te quiten una vida
    super=3;            // Numero de superataques
    puntos=0;            // Variable para la puntuacion
    bonos=0;             // Numero de bonos recogidos
    fuente1=0,fuente2=0;     // Identificadores de las fuentes
    despertar=0;        // Masteries, fix del prota fantasma
    no_graph;            // Ms cosas del fix
    pregraph;            // Fix
    graficos_fase;
    graficos_splash;
    graficos_general;

    s_laser;            // Identificador para el sonido de disparo
    s_latigo2;            // Identificador para el sonido del latigo electrico
    s_fiu;                // Identificador para el sonido de proyectil
    s_queja;            // Identificador para el sonido del quejido
    s_scarab;            // Identificador para el sonido del escarabajo
    s_whip;                // Identificador para el sonido del latigazo
    s_bonos;             // Identificador para el sonido de recogida de bonos
    s_caida;             // Identificador para el sonido de caida
    s_salto;            // Identificador para el sonido de salto
    s_abeja;             // Identificador para el sonido de abejorro
    s_ogro;              // Identificador para el sonido de los ogros
    s_estrella;          // Identificador para el sonido de estrellas
    s_golpe;               // Identificador para el sonido del impacto
    s_roca;                // Identificador para el sonido del golpe a la roca
    s_bang;                // Identificador para el sonido de explosin
    s_super;            // Identificador para el sonido del superltigo
    s_argh;                // Identificador para el sonido del quejido del ogro
    s_lanza;              // Identificador para el sonido de la lanza
    s_blade;            // Identificador para el sonido de las cuchillas
    s_muelle;            // Identificador para el sonido del muelle
    s_splash;            // Identificador para el sonido del chapuzon
    s_onda;                // Identificador para el sonido de la onda vital
    s_shout;            // Identificador para el sonido del grito de la reina

    music,music_menu,music1,music2,music3,music4,music5,music6,music7,music8,music9;

    energia_enemigo;    // Variable para el nivel de energia enemigos fin de fase
    id_barra_enemigo;   // Identificador para quitar la barra de energia
    fin_nivel=false;    // Variable para controlar si se ha terminado un nivel
    idtextovida;        // Variables que manejan el texto cuando sale una vida
    contadortextovida;
    contextovida=0;
    idtextotoke;
    contadortextotoke;
    contextotoke=0;

    idprincipal;
    idprota;
    idprota2;
    idpared;
    tipolatigo=0;                // Variable que define el tipo de latigo
    BYTE twef[4]=0;                // Masteries, del cdigo del Viaje, variable para dibujar el sprite del efecto de agua, seala al primer grfico
    BYTE suelo_lago=0;
    BYTE pause=0;                  // Masteries, para el proceso de pausar el juego
    BYTE bolas_fuego=0;            // del Dragn
    
    string savegamedir;            // Variable con la ruta al lugar donde guardaremos el fichero de configuracin
    string developerpath="/Firewhip/";
    Struct ops;
        byte nivel=1;           // El nivel guardado
        byte vidas=5;
    End

Local
    velocidad_gravedad; // Variable para guardar la velocidad de caida (gravedad)
    velocidad=0;        // Variable para guardar la velocidad horizontal del protagonista
    muerte;             // Variable para guardar si el protagonista esta muerto
    angulo2;            // Variable de uso general angulos
    disparo2=false;     // Variable que determina si el prota dispara saltando
    int oldgraph;        // Variable donde guardar el grfico cuando se lo pida
    int cadencia;        // Contador que determina la cadencia entre disparos del prota
    int contadorsalto;    // Contador para evitar la repeticin de los saltos
    cinvencible=0;        // Si mayor que 0 invencible=true
    invencible=false;   // Si true, prota invencible; si false, pues no

Private
    pantalla=1;         // Pantalla que se ve como menu
    saliendo=0;         // 1=Se quiere salir del juego
    int fp;
    string env_lang;
    string cadena_lenguaje;
    string cadena_lenguaje_bien;
Begin
    idprincipal=id;
    full_screen=false;
    set_title("Firewhip");
    if(os_id==OS_GP32 || os_id==OS_GP2X || os_id==OS_GP2X_WIZ || os_id==OS_CAANOO || os_id==OS_WII)
        set_mode(320,240,8);
    else
        set_mode(320,240,8,MODE_16BITS);
    end;
    set_fps(30,0);                  // Velocidad 30 frames por segundo con un frameskip de 0 pantallas


    // Intentar determinar idioma y lugar de guardado del fichero de partidas
    switch(os_id)
        case OS_WIN32: //windows
            //qu lenguaje lleva este windows?
            if(!fexists(getenv("TEMP")+"\lang.txt")) exec(1,"language.bat",0,0); end
            fp=fopen(getenv("TEMP")+"\lang.txt",O_READ);
            if(fp) 
                cadena_lenguaje=fgets(fp);
                fclose(fp);
            end
            cadena_lenguaje_bien=""+cadena_lenguaje[25]+cadena_lenguaje[26]+cadena_lenguaje[27]+cadena_lenguaje[28];
            switch(cadena_lenguaje_bien)
                case "0c0a": lang=1; end
            end
            
            // Lugar donde guardar el savegame
            savegamedir=getenv("APPDATA")+developerpath;
            if(savegamedir==developerpath) //windows 9x/me
                savegamedir=cd();
            else
                crear_jerarquia(savegamedir);
            end
        end

        case OS_LINUX: //linux
            // Aportado por Miry: Se pone aqu para evitar que use el lenguaje ya asignado en una versin anterior
            env_lang=getenv("LANG");
            env_lang=""+env_lang[0]+env_lang[1];
            switch(env_lang)
                case "es": lang=1; end
            end
            //-------------------
            savegamedir=getenv("HOME")+"/.config"+developerpath;
            crear_jerarquia(savegamedir);
        end

        // Determinar el idioma en la Caanoo
        case OS_CAANOO:
            fp=fopen("/mnt/ubifs/usr/gp2x/common.ini",O_READ);
            if(fp)
                while(!feof(fp))
                    cadena_lenguaje=fgets(fp);
                    if(find(cadena_lenguaje,"language")>-1)
                        env_lang=""+cadena_lenguaje[11]+cadena_lenguaje[12];
                        break;
                    end
                end
                fclose(fp);
            end
            switch(env_lang)
                case "es": lang=1; end
            end
        end
    end
    
    // Las variables que se leen de aqu sobreescriben a las determinadas
    // en el bloque anterior
    if(file_exists(savegamedir+"save.dat"))
        load(savegamedir+"save.dat", ops);
    end

    // Pantallas de presentacion
    graficos_splash=load_fpg("splash.fpg");
    s_bonos=load_wav("bonus.wav");
    put_screen(0,0);    // Fix
    fade_on();
    While(fading)
        Frame;
    End
    Frame;
    fade_off();
    While(fading)
        Frame;
    End
    put_screen(graficos_splash,1);
    fade_on();
    While(fading)
            Frame;
    End
    Frame(5400);        // 2 segundos
    fade_off();
    While(fading)
        Frame;
    End
    put_screen(graficos_splash,2);
    fade_on();
    While(fading)
        Frame;
    End
    Frame(5400);           // 2 segundos
    fade_off();
    While(fading)
        Frame;
    End
    put_screen(graficos_splash,3);
    write_translated(0,160,96,4,"With special support from");
    fade_on();
    While(fading)
        Frame;
    End
    Frame(5400);           // 2 segundos
    fade_off();
    While(fading)
        Frame;
    End
    delete_text(all_text);
    put_screen(graficos_splash,4);
    fade_on();
    While(fading)
        Frame;
    End
    Frame(4000);
    play_wav(s_bonos,0);
    put_screen(graficos_splash,5);
    Frame(2000);
    put_screen(graficos_splash,6);
    Frame(4000);
    fade_off();
    While(fading)
        Frame;
    End
    Frame(1800);
    fade_off();
    delete_text(all_text);
    While(fading)
        Frame;
    End
    unload_wav(s_bonos);
    unload_fpg(graficos_splash);

    // Fin de las pantallas de presentacin

    graficos_general=load_fpg("firewhip.fpg");        // Carga el fichero de graficos general
    put_screen(0,0);                  // Pon la pantalla de fondo
    load_pal("firewhip.fpg");        // Carga la paleta de colores
    fade_on();
    while(fading)
        Frame;
    end;

    write_translated(fuente1,60,200,4,"Loading...");
    Frame(2000);

    //Carga sonidos

    s_golpe=load_wav("golpe.wav");                // Sonido de impacto
    s_estrella=load_wav("estrella.wav");          // Sonido de estrellas
    s_ogro=load_wav("ogro.wav");                   // Sonido del ogro
    s_abeja=load_wav("abeja.wav");                // Sonido del abejorro
    s_salto=load_wav("salto.wav");               // Sonido de salto dos
    s_caida=load_wav("caida.wav");                 // Sonido de caida
    s_bonos=load_wav("bonus.wav");                // Sonido de bonos
    s_whip=load_wav("whip.wav");                // Sonido del latigo
    s_scarab=load_wav("scarab.wav");            // Sonido de escarabajo
    s_queja=load_wav("queja.wav");              // Sonido del quejido
    s_fiu=load_wav("fiu.wav");                    // Sonido de proyectil
    s_latigo2=load_wav("latigo2.wav");            // Sonido de latigo electrico
    s_laser=load_wav("laser.wav");                // Sonido de disparo
    s_roca=load_wav("roca.wav");                // Sonido de roca
    s_bang=load_wav("bang.wav");                // Sonido de explosin
    s_super=load_wav("super.wav");                // Sonido del superltigo
    s_argh=load_wav("argh.wav");                // Sonido del ogro al morir
    s_lanza=load_wav("lanza.wav");                // Sonido de la lanza al saltar
    s_blade=load_wav("sword.wav");                // Sonido de la cuchilla giratoria
    s_muelle=load_wav("muelle.wav");            // Sonido de la ballesta
    s_splash=load_wav("splash.wav");            // Sonido del chapuzon
    s_onda=load_wav("onda.wav");                // Sonido de la onda vital
    s_shout=load_wav("shout.wav");                // Sonido del grito de la reina

    music_menu=load_song("music0.mod");
    music=-1; music1=0; music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
    fade_off();                     // Apaga la pantalla
    while(fading)
        Frame;
    end;
    delete_text(all_text);          // Borra todos los textos de pantalla

    jkeys_set_default_keys();
    Loop                                    // Bucle principal
        play_song(music_menu,-1);
        let_me_alone();                 // Termina con cualquier proceso aun activo
        jkeys_controller();
        fade_on();                      // Enciende la pantalla
        while(fading)
            Frame;
        end;
        titulo(1,160,80,-250);             // Pone el titulo del juego (proceso)

        // Inicia el scroll de la presentacin
        start_scroll(0,graficos_general,3,99,0,8);

        primer_plano3(59,0,200,1);
        primer_plano3(59,320,340,0);

        // Pone textos explicativos
		switch(os_id)
			case OS_GP32, OS_GP2X, OS_GP2X_WIZ, OS_CAANOO:
				write_translated(0,160,181,1,"Press MENU");
			end;
			case OS_WII:
			    write_translated(0,160,181,1,"Press A on your Wiimote");
			end;
			default:
				write_translated(0,160,181,1,"Press ENTER");
			end;
		end;
        write_translated(0,300,230,1,"V 1.0");

        titulo(85,160,185,-248);

        scroll[0].camera=id;

        // Pone las coordenadas del proceso camara
        x=160; y=520;

        Repeat                        // Repite el bucle de la presentacin
            If (jkeys_state[_JKEY_SELECT]); exit(0);End
            y=y-1;Frame;         // Avanza la camara 1 punto por bucle
            If (y==120) y=520; End
        Until (jkeys_state[_JKEY_MENU])             // Hasta que se pulse enter (start)

        fade_off();                         // Apaga pantalla
        while(fading)
            Frame;
        end;
        // Inicializa variables de juego
        // Fase=1, vidas=5, puntuacion=0, bonus=0
        nivel=ops.nivel;//seleccin del nivel 1
        vidas=ops.vidas;
        toques=5;
        super=3;
        puntos=0;
        bonos=0;
        tipolatigo=0;
        energia_enemigo=160;

        Repeat                          // Bucle para pantalla de espera de carga
            let_me_alone();
            jkeys_controller();
            stop_scroll(0);
            stop_scroll(1);
            stop_scroll(2);
            stop_scroll(3);
            delete_text(all_text);

            put_screen(graficos_general,2);// Pinta pantalla de fondo
            write_translated(fuente2,52,57,4,"ZONE");
            write_int(fuente2,80,57,4,&nivel);
            fade_on();      // Enciende la pantalla
            While (fading)  // Espera mientras inicia todo, que
                Frame;      // seral acabar el apagado de pantalla
            End
            FRAME(3000);
            fade_off();
            while(fading)
                frame;
            end;
            delete_text(all_text);

            // Coloca marcadores de puntos, vidas y bonos
            objeto(graficos_general,222,20,16,-512,0);             // Pinta vidas
            write_translated(fuente1,40,16,4,"x");
            write_int(fuente1,48,16,3,&vidas);
            barra(graficos_general,290,224,-512,0);                // Pinta energia
            barra2(graficos_general,160,16,-512,0);
            objeto(graficos_general,221,265,17,-512,0);            // Pinta bonos
            write_translated(fuente1,288,16,4,"x");
            write_int(fuente1,296,16,3,&bonos);        // Inicializa variable
            //write(0,236,220,0,"fps");
            //write_var(0,218,220,0,fps);

            fin_nivel=false;                        // controladora de fin de fase
            //pausa();//Masteries, proceso de pausa
            Switch (nivel)  // Bucle para niveles
                Case 1:                         // Inicializa nivel uno
                    stop_song();
                    graficos_fase=load_fpg("nivel1.fpg");        // Carga el bloque de graficos del nivel uno
                    If (music!=music1)
                        unload_song(music); music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music1.mod");
                        music1=music;
                    End;
                    play_song(music,-1);

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Inicializa objetos de primer plano
                    primer_plano2(4,150,128,1);
                    primer_plano2(4,350,128,1);
                    primer_plano2(4,550,128,1);
                    primer_plano2(4,750,128,1);
                    primer_plano2(4,950,128,1);
                    primer_plano2(4,1150,128,1);
                    primer_plano2(4,1350,128,1);
                    primer_plano2(4,1550,128,1);
                    primer_plano2(4,1750,128,1);
                    primer_plano2(4,1950,128,1);
                    primer_plano2(4,2150,128,1);
                    primer_plano2(4,2350,128,1);

                    // Inicializa antorcha fija
                    antorcha2(3088,86,50);

                    // Inicializa el objeto del protagonista
                    idprota=prota(120,224);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    From z=0 To 10;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 2:                         // Inicializa nivel dos
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel2.fpg");        // Carga el bloque de graficos del nivel dos

                    If (music!=music1)
                        stop_song();
                        unload_song(music); music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music1.mod");
                        music1=music;
                        play_song(music,-1);
                    End;

                    // Inicializa objetos de primer plano
                    start_scroll(0,graficos_fase,1,3,0,8);

                    primer_plano(6,18,2150,1);
                    primer_plano(6,1200,2150,0);
                    primer_plano(6,27,1730,1);
                    primer_plano(6,1200,1670,0);
                    primer_plano(6,27,1350,1);
                    primer_plano(6,1200,1350,0);
                    primer_plano(6,27,950,1);
                    primer_plano(6,1200,900,0);
                    primer_plano(6,27,600,1);
                    primer_plano(6,1200,300,0);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    antorcha2(206,2278,50);
                    antorcha2(398,2214,50);
                    antorcha2(974,1382,50);
                    antorcha2(1166,1382,50);
                    antorcha2(654,1640,50);

                    objeto(graficos_fase,004,250,885,-256,1);
                    objeto(graficos_fase,005,1254,149,-256,1);

                    // Inicializa el objeto del protagonista
                    idprota=prota(100,2362);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 22;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 3:                         // Inicializa nivel tres
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel3.fpg");   // Carga el bloque de graficos

                    If (music!=music1)
                        stop_song();
                        unload_song(music); music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music1.mod");
                        music1=music;
                        play_song(music,-1);                        
                    End;

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(112,128);

                    objeto(graficos_fase,004,1702,277,-240,1);
                    objeto(graficos_fase,004,6374,405,-240,1);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 29;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 4:                         // Inicializa nivel cuatro
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel4.fpg");        // Carga fichero de graficos para nivel tres
                    If (music!=music2)
                        stop_song();
                        unload_song(music); music1=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music2.mod");
                        music2=music;
                        play_song(music,-1);
                    End;

                    // Inicializa scroll para nivel 4
                    start_scroll(0,graficos_fase,1,3,0,8);

                    // Selecciona la zona del scroll a partir de donde se mueve
					scroll[0].region1=-1;

                    // Inicializa protagonista
                    idprota=prota(64,4768);

                    // Coge puntos de control para bonos
                    From z=0 To 21;
                        get_point(graficos_fase,1,z,&x,&y); // Coge puntos
                        bono(x,y);              // Pone bonos
                    End
                End

                Case 5:                     // Inicializa fase cinco
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel5.fpg");     // Carga fichero de graficos para fase cinco
                    If (music!=music3)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music3.mod");
                        music3=music;
                        play_song(music,-1);
                    End;

                    // Inicializa scroll para fase cinco
                    start_scroll(0,graficos_fase,1,3,0,4);
                    // Define la zona de scroll a partir de donde se mueve
					scroll[0].region1 = -1;

                    // Inicializa protagonista
                    idprota=prota(256,288);

                    antorcha2(2,130,50);
                    antorcha2(510,130,50);
                    antorcha2(96,162,50);
                    antorcha2(416,162,50);

                    barra_energia();

                    // Inicializa monstruo fin de fase (Escarabajo Gigante)
                    bigboss(4,0,256,128,128,32,300,48);
                End

                Case 6:                         // Inicializa nivel seis
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel6.fpg");   // Carga el bloque de graficos
                    If (music!=music4)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music4.mod");
                        music4=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1 = -1;
					
                    // Inicializa el objeto del protagonista
                    idprota=prota(90,420);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 25;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                    lluvia();//inicia la lluvia
                End

                Case 7:                         // Inicializa nivel siete
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel7.fpg");   // Carga el bloque de graficos
                    If (music!=music5)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music5.mod");
                        music5=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll

                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(90,448);

                    antorcha2(240,371,50);
                    antorcha2(3823,371,50);
                    antorcha2(2158,390,50);
                    antorcha2(5231,339,50);
                    antorcha2(7151,51,50);

                    objeto(graficos_fase,004,1638,405,-256,1);
                    objeto(graficos_fase,005,2298,405,-256,1);
                    objeto(graficos_fase,005,3578,85,-255,1);
                    objeto(graficos_fase,009,3504,96,-256,1);
                    objeto(graficos_fase,009,3408,96,-256,1);
                    objeto(graficos_fase,008,3344,96,-256,1);

                    plataforma_metal(3720,160,3720,280,1,false);
                    plataforma_metal(4700,120,4700,214,1,false);
                    plataforma_metal(6680,180,6680,408,1,false);

                    idpared=pared(graficos_general,86,3296,240,50,1,3256,3336,3255,3337);

                    primer_plano2(6,500,480,1);
                    primer_plano2(6,2200,480,1);
                    primer_plano2(6,4000,480,1);
                    primer_plano2(6,4800,480,1);
                    primer_plano2(6,6100,480,1);

                    powerup(3248,90,22,8);
                    redjar(3312,90,20,8);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 20;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 8:                         // Inicializa nivel ocho
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel8.fpg");        // Carga el bloque de graficos del nivel dos

                    If (music!=music5)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music5.mod");
                        music5=music;
                        play_song(music,-1);
                    End

                    // Inicializa objetos de primer plano
                    start_scroll(0,graficos_fase,1,3,0,8);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(100,128);

                    // Inicializa la plataforma; true=estar en movimiento
                    plataforma_metal(700,2000,700,2320,1,false);

                    primer_plano(6,27,2280,0);
                    primer_plano(6,1200,2160,1);
                    primer_plano(6,27,1860,0);
                    primer_plano(6,1200,1680,1);
                    primer_plano(6,27,1400,0);
                    primer_plano(6,1200,1200,1);
                    primer_plano(6,27,1000,0);
                    primer_plano(6,1200,720,1);
                    primer_plano(6,27,540,0);
                    primer_plano(6,1200,240,1);
                    primer_plano(6,27,120,0);

                    antorcha2(398,1254,50);
                    antorcha2(686,1254,50);

                    //Coge puntos de control del mapa para bonos
                    From z=0 To 28;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 9:
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel9.fpg");
                    
                    If (music!=music5)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music5.mod");
                        music5=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(115,224);

                    antorcha2(1584,147,50);

                    objeto(graficos_fase,004,5574,117,-256,1);
                    objeto(graficos_fase,005,5786,117,-256,1);
                    objeto(graficos_fase,004,2374,149,-256,1);
                    objeto(graficos_fase,005,2746,149,-256,1);

                    plataforma_metal(3158,224,3158,370,1,false);
                    plataforma_metal(6070,80,6070,210,1,true);
                    plataforma_metal(5930,360,5930,260,1,true);

                    primer_plano2(6,1440,480,1);
                    primer_plano2(6,2880,480,1);
                    primer_plano2(6,4320,480,1);
                    primer_plano2(6,7560,480,1);

                    powerup(1600,26,22,8);
                    powerup(4384,320,22,8);
                    redjar(1664,26,20,8);
                    redjar(4128,320,20,8);
                    redjar(4640,320,20,8);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 25;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 10:
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel10.fpg");
                    If (music!=music6)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music5=0; music7=0; music8=0; music9=0;
                        music=load_song("music6.mod");
                        music6=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(120,256);

                    plataforma_madera(5008,160,5008,224,1);

                    antorcha2(192,114,50);
                    antorcha2(2496,242,50);

                    From z=0 To 25;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 11:
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel11.fpg");
                    If (music!=music7)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music5=0; music6=0; music8=0; music9=0;
                        music=load_song("music7.mod");
                        music7=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(120,100);

                    bolab(120,-200);

                    plataforma_metal(2520,256,2260,256,1,false);

                    From z=0 To 22;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                End

                Case 12:
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel12.fpg");

                    If (music!=music7)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music5=0; music6=0; music8=0; music9=0;
                        music=load_song("music7.mod");
                        music7=music;
                        play_song(music,-1);
                    End

                    // Inicializa scroll
                    start_scroll(0,graficos_fase,1,3,0,4);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(100,176);

                    agua(3,005,384,224,-10);
                    agua(3,004,496,224,-10);
                    agua(3,006,608,224,-10);
                    agua(3,005,5664,224,-10);
                    agua(3,004,5776,224,-10);
                    agua(3,004,5936,224,-10);
                    agua(3,006,6048,224,-10);
                    agua(3,005,6784,224,-10);
                    agua(3,004,6896,224,-10);
                    agua(3,006,7008,224,-10);
                    agua(3,005,10176,224,-10);
                    agua(3,004,10288,224,-10);
                    agua(3,004,10448,224,-10);
                    agua(3,004,10608,224,-10);
                    agua(3,006,10720,224,-10);
                    agua(3,005,10880,224,-10);
                    agua(3,004,10992,224,-10);
                    agua(3,004,11152,224,-10);
                    agua(3,004,11312,224,-10);
                    agua(3,006,11424,224,-10);

                    From z=0 To 22;
                        get_point(graficos_fase,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos
                    End
                    lluvia();//inicia la lluvia
                End

                Case 13:                     // Inicializa fase 13
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel13.fpg");     // Carga fichero de graficos para fase cuatro
                    If (music!=music3)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music4=0; music5=0; music6=0; music7=0; music8=0; music9=0;
                        music=load_song("music3.mod");
                        music3=music;
                        play_song(music,-1);
                    End;

                    // Inicializa scroll para fase cinco
                    start_scroll(0,graficos_fase,1,3,0,4);
                    // Define la zona de scroll a partir de donde se mueve
					scroll[0].region1=-1;

                    // Inicializa protagonista
                    idprota=prota(256,288);
                    agua(0,0,0,0,0);//animacin al fondo del agua en movimiento
                    agua(1,0,0,0,0);//sprite fijo del agua que tapa al personaje de forma parcial
                    energia_enemigo=160;
                    barra_energia();

                    // Inicializa monstruo fin de fase (Dragn)
                    dragon(550,200);
                End

                Case 14:                         // Inicializa nivel catorce
                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel14.fpg");
                    If (music!=music8)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music9=0;
                        music=load_song("music8.mod");
                        music8=music;
                        play_song(music,-1);
                    End

                    start_scroll(0,graficos_fase,1,3,0,8);

                    // Define la zona del scroll a partir de la cual se mueve
					scroll[0].region1=-1;

                    // Inicializa el objeto del protagonista
                    idprota=prota(60,1024);

                    // Inicializa la plataforma; true=estar en movimiento

                    rotor(320,558,256);
                    rotor2(320,558,256);

                    antorcha2(71,923,50);
                    antorcha2(247,875,50);
                    antorcha2(391,875,50);
                    antorcha2(567,923,50);

                    plataforma2(graficos_fase,4,200,1032,0,1);
                    plataforma2(graficos_fase,4,320,1016,0,1);
                    plataforma2(graficos_fase,4,440,1032,0,1);

                    energia_enemigo=160;
                    barra_energia();

                    plataforma_metal(320,480,320,380,1,true);
                    plataforma_metal(320,830,320,1200,1,false);
                    plataforma_metal(70,596,70,810,1,true);
                    plataforma_metal(570,596,570,810,1,true);

                    powerup(200,980,24,8);
                    redjar(440,980,24,8);

                    // Inicializa monstruo fin de juego (Reina verde)
                    queen(5,0,320,920,120,100,24,36);

                End

                Case 15:
                    delete_text(all_text);
                    signal(type objeto, s_kill);
                    signal(type barra, s_kill);
                    signal(type barra2, s_kill);

                    unload_fpg(graficos_fase);
                    graficos_fase=load_fpg("nivel15.fpg");
                    If (music!=music9)
                        stop_song();
                        unload_song(music); music1=0; music2=0; music3=0; music4=0; music5=0; music6=0; music7=0; music8=0;
                        music=load_song("music9.mod");
                        music9=music;
                        play_song(music,-1);
                    End
                    fondo();
                    credits(80,006);
                    credits(280,007);
                    credits(415,009);
                    credits(588,010);
                    credits(801,011);
                    credits(948,012);
                    credits(1094,013);
                    credits(1266,014);
                    credits(1426,015);
                    credits(1559,016);
                    credits(1705,017);
                    credits(1866,018);
                    credits(1997,019);
                    credits(2130,020);
                    credits(2263,021);
                    credits(2397,022);
                    credits(2530,023);
                    credits(2662,024);
                    credits(2948,025);
                    credits(3106,026);
                    scrollcrd(160,240,-256,001,6);    // Hierba
                    scrollcrd(480,240,-256,001,6);    // Hierba
                    scrollcrd(160,212,-254,002,4);    // Arboles
                    scrollcrd(480,212,-254,002,4);    // Arboles
                    scrollcrd(160,240,-250,003,2);    // Montaa y lago
                    scrollcrd(480,240,-250,003,2);    // Montaa y lago
                    scrollcrd(160,140,-240,004,1);    // Montaa fondo
                    scrollcrd(480,140,-240,004,1);    // Montaa fondo
                    scrollcrd(160,120,0,005,0);            // Cielo
                    caballo(80,220);
                    fade_on();
                    while(fading)
                        Frame;
                    end;
                End
            End

            fade_off();             // Apaga pantalla
            while(fading)
                Frame;
            end;
            clear_screen();         // Borra pantalla
            fade_on();              // Enciende pantalla
            while(fading)
                Frame;
            end;

            Repeat                  // Bucle principal del juego

                // Si se pulsa a la vez L y R pasa de nivel
                //If (jkeys_state[_JKEY_L] AND jkeys_state[_JKEY_R])
                //    fin_nivel=true;
                //End
                Frame;

            // Repite hasta que se pase de nivel o te quedes sin vidas
            Until (fin_nivel OR vidas<0 OR jkeys_state[_JKEY_SELECT])
            If (jkeys_state[_JKEY_SELECT])
                saliendo=1;
            End
            If (fin_nivel)        // Si se ha terminado la fase
                nivel++;          // Incrementa la fase
                fin_nivel=false;  // Inicializa la variable de control de fase

                //Guarda la partida
                ops.nivel=nivel;
                ops.vidas=vidas;
                save(savegamedir+"save.dat", ops);
            End
            If (vidas<0)
                // After Game Over, you go back to first level
                ops.nivel=1;
                ops.vidas=5;
                save(savegamedir+"save.dat", ops);

                write_translated(fuente2,160,100,4,"GAME OVER");
                Frame (6000);
            End
            If (nivel==16)                //Masteries, aqu se pondr el nmero del ltimo nivel
                Frame(1000);
                write_translated(fuente2,160,100,4,"YOU'VE COMPLETED THE GAME");
                Frame(6000);
            End

            Frame(600);
            fade_off();                      // Apaga pantalla
            while(fading)
                Frame;
            end;
            stop_scroll(0);                  // Para scroll
            // Termina procesos que no se hayan destruido
            signal(Type objeto,s_kill);
            signal(Type primer_plano,s_kill);
            signal(Type primer_plano2,s_kill);
            signal(Type antorcha2,s_kill);
            signal(Type lluvia,s_kill);
            signal(Type plataforma_metal,s_kill);
            signal(Type powerup,s_kill);
            signal(Type redjar,s_kill);
            signal(Type plataforma_madera,s_kill);
            signal(Type agua,s_kill);
            signal(Type rotor,s_kill);
            signal(Type rotor2,s_kill);
            signal(Type fondo,s_kill);
            signal(Type credits,s_kill);
            signal(Type caballo,s_kill);
            signal(Type scrollcrd,s_kill);
            // Borra todos los textos que haya
            delete_text(all_text);
            // Descarga fichero de graficos
            unload_fpg(graficos_fase);
            // Quita la barra de energia del enemigo final
            signal(id_barra_enemigo,s_kill);
        // Repite hasta que no tengas vidas o llegue a la fase quince
        Until (vidas<0 OR nivel==16 OR saliendo)    //Masteries, aadiendo ms niveles
        saliendo=0;
        fade_off();
        while(fading)
            FRAME;
        end;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el protagonista
// Entradas: coordenadas horizontal (x) y vertical (y)
//-----------------------------------------------------------------------------

Process prota(x,y);

Private
    idlanza;                    // Para detectar las trampas-lanza
    disparo=false;        // Variable que determina si el prota esta disparando o no
    agachado=false;        // Variable que determina si el prota esta agachado o no
    creador=true;       // Variable para crear otros procesos segn posicion prota
    incx=0;                 // Variable para comprobar paredes
    ultima_y=0;             // Variable para mirar si sube
    ultima_veloc=0;     // Variable para comprobar paredes
    id2;                    // Identificador de uso general
    contador=0;         // Variable para ralentizar la animacion
    idprota_fantasma;    // Id del prota en la plataforma que a veces perdura causando un duplicado del personaje
                           // Masteries
Begin
    ctype=c_scroll;             // Mete dentro del scroll
    scroll[0].camera=id;           // Hace que le siga la camara
    graph=100;                  // Grafico por defecto
    priority=2;                 // Prioridad maxima

    file=graficos_general;

    Loop

        cadencia=cadencia-1;
                If (cadencia<0)
                        cadencia=0;
                End
                If (cadencia<6)
                        disparo=false;
                        disparo2=false;
                End
        contador=contador+1;
        cinvencible-=1;
                If (cinvencible<0)
                        cinvencible=0;
                End
            If(invencible==true)
                               If(cinvencible%2==1) file=2; else file=graficos_general; end
                        End
            If (cinvencible>0)
                    invencible=true;
            Else
                    invencible=false;
            End

        // Lee el teclado y el joystick
        If ((jkeys_state[_JKEY_RIGHT]) AND velocidad<6 and disparo==false and (!jkeys_state[_JKEY_LEFT]))
            //write(0,100,100,4,"derecha");//debug
            if(!jkeys_state[_JKEY_DOWN]) //Masteries
                    velocidad+=2;               // Sube velocidad a la derecha
            end
            If (disparo2==false)          // Y si no dispara en el aire
                    flags=0;                  // Mira a la derecha
            End
        Else
            If ((jkeys_state[_JKEY_LEFT]) AND velocidad>-6 and disparo==false and (!jkeys_state[_JKEY_RIGHT]))
                //write(0,100,100,4,"izquierda");//debug
                if(!jkeys_state[_JKEY_DOWN]) //Masteries
                    velocidad-=2;       // Sube velocidad a la izquierda
                end
                If (disparo2==false)    // Y si no dispara en el aire
                        flags=1;            // Mira a la izquierda
                End
            Else                            // Si no hay nada pulsado
                If (velocidad>0)            // Frena a la derecha
                    velocidad-=1;
                End
                If (velocidad<0)            // O frena a la izquierda
                    velocidad+=1;
                End
            End
        End

        // Mira si el protagonista choca con las paredes
        ultima_veloc=velocidad;                    // Guarda la velocidad en 'ultima_veloc'
        If (ultima_veloc<>0)                       // Y si se mueve
            incx=ultima_veloc/abs(ultima_veloc);// Halla la direccion
            While (ultima_veloc<>0)                // 'ultima_veloc' sirve de contador
                // Comprueba que no de por debajo
                If (map_get_pixel(graficos_fase,2,(x+incx)/2,(y-64)/2)<>120 and agachado==false and disparo==false)
                    // Ni que de por encima
                    If (map_get_pixel(graficos_fase,2,(x+incx)/2,(y-2)/2)<>120 and agachado==false and disparo==false)
                            // Ni por el centro
                        If (map_get_pixel(graficos_fase,2,(x+incx)/2,(y-32)/2)<>120 and agachado==false and disparo==false)
                                x+=incx;            // Y si no da, mueve al prota
                            End
                    End
                End
                ultima_veloc-=incx;         // Resta 'ultima_veloc' hasta que sea cero
            End
        End

        // Si choca con una plataforma crea un nuevo protagonista
        If (id2=collision(Type plataforma))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<28 AND y<=id2.y+12)
                idprota2=prota_plataforma(x-id2.x,id2,36,4);//!!!!!!!!!
                pregraph=graph;//Masteries
                graph=no_graph;
                while(despertar==0) frame(10); end
                despertar=0;
                graph=pregraph;
                if(exists(type prota_plataforma))
                    idprota_fantasma=get_id(type prota_plataforma);
                    signal(idprota_fantasma,s_kill);
                end
            End
        End

        // Si choca con una plataforma de metal crea un protagonista nuevo
        If (id2=collision(Type plataforma_metal))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<36 AND y<=id2.y+12)
                idprota2=prota_plataforma(x-id2.x,id2,36,-7);//!!!!!!!!
                pregraph=graph;//Masteries
                graph=no_graph;
                while(despertar==0) frame(10); end
                despertar=0;
                graph=pregraph;
                if(exists(type prota_plataforma))
                    idprota_fantasma=get_id(type prota_plataforma);
                    signal(idprota_fantasma,s_kill);
                end
            End
        End

        // Si choca con una plataforma de madera crea un protagonista nuevo
        If (id2=collision(Type plataforma_madera))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<28 AND y<=id2.y+12)
                idprota2=prota_plataforma(x-id2.x,id2,36,-7);//!!!!!!!
                pregraph=graph;//Masteries
                graph=no_graph;
                while(despertar==0) frame(10); end
                despertar=0;
                graph=pregraph;
                if(exists(type prota_plataforma))
                    idprota_fantasma=get_id(type prota_plataforma);
                    signal(idprota_fantasma,s_kill);
                end
            End     //Masteries, aqu va a ser, cuando regrese de prota_plataforma, hay que examinarlo para que no siga existiendo
        End

        // Si choca con una plataforma del nivel final crea un prota nuevo
        If (id2=collision(Type plataforma2))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<44 AND y<=id2.y)
                idprota2=prota_plataforma(x-id2.x,id2,48,-11);//!!!!!!!
                pregraph=graph;//Masteries
                graph=no_graph;
                while(despertar==0) frame(10); end
                despertar=0;
                graph=pregraph;
                if(exists(type prota_plataforma))
                    idprota_fantasma=get_id(type prota_plataforma);
                    signal(idprota_fantasma,s_kill);
                end
            End
        End

        gravedad();                     // Funcion para hallar la gravedad del protagonista
        if(exists(type agua) && y>218)//200
           if(!en_pantalla())
              if(suelo_lago==1)//cada
                 drawwatereffect(5,1);//cdigo del Viaje
              end
              suelo_lago=0;//est en el aire
           end
        end
        pause=0;//en el aire o en plataformas no se puede pausar el juego
        If (en_pantalla())
            pause=1;//Slo se puede pausar el juego con el prota en el suelo                          // Si el protagonista TOCA EL SUELO

            If (velocidad<>0 and disparo==false)        // Y se mueve y no dispara
                If contador MOD 2 == 0 :  // Anima cada 2 frames
                        graph++;
                                if(graph<100 | graph>149)
                                   graph=101;//fix, intentos de arreglar el problema del grafico del demonio rojo
                                end                          // Cambia de grafico para animarlo
                        If (graph>112)
                            graph=101;
                        End
                        contador=0;                     // Pone a 0 el contador de salto de 2 frames
                                End
                        End

            If (disparo2)                 // Si cae disparando
                    velocidad=0;
                    disparo=true;             // Se activan las condiciones "disparo en suelo"
                    disparo2=false;           // Se desactivan las condiciones "disparo en aire"
                    graph=oldgraph+19;          // Y salta al grfico "disparo en suelo" que toque
            End

            If (velocidad==0)             // Si esta parado
                    If (disparo)              // ...y dispara
                        If (agachado==false)    // ...y esta de pie
                                If contador MOD 2 == 0 :
                                if(graph<100 | graph>149)
                                    graph=140;//intento de arreglar el bug del demonio rojo
                            end
                                        If (graph<148)
                                            graph+=1;
                                        End
                                      contador=0;
                                End
                        Else     // ...o esta agachado
                            If contador MOD 2 == 0 :
                            if(graph<100 | graph>149)
                                    graph=130;//intento de arreglar el bug del demonio rojo
                            end
                                        If (graph<138)
                                            graph+=1;
                                        End
                                      contador=0;
                                End
                    End
                Else                           // Si esta parado y no dispara
                        graph=100;
                    End
            End

            If ((jkeys_state[_JKEY_DOWN]) and disparo==false)// Si pulso abajo
                    agachado=true;            // estara agachado
                    velocidad=0;
                            If (disparo==false)   // ...y si no esta disparando
                                graph=120;
                            End
                Else                          // Y si no pulso abajo
                        agachado=false;           // estara de pie
                End

            If ((jkeys_state[_JKEY_A]) and cadencia==0)
                disparo=true;
                velocidad=0;
                cadencia=20;

                      If (tipolatigo==0)
                                play_wav(s_whip,0);
                        Else
                                play_wav(s_latigo2,0);
                        End

                        If (agachado==false)
                                If (flags==0)
                                        latigo(40,-44);
                                        graph=141;
                                Else
                                        latigo(-40,-44);
                                        graph=141;
                                End
                        Else
                                If (flags==0)
                                        latigo(36,-26);
                                        graph=131;
                                Else
                                        latigo(-36,-26);
                                        graph=131;
                                End
                        End
                End

            // Lee la tecla X y ejecuta el salto si se cumplen las condiciones
            If (jkeys_state[_JKEY_B] and disparo==false and agachado==false)
                    contadorsalto+=1;
            Else
                    contadorsalto=0;
            End
            If (contadorsalto>3)
                    contadorsalto=3;
            End

            If (contadorsalto==1)
                play_wav(s_salto,0);         // Si esta pulsado haz sonido
                velocidad_gravedad=-13;        // y salta
            End

            if(exists(type agua) && y>218)                 //pregunta si hay agua, slo en la fase del Dragn
               if(suelo_lago==0)
                  drawwatereffect(5,1);     //cdigo del Viaje
               end
               suelo_lago=1;     //para el efecto de salpicar agua al saltar o al caer
                                          //el agua frena al personaje
                if(!jkeys_state[_JKEY_DOWN])
                  if(jkeys_state[_JKEY_LEFT])
                     velocidad = -1;
                  end
                  if(jkeys_state[_JKEY_RIGHT])
                     velocidad = 1;
                  end
                end
               drawwatereffect(0,1);//cdigo del Viaje
             end
        Else                        // Si el protagonista NO TOCA EL SUELO
            If (disparo2==false)
                    If (ultima_y<y)
                            graph=117; End
                    If (ultima_y==y)
                            graph=116; End
                    If (ultima_y>y)
                            graph=115; End
            Else//est en el aire y disparando
                    If contador MOD 2 == 0 :
                                if(graph<100 | graph>149)//intentos de arreglar lo del demonio rojo
                                   graph=120;//el if de abajo pone el 121
                                end
                        If (graph<128)
                            graph+=1;
                        End
                                 contador=0;
                   End
                oldgraph=graph;
            End
            If ((jkeys_state[_JKEY_A]) and cadencia==0)
                        disparo2=true;
                        cadencia=20;

                        If (tipolatigo==0)
                                play_wav(s_whip,0);
                        Else
                                play_wav(s_latigo2,0);
                        End

                If (flags==0)
                                latigo(40,-44);
                                graph=121;
                        Else
                                latigo(-40,-44);
                                graph=121;
                        End
                End
        End

        If (jkeys_state[_JKEY_Y] and cadencia==0 and super>0) // Si pulsas Z superataque tendrs
                suena_sonido(s_super,512,256);
                cinvencible=30;                      // e invencible sers
                suena_sonido(s_super,512,256);
                If (flags==0)
                        super(x+8,y-32);
                Else
                        super(x-8,y-32);
                End
                cadencia=20;
                super-=1;
        End

        If (ultima_y<y)           // Comprueba si esta bajando
            muerte=true;            // Si baja puede matar
        Else
            muerte=false;           // Si sube o esta quieto le pueden matar
        End

        // Comprueba colision con bichos
        If (id2=collision(Type bicho))
            puntos+=350;
        Else
                // Comprueba colision con bichos de pared
            If (id2=collision(Type bichopared))
                puntos+=825;
            Else
                    // Comprueba colision con garrapatas
                If (id2=collision(Type garrapata))
                        puntos+=150;
                Else
                        // Comprueba colision con topo
                    If (id2=collision(Type topo))
                        puntos+=425;
                    End
                End
            End
        End

        If (id2)                                            // Comprueba si ha habido cualquier tipo de colision
            If (muerte)                                 // Y si esta bajando y puede matar
                velocidad_gravedad=-12;   // Hace botar al protagonista
                explosion(id2.x,id2.y);   // Crea explosion
                salpicon(id2.x,(id2.y-10),100);// Salpica moco
                signal(id2,s_kill_tree);       // Elimina al monstruo que ha originado la colision
                play_wav(s_golpe,0);

            Else  // Si no puede matar, entonces el protagonista es tocado
                    If (invencible==false)
                                    prota_tocado(idprota.x,idprota.y);
                                    despertar=0;
                                                                  pregraph=graph;//Masteries
                                          graph=no_graph;//evitamos que se cree un fantasma del tipo prota_tocado
                                          toques=toques-1;
                                          while(despertar==0) frame(10); end
                                          despertar=0;
                                          graph=pregraph;
                                          if(exists(type prota_tocado))
                                                idprota_fantasma=get_id(type prota_tocado);
                                               signal(idprota_fantasma,s_kill);
                                          end
                                    disparo=false;
                                    disparo2=false;
                End
            End
        End

        // Condiciones al impactar con enemigos
        // Masteries; quizs aqu se puede mirar si existe if(exists(type prota_plataforma))... y eliminar el prota de la plataforma.

        If (invencible==false)             //!!!!!
                If (collision(Type avispa) or collision (Type goblin) or collision (Type demon))
                        prota_tocado(idprota.x,idprota.y);
                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type disparo_cabeza) or collision(Type disparo_demon))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (exists(type agua))
                If (collision(Type bolita))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                End
                If (exists(Type agua))
                If (idlanza=collision(Type dragon))
                If(idlanza.graph==104)//el Dragn slo hace dao cuando se abalanza desde el cielo
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                    End
                End
                End
                If (collision(Type scarab) or collision (Type ojo))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type hacha) or collision(Type lava1) or collision (Type flecha))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type ogro) or collision (Type pez))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type esqueleto))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                        if((idlanza=collision(type lanza)))
                                if(idlanza.graph<>480)//la lanza slo hace dao cuando se mueve
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                    end
                End
                If (collision(Type bigboss))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type loquesea) or collision (Type cuchilla) or collision (Type rotor2))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type parabolico) or collision (Type parabolico2) or collision (Type parabolico3))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision(Type garra) or collision (Type roca) or collision (Type planta))
                        prota_tocado(idprota.x,idprota.y);
                                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
                If (collision (Type bombas) or collision (Type laser) or collision(Type bala))
                        prota_tocado(idprota.x,idprota.y);
                        despertar=0;
                                        pregraph=graph;//Masteries
                                        graph=no_graph;
                                        toques=toques-1;
                                        while(despertar==0) frame(10); end
                                        despertar=0;
                                        graph=pregraph;
                                        if(exists(type prota_tocado))
                                          idprota_fantasma=get_id(type prota_tocado);
                                          signal(idprota_fantasma,s_kill);
                                        end
                        disparo=false;
                            disparo2=false;
                End
        End
        // Si es bola rodante, directamente mata al protagonista
        If (collision(Type bola) or collision (type bolab)) muerte_prota(); End

        // Comprueba si hay colision con los bonos
        If (id2=collision(Type bono))
            play_wav(s_bonos,0);        // Haz sonido
            bonos++;                    // Incrementa numero de bonos
            puntos+=1000;               // Suma puntos
            estrellas(id2.x,id2.y);     // Crea estrella vistosas
            signal(id2,s_kill);         // Elimina los bonos de pantalla
            If (bonos==20)              // Y si tiene mas de 15 bonos
                bonos=0;                  // Resta 15 bonos en la cuenta
                vidas++;                // Y suma una vida
                // Pone un mensaje de vida conseguida
                idtextovida=write_translated(fuente1,160,150,4,"EXTRA LIFE");
                contadortextovida=0;
                contextovida=1;
            End
        End
                // Comprueba si hay colision con los powerup
        If (id2=collision(Type powerup))
            play_wav(s_bonos,0);        // Haz sonido
            If (toques<3)
                    toques+=3;              // Incrementa el numero de toques en 3
            Else
                    toques=5;               // Si tiene ms de 2 que se quede en 5
            End
            puntos+=1000;               // Suma puntos
            estrellas(id2.x,id2.y);     // Crea estrella vistosas
            signal(id2,s_kill);         // Elimina el powerup
            // Pone un mensaje
            If (toques==5)
                    idtextotoke=write_translated(fuente1,160,140,4,"MAX ENERGY");
                    contadortextotoke=0;
                    contextotoke=1;
                End
        End

        If (id2=collision(Type redjar))
            play_wav(s_bonos,0);        // Haz sonido
            If (super<3)
                    super+=1;               // Suma un ataque a la reserva
            Else
                    super=3;                   // Pero que no tenga mas de 3
            End
            puntos+=1000;               // Suma puntos
            estrellas(id2.x,id2.y);     // Crea estrella vistosas
            signal(id2,s_kill);         // Elimina los bonos de pantalla
        End

        // Espera cuatro segundos hasta quitar el mensaje
        If (contextovida==1)
            contadortextovida++;
        End
        If (contextotoke==1)
                contadortextotoke++;
        End
        If (contadortextovida>99 AND contextovida==1)
            delete_text(idtextovida);
            contextovida=2;
        End
        If (contadortextotoke>99 and contextotoke==1)
                delete_text(idtextotoke);
                contextotoke=2;
        End
        // Actualiza las variables internas del scroll cero
        move_scroll(0);

// ****************************************************************************************
// Destruye y crea nuevos procesos a medida que avanza por los niveles
// ****************************************************************************************
        If (nivel==1)
            If (y>400)
                    muerte_prota();
            End
            If (x<160)
                signal(type lanza,s_kill);
                signal(type esqueleto,s_kill);
                signal(type bicho, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type bola1, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type pared,s_kill);
                        creador=true;
                End
            If (x>160 and x<3180 and creador==true)
                bicho(900,176,-1,0);
                bicho(700,176,-2,0);
                bicho(2176,208,-2,0);
                bicho(2368,208,-1,0);
                idpared=pared(graficos_general,86,3168,96,50,1,3128,3200,3127,3200);
                bola1(704,134,24,8);
                bola1(1632,40,24,8);
                plataforma_metal(1370,144,1150,144,1,false);
                plataforma_metal(2840,150,2640,150,1,false);
                antorcha(1808,22,50);
                antorcha(1904,86,50);
                creador=false;
            End
            If (x>3180)
                        signal(type plataforma_metal, s_kill);
                signal(type bicho, s_kill_tree);
                signal(type bola1, s_kill);
                signal(type antorcha, s_kill);
                signal(type pared,s_kill);
                fin_nivel=true;
                creador=true;
            End
        End

        If (nivel==2)
                If (x>128 and x<1024)    // Si no est cerca de la pared genera escarabajos aleatoriamente
                        If (rand(0,900)==0)
                           scarab(91,0,idprota.x-320,idprota.y-32,48,48,1,64);
                    End
                        If (rand(0,900)==1)
                                scarab(91,1,idprota.x+320,idprota.y-32,48,48,0,64);
                        End
                End
                If (x<160 and y>2242)
                        signal(type garrapata, s_kill_tree);
                        signal(type bicho, s_kill_tree);
                        signal(type redjar, s_kill);
                        creador=true;
                End
                If (x>160 and y>1548 and creador==true)
                        garrapata(630,2192,1,40);
                garrapata(42,2160,0,40);
                garrapata(42,1872,0,44);
                garrapata(1238,1808,1,40);
                garrapata(1238,2304,1,40);
                bicho(1056,2369,-1,0);
                bicho(400,2145,-1,0);
                bicho(992,1857,-1,0);
                bicho(384,1729,-1,0);
                bicho(190,1921,-1,0);
                redjar(1120,2320,24,8);
                creador=false;
            End
            If (y>1440 and y<1548)
                signal(type garrapata, s_kill_tree);
                signal(type plataforma_metal, s_kill);
                signal(type plataforma_madera, s_kill);
                signal(type bola1, s_kill);
                signal(type bicho, s_kill_tree);
                signal(type powerup, s_kill);
                signal(type redjar, s_kill);
                creador=true;
            End
            If (y<1440 and y>740 and creador==true)
                plataforma_metal(706,836,706,1112,1,false);
                plataforma_madera(240,1320,240,1270,1);
                plataforma_madera(432,1186,432,1124,1);
                plataforma_madera(976,1160,976,1024,1);
                garrapata(42,1136,0,40);
                garrapata(470,1008,1,44);
                garrapata(470,1296,1,40);
                garrapata(1238,1032,1,40);
                garrapata(1238,1136,1,44);
                bola1(1120,920,24,8);
                bicho(340,1345,-1,0);
                bicho(1080,1313,-1,0);
                powerup(96,1168,24,8);
                creador=false;
            End
            If (y>576 and y<740 and x<326)
                signal(type garrapata, s_kill_tree);
                signal(type plataforma_metal, s_kill);
                signal(type plataforma_madera, s_kill);
                signal(type bola1, s_kill);
                signal(type bicho, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type powerup, s_kill);
                creador=true;
            End
            If (y<678 and x>326 and x<1250 and y>200 and creador==true)
                plataforma_metal(1000,512,1000,352,2,true);
                plataforma_metal(1160,352,1160,664,1,false);
                antorcha(622,456,50);
                antorcha(430,456,50);
                antorcha(238,264,50);
                garrapata(106,240,0,40);
                garrapata(1238,466,1,64);
                garrapata(1238,658,1,44);
                bicho(578,513,-1,0);
                bicho(640,385,-1,0);
                bicho(320,193,-1,0);
                bicho(768,193,-1,0);
                powerup(530,464,24,8);
                creador=false;
            End
            If (x>1250 and y<200)
                signal(type garrapata, s_kill_tree);
                signal(type plataforma_metal, s_kill);
                signal(type plataforma_madera, s_kill);
                signal(type bola1, s_kill);
                signal(type bicho, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type powerup, s_kill);
                creador=true;
                fin_nivel=true;
            End
        End

        If (nivel==3)
            If (x<115 and y<200)
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type bola1, s_kill);
                signal(type garrapata, s_kill_tree);
                signal(type pared, s_kill);
                creador=true;
            End
            If (x>115 and x<1150 and creador==true)
                idpared=pared(graficos_general,86,672,400,50,1,632,712,631,713);
                bicho(470,449,-1,0);
                bicho(900,449,-1,0);
                bicho(332,321,-1,0);
                garrapata(42,272,0,40);
                garrapata(950,80,1,48);
                avispa(81,0,700,120,48,32,100,64);
                bola1(352,80,24,8);
                creador=false;
            End
            If (x>1150 and x<1200) // and y<200)
                signal(type pared, s_kill);
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type bola1, s_kill);
                signal(type garrapata, s_kill_tree);
                signal(type powerup, s_kill);
                creador=true;
            End
            If (x>1200 and x<2650 and creador==true)
                antorcha(2031,390,50);
                antorcha(2223,390,50);
                bicho(2460,449,-1,0);
                bicho(2370,320,-1,0);
                bicho(1734,129,-1,0);
                bicho(2200,161,-1,0);
                garrapata(1846,80,1,40);
                garrapata(2614,290,1,48);
                avispa(81,0,1500,270,48,48,140,50);
                avispa(81,0,1900,270,56,32,110,66);
                avispa(81,0,2329,324,48,24,220,32);
                powerup(1312,400,24,8);
                creador=false;
            End
            If (x>2650 and x<2680)
                signal(type bicho, s_kill_tree);
                signal(type bola1, s_kill);
                signal(type avispa, s_kill_tree);
                signal(type cadena, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type garrapata, s_kill_tree);
                signal(type powerup, s_kill);
                creador=true;
            End
            If (x>2680 and x<4300 and y<290 and creador==true) // Ojo, zona cadenas!
                cadena(3350,32,0,pi/48,pi/4);
                cadena(3633,32,pi,pi/40,pi/4);
                cadena(3960,32,0,pi/48,pi/4);
                avispa(81,1,3600,130,32,48,100,50);
                bola1(3072,146,24,8);
                creador=false;
            End
            If (x>2680 and x<4300 and y>290 and y<320)
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type cadena, s_kill_tree);
                signal(type garrapata, s_kill_tree);
                signal(type bola1, s_kill);
                creador=true;
            End
            If (x>2680 and x<4300 and y>320 and creador==true) // Ojo, zona cadenas!
                bicho(3470,448,-1,0);
                bicho(4040,448,-1,0);
                bicho(2950,448,-1,0);
                bicho(4200,448,-1,0);
                creador=false;
            End
            If (x>4300 and x<4350 and y<100)
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type cadena, s_kill_tree);
                signal(type garrapata, s_kill_tree);
                signal(type bola1, s_kill);
                creador=true;
            End
            If (x>4350 and x<5450 and creador==true)
                bicho(5000,448,-1,0);
                bicho(5160,448,-1,0);
                bicho(4608,129,-1,0);
                bicho(4736,97,-1,0);
                bicho(5150,161,-1,0);
                avispa(81,0,5000,140,110,64,100,64);
                creador=false;
            End
            If (x>5450 and x<5500)
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type garrapata, s_kill_tree);
                signal(type powerup, s_kill);
                creador=true;
            End
            If (x>5500 and x<6400 and creador==true)
                bicho(5800,128,-1,0);
                bicho(6000,417,-1,0);
                avispa(91,0,6000,270,90,48,200,50);
                avispa(81,0,6400,100,56,64,100,64);
                avispa(81,0,6000,270,48,48,160,50);
                garrapata(6358,176,1,48);
                powerup(6048,336,24,8);
                creador=false;
            End
            If (x>6350 and y>320)
                signal(type bicho, s_kill_tree);
                signal(type avispa, s_kill_tree);
                signal(type garrapata, s_kill_tree);
                signal(type powerup, s_kill);
                creador=true;
                fin_nivel=true;
            End
        End

        If (nivel==4)
                If (x>128 and x<352)    // Si no est cerca de la pared genera escarabajos aleatoriamente
                        If (rand(0,900)==0)
                           scarab(91,0,idprota.x-320,idprota.y-32,48,48,1,64);
                    End
                        If (rand(0,900)==1)
                                scarab(91,1,idprota.x+320,idprota.y-32,48,48,0,64);
                        End
                End
                If (x<224 and y>4736)
                        signal(type bicho, s_kill_tree);
                        signal(type bichopared, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type plataforma_metal, s_kill);
                        creador=true;
                End
                If (x>224 and y>4130 and creador==true)
                        bichopared(298,4400,0);
                        garrapata(42,4593,0,46);
                        garrapata(215,4433,1,40);
                        bicho(200,4255,-1,0);
                plataforma_metal(386,4300,386,4600,1,false);
                bola1(178,4372,24,8);
                creador=false;
            End
            If (y<4130 and y>4096)
                        signal(type bichopared, s_kill_tree);
                        signal(type bicho, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type plataforma_metal, s_kill);
                        signal(type plataforma_madera, s_kill);
                        signal(type powerup, s_kill);
                        creador=true;
                End
            If (y<4096 and y>3392 and creador==true)
                bicho(324,4001,-1,0);
                bicho(360,3647,-1,0);
                bichopared(42,3472,0);
                bichopared(42,3760,0);
                garrapata(42,3984,0,40);
                garrapata(438,3793,1,46);
                plataforma_madera(208,3818,208,3698,2);
                plataforma_metal(96,3464,96,3764,1,true);
                creador=false;
            End
            If (y<3392 and y>3366)
                        signal(type bicho, s_kill_tree);
                        signal(type bichopared, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type plataforma_madera, s_kill);
                        signal(type plataforma_metal, s_kill);
                        signal(type bola1, s_kill);
                        signal(type avispa, s_kill_tree);
                        signal(type powerup, s_kill);
                        creador=true;
                End
            If (y<3366 and y>2090 and creador==true)
                bola1(64,3200,24,8);
                bola1(224,2238,24,8);
                bicho(324,2785,-1,0);
                garrapata(42,3088,0,40);
                garrapata(42,2704,0,44);
                garrapata(42,2512,0,48);
                garrapata(42,2256,0,44);
                bichopared(438,2512,1);
                bichopared(330,2256,0);
                plataforma_madera(272,3306,272,3098,1);
                plataforma_madera(304,2938,304,3018,2);
                plataforma_madera(400,2316,400,2236,2);
                plataforma_metal(178,2452,178,2896,1,false);
                plataforma_metal(388,2624,96,2624,1,true);
                plataforma_metal(388,2452,388,2580,1,false);
                powerup(128,3184,24,8);
                creador=false;
            End
            If (y<2090 and y>2000)
                        signal(type bicho, s_kill_tree);
                        signal(type bichopared, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type plataforma_madera, s_kill);
                        signal(type plataforma_metal, s_kill);
                        signal(type bola1, s_kill);
                        signal(type powerup, s_kill);
                        signal(type avispa, s_kill_tree);
                        creador=true;
                End
                If (y<2000 and y>864 and creador==true)
                bola1(160,1270,24,8);
                bicho(96,1889,-1,0);
                bicho(256,1889,-1,0);
                bicho(192,1601,-1,0);
                bicho(160,993,-1,0);
                avispa(81,0,260,1440,110,64,100,64);
                avispa(81,0,320,1104,110,64,100,64);
                garrapata(438,1832,1,48);
                garrapata(42,1104,0,44);
                bichopared(438,1392,1);
                bichopared(438,1266,1);
                bichopared(438,978,1);
                plataforma_madera(367,1360,367,1518,1);
                plataforma_metal(352,1008,238,1128,2,false);
                plataforma_metal(320,1632,320,1840,1,true);
                creador=false;
            End
            If (y<864 and y>848 and x<160)
                        signal(type bicho, s_kill_tree);
                        signal(type bichopared, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type plataforma_metal, s_kill);
                        signal(type plataforma_madera, s_kill);
                        signal(type cadena, s_kill_tree);
                        signal(type avispa, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type pared, s_kill_tree);
                        signal(type powerup, s_kill);
                        creador=true;
                End
                If (y<848 and y>32 and creador==true)
                bichopared(42,624,0);
                idpared=pared(graficos_general,86,320,752,50,1,280,360,279,361);
                bicho(280,513,-1,0);
                plataforma_madera(175,80,175,144,1);
                plataforma_madera(335,240,335,400,1);
                garrapata(278,624,1,48);
                garrapata(42,306,0,44);
                garrapata(42,454,0,44);
                cadena(216,256,pi,pi/40,pi/4);
                powerup(340,134,24,8);
                creador=false;
            End
                If (y<32)
                    signal(type pared, s_kill_tree);
                    signal(type bicho, s_kill_tree);
                    signal(type bichopared, s_kill_tree);
                    signal(type plataforma_madera, s_kill);
                    signal(type garrapata, s_kill_tree);
                    signal(type cadena, s_kill_tree);
                    signal(type avispa, s_kill_tree);
                    signal(type powerup, s_kill);
                    fin_nivel=true;
                    creador=true;
                End
        End

        If (nivel==6)
            If (x<96)
                signal(type bicho, s_kill_tree);
                signal(type cadena, s_kill_tree);
                signal(type garra, s_kill);
                signal(type roca, s_kill_tree);
                signal(type goblin, s_kill_tree);
                signal(type ogro, s_kill_tree);
                creador=true;
            End
            If (x>96 and x<1640 and creador==true)
                goblin(1400,90,96,128,60,40);
                bicho(550,382,-1,0);
                bicho(700,382,-1,0);
                bicho(1300,290,-2,0);
                bicho(1380,382,-1,0);
                roca(460,382,410,510,409,511);
                roca(1480,382,1430,1530,1429,1531);
                cadena(980,96,pi,pi/40,pi/4);
                garra(476,40,0,270000);
                ogro(1170,96,-2,0);
                ogro(1280,382,-2,0);
                creador=false;
            End
            If (x>1640 and x<1720)
                signal(type bicho, s_kill_tree);
                signal(type cadena, s_kill_tree);
                signal(type garra, s_kill);
                signal(type roca, s_kill_tree);
                signal(type goblin, s_kill_tree);
                signal(type ogro, s_kill_tree);
                signal(type powerup, s_kill);
                creador=true;
            End
            If (x>1720 and x<3070 and creador==true)
                bicho(2500,224,-1,0);
                bicho(2332,416,-1,0);
                bicho(2552,416,-1,0);
                garra(1998,136,0,90000);
                garra(2096,136,0,270000);
                garra(2160,392,0,270000);
                garra(2364,40,1,270000);
                ogro(2820,256,-2,0);
                powerup(2450,48,24,8);
                creador=false;
            End
            If (x>3070 and x<3150)
                signal(type bicho, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type garra, s_kill);
                signal(type ogro, s_kill_tree);
                signal(type goblin, s_kill_tree);
                signal(type roca, s_kill_tree);
                signal(type powerup, s_kill);
                signal(type redjar, s_kill);
                creador=true;
            End
            If (x>3150 and x<5220 and creador==true)
                antorcha(3568,243,50);
                antorcha(3984,371,50);
                antorcha(4144,371,50);
                antorcha(4624,371,50);
                antorcha(5008,371,50);
                bicho(3500,128,-1,0);
                bicho(3600,128,-2,0);
                bicho(3500,320,-1,0);
                ogro(3380,224,-2,0);
                ogro(3600,416,-2,0);
                roca(4068,446,4018,4118,4017,4119);
                roca(4850,446,4800,4900,4799,4901);
                garra(3716,72,0,90000);
                garra(4476,200,1,270000);
                goblin(4000,280,96,128,60,40);
                goblin(4800,90,96,128,60,40);
                goblin(5020,280,96,128,60,40);
                redjar(3628,80,24,8);
                creador=false;
            End
            If (x>5220 and x<5300)
                signal(type roca, s_kill_tree);
                signal(type bicho, s_kill_tree);
                signal(type antorcha, s_kill);
                signal(type cadena, s_kill_tree);
                signal(type garra, s_kill);
                signal(type ogro, s_kill_tree);
                signal(type goblin, s_kill_tree);
                signal(type plataforma_metal, s_kill);
                signal(type powerup, s_kill);
                signal(type redjar, s_kill);
                creador=true;
            End
            If (x>5300 and x<7180 and creador==true)
                bicho(6000,66,-1,0);
                bicho(6100,224,-1,0);
                bicho(6320,320,-1,0);
                bicho(6420,320,-2,0);
                bicho(6700,320,-1,0);
                bicho(6750,320,-2,0);
                plataforma_metal(5762,160,5762,320,1,true);
                roca(6600,318,5750,5850,5749,5851);
                roca(6950,318,6100,6200,6099,6201);
                ogro(6500,96,-2,0);
                ogro(6650,192,-2,0);
                garra(5584,392,1,90000);
                garra(6854,136,0,90000);
                antorcha(6032,147,50);
                antorcha(6224,147,50);
                antorcha(6512,243,50);
                antorcha(6800,115,50);
                cadena(6174,256,pi,pi/40,pi/4);
                powerup(5880,48,24,8);
                creador=false;
            End
            If (x>7180)
                    signal(type roca, s_kill_tree);
                    signal(type bicho, s_kill_tree);
                    signal(type antorcha, s_kill);
                    signal(type cadena, s_kill_tree);
                    signal(type garra, s_kill);
                    signal(type ogro, s_kill_tree);
                    signal(type goblin, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type powerup, s_kill);
                        creador=true;
                        fin_nivel=true;
            End
            If (y>640)
                    muerte_prota();
            End
        End

        If (nivel==7)
            If (x<180)
                    signal(type planta, s_kill_tree);
                    signal(type antorcha, s_kill);
                    signal(type bola1, s_kill);
                    signal(type plataforma_madera, s_kill);
                    signal(type bicho, s_kill);
                    signal(type goblin, s_kill_tree);
                    signal(type avispa, s_kill);
                    signal(type ogro, s_kill_tree);
                    signal(type primer_plano, s_kill);
                    creador=true;
            End
            If (x>180 and x<2180 and creador==true)
                planta(800,416,80,760,840,759,841);
                antorcha(1039,211,50);
                antorcha(1327,243,50);
                antorcha(1743,51,50);
                bola1(450,180,24,8);
                bola1(1360,60,24,8);
                plataforma_madera(1636,250,1636,140,2);
                bicho(600,384,-1,0);
                bicho(550,384,-2,0);
                bicho(1800,128,-2,0);
                bicho(1300,96,-1,0);
                bicho(1500,96,-2,0);
                goblin(900,120,96,128,60,40);
                ogro(1700,288,-2,0);
                ogro(2000,288,-2,0);
                avispa(81,0,1200,260,55,56,50,48);
                primer_plano(7,1440,440,4);
                creador=false;
            End
            If (x>2180 and x<2260)
                    signal(type planta, s_kill_tree);
                    signal(type antorcha, s_kill);
                    signal(type bola1, s_kill);
                    signal(type plataforma_madera, s_kill);
                    signal(type bicho, s_kill);
                    signal(type goblin, s_kill_tree);
                    signal(type avispa, s_kill);
                    signal(type ogro, s_kill_tree);
                signal(type primer_plano, s_kill);
                signal(type bichopared, s_kill);
                signal(type garrapata, s_kill_tree);
                creador=true;
            End
            If (x>2260 and x<3820 and creador==true)
                    planta(2500,288,80,2460,2540,2459,2541);
                    antorcha(2511,83,50);
                    antorcha(2991,275,50);
                    bola1(3186,90,24,8);
                    primer_plano(7,2880,440,4);
                    bicho(2940,352,-2,0);
                    bicho(2900,192,-2,0);
                    bichopared(3010,136,1);
                    garrapata(3202,256,1,30);
                    garrapata(3068,80,0,40);
                    garrapata(3324,368,0,32);
                    avispa(81,0,2660,120,80,24,144,32);
                    avispa(81,0,2640,128,55,48,60,48);
                    creador=false;
            End
            If (x>3820 and x<3900)
                    signal(type planta, s_kill_tree);
                    signal(type antorcha, s_kill);
                    signal(type bola1, s_kill);
                    signal(type primer_plano, s_kill);
                    signal(type bicho, s_kill);
                    signal(type bichopared, s_kill);
                    signal(type garrapata, s_kill_tree);
                    signal(type avispa, s_kill);
                    signal(type garra, s_kill);
                    signal(type ogro, s_kill_tree);
                    creador=true;
            End
            If (x>3900 and x<5340 and creador==true)
                    planta(4400,256,80,4360,4440,4359,4441);
                    planta(4670,352,80,4630,4710,4629,4711);
                    antorcha(4591,275,50);
                    primer_plano(7,4320,440,4);
                    bicho(4500,352,-2,0);
                    bicho(4880,96,-2,0);
                    bicho(4980,96,-1,0);
                    ogro(5080,96,-2,0);
                    garrapata(5292,48,1,70);
                    garrapata(4928,176,0,30);
                    garrapata(4994,304,0,40);
                    garra(5296,176,1,90000);
                    creador=false;
            End
            If (x>5340 and x<5420)
                    signal(type planta, s_kill_tree);
                    signal(type antorcha, s_kill);
                    signal(type bola1, s_kill);
                    signal(type cadena, s_kill_tree);
                    signal(type primer_plano, s_kill);
                    signal(type bicho, s_kill);
                    signal(type bichopared, s_kill);

                    signal(type garrapata, s_kill_tree);
                    signal(type garra, s_kill);
                    signal(type ogro, s_kill_tree);
                    signal(type goblin, s_kill_tree);
                    signal(type avispa, s_kill_tree);
                    creador=true;
            End
            If (x>5420 and x<7160 and creador==true)
                    planta(6320,384,80,6280,6360,6279,6361);
                    antorcha(6095,211,50);
                    antorcha(6415,307,50);
                    antorcha(7055,371,50);
                goblin(5920,130,96,128,60,40);
                    ogro(7000,448,-2,0);
                    ogro(6800,448,-2,0);
                    bicho(6900,448,-1,0);
                    bicho(6250,384,-2,0);
                    avispa(81,0,6100,240,80,24,144,32);
                    avispa(81,0,6000,250,55,48,60,48);
                avispa(81,0,5720,310,80,24,144,56);
                bola1(5568,122,24,8);
                bola1(6180,60,24,8);
                    cadena(6880,32,pi,pi/40,pi/4);
                primer_plano(7,5760,440,4);
                creador=false;
            End
            If (x>7160)
                    signal(type planta, s_kill_tree);
                    signal(type antorcha, s_kill);
                        signal(type bola1, s_kill);
                        signal(type cadena, s_kill_tree);
                        signal(type primer_plano, s_kill);
                        signal(type ogro, s_kill_tree);
                        signal(type goblin, s_kill_tree);
                        signal(type avispa, s_kill_tree);
                        signal(type bicho, s_kill);
                        creador=true;
                        fin_nivel=true;
            End
            If (y>640)
                    muerte_prota();
            End
        End

        If (nivel==8)
                If (x>128 and x<1024)    // Si no est cerca de la pared genera escarabajos aleatoriamente
                        If (rand(0,900)==0)
                           scarab(91,0,idprota.x-320,idprota.y-32,48,48,1,64);
                    End
                        If (rand(0,900)==1)
                                scarab(91,1,idprota.x+320,idprota.y-32,48,48,0,64);
                        End
                End
                If (y<160 and x<200)
                        signal(type garrapata, s_kill_tree);
                        signal(type bicho, s_kill_tree);
                        signal(type avispa, s_kill);
                        signal(type planta, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type bichopared, s_kill);
                        signal(type redjar, s_kill);
                        creador=true;
                End
                If (x>200 and y<460 and creador==true)
                        planta(700,160,100,660,740,659,741);
                         planta(400,448,120,360,440,359,441);
                        garrapata(898,176,1,40);
                garrapata(898,272,1,70);
                garrapata(964,208,0,60);
                bola1(430,90,24,8);
                bicho(800,384,-2,0);
                bicho(700,384,-1,0);
                bicho(1150,192,-2,0);
                bichopared(1140,250,1);
                avispa(81,0,600,312,100,120,100,40);
                redjar(1220,98,22,8);
                creador=false;
            End
            If (y>460 and y<510)
                        signal(type garrapata, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type bicho, s_kill_tree);
                        signal(type planta, s_kill_tree);
                        signal(type bichopared, s_kill);
                        signal(type ogro, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        signal(type lanza, s_kill);
                        signal(type avispa, s_kill);
                        signal(type powerup, s_kill);
                        signal(type redjar, s_kill);
                        creador=true;
                End
            If (y>510 and y<1130 and creador==true)
                bicho(450,576,-2,0);
                bicho(940,704,-1,0);
                bicho(1100,704,-2,0);
                bichopared(700,686,0);
                bichopared(1195,776,1);
                bichopared(648,814,1);
                bichopared(440,730,0);
                ogro(900,896,-2,0);
                garrapata(698,752,0,50);
                garrapata(1252,930,1,70);
                garrapata(1252,656,1,70);
                cuchilla(288,1119,1,30);
                cuchilla(512,1119,0,0);
                lanza(160,1025,techo);
                lanza(640,1025,techo);
                    avispa(81,0,148,752,80,24,100,32);
                    avispa(81,0,770,660,55,48,60,48);
                avispa(81,0,1000,780,80,24,144,56);
                powerup(560,733,22,8);
                redjar(128,1090,22,8);
                creador=false;
            End
            If (y>1130 and y<1180)
                    signal(type cuchilla, s_kill_tree);
                    signal(type garrapata, s_kill_tree);
                    signal(type bichopared, s_kill);
                    signal(type ogro, s_kill_tree);
                    signal(type bicho, s_kill);
                    signal(type lanza, s_kill);
                        signal(type avispa, s_kill);
                    signal(type powerup, s_kill);
                        signal(type redjar, s_kill);
                        signal(type planta, s_kill_tree);
                    creador=true;
            End
            If (y>1180 and y<1760 and creador==true);
                cuchilla(383,1343,1,30);
                cuchilla(671,1343,1,0);
                lanza(256,1343,floor);
                lanza(288,1185,techo);
                ogro(200,1600,-2,0);
                bichopared(1195,1480,1);
                garrapata(892,1552,0,70);
                bichopared(1252,1252,1);
                planta(994,1440,80,954,1034,953,1035);
                powerup(528,1538,22,8);
                powerup(994,1570,22,8);
                creador=false;
            End
            If (y>1760 and y<1810)
                        signal(type garrapata, s_kill_tree);
                        signal(type planta, s_kill_tree);
                        signal(type bichopared, s_kill);
                        signal(type bola1, s_kill);
                        signal(type bicho, s_kill_tree);
                        signal(type powerup, s_kill);
                        signal(type redjar, s_kill);
                        signal(type cuchilla, s_kill_tree);
                        signal(type ojo, s_kill_tree);
                        signal(type lanza, s_kill);
                        signal(type bicho, s_kill);
                        signal(type ogro, s_kill_tree);
                        creador=true;
                End
            If (y>1810 and creador==true)
                redjar(460,1890,22,8);
                bicho(100,1984,-2,0);
                bicho(900,2016,-2,0);


                ojo(256,2200,0,340);
                ojo(512,2200,1,340);
                ojo(768,2200,0,340);
                ojo(1024,2200,1,340);
                creador=false;
            End
            If (y>1810)
                If(!exists(type ojo) and !exists(type bola1))
                        explosion3(600,2320,100);
                              explosion3(580,2330,100);
                              explosion3(610,2310,100);
                        estrellas(600,2320);
                        bola1(600,2320,24,8);
                End
            End
            If (x>940 and y<50)
                        signal(type garrapata, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type bicho, s_kill_tree);
                        signal(type antorcha, s_kill);
                        creador=true;

                        fin_nivel=true;
                End
        End

                If (nivel==9)
                If (x<120 and y<256)
                        signal(type ogro, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type bola1, s_kill);
                        signal(type bicho, s_kill);
                        signal(type garrapata, s_kill_tree);
                        signal(type planta, s_kill_tree);
                        creador=true;
                End
                If (x>120 and x<1520 and creador==true)
                antorcha(624,339,50);
                ogro(600,160,-2,0);
                planta(250,448,100,210,290,209,291);
                ogro(1200,416,-2,0);
                bola1(138,400,24,8);
                bicho(800,64,-1,0);
                bicho(900,64,-2,0);
                bicho(1240,322,-1,0);
                garrapata(806,144,1,60);
                  garrapata(1504,368,1,50);
                creador=false;
                End
                If (x>1520 and x<1600)
                        signal(type ogro, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type bola1, s_kill);
                        signal(type pared, s_kill_tree);
                        signal(type bicho, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type cuchilla, s_kill_tree);
                        signal(type goblin, s_kill_tree);
                        signal(type lanza, s_kill_tree);
                        signal(type planta, s_kill_tree);
                        creador=true;
                End
                If (x>1600 and x<3300 and creador==true)
                        antorcha(2384,339,50);
                antorcha(2736,339,50);
                cuchilla(2463,191,0,0);
                cuchilla(2655,191,1,0);
                cuchilla(2559,96,2,30);
                lanza(2112,320,techo);
                lanza(2208,320,techo);
                ogro(3000,226,-2,0);
                ogro(2000,416,-2,0);
                ogro(3000,416,-2,0);
                bola1(2116,206,24,8);
                goblin(1880,260,100,120,64,40);
                idpared=pared(graficos_general,86,2560,16,50,1,2520,2600,2519,2601);
                creador=false;
                End
                If (x>3300 and x<3380)
                        signal(type ogro, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type cadena, s_kill_tree);
                        signal(type bola1, s_kill);
                        signal(type pared, s_kill_tree);
                        signal(type cuchilla, s_kill_tree);
                        signal(type garrapata, s_kill_tree);
                        signal(type goblin, s_kill_tree);
                        signal(type lanza, s_kill_tree);
                        signal(type avispa, s_kill);
                        creador=true;
                End
                If (x>3380 and x<5400 and creador==true)
                cadena(3870,158,0,pi/48,pi/4);
                cadena(4170,158,pi,pi/40,pi/4);
                cadena(4470,158,0,pi/48,pi/4);
                cadena(4770,158,pi,pi/40,pi/4);
                avispa(81,0,4895,60,48,48,140,50);
                avispa(81,0,4385,60,48,48,140,50);
                avispa(81,0,3871,60,48,48,140,50);
                ogro(4100,128,-2,0);
                ogro(5000,128,-2,0);
                roca(5150,354 ,5110,5190,5109,5191);
                creador=false;
                End
                If (x>5400 and x<5450)
                        signal(type ogro, s_kill);
                        signal(type cadena, s_kill_tree);
                        signal(type esqueleto,s_kill);
                        signal(type planta, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        signal(type lanza, s_kill);
                        signal(type bicho, s_kill);
                        signal(type garrapata, s_kill_tree);
                        signal(type roca, s_kill_tree);
                        signal(type avispa, s_kill);
                        creador=true;
                End
                If (x>5450 and x<7200 and creador==true)
                ogro(6200,256,-2,0);
                  esqueleto(6700,258,-3,0);
                  esqueleto(7000,416,-3,0);
                  roca(6840,126,6800,6880,6799,6881);
                  planta(6500,128,100,6460,6540,6599,6541);
                  cuchilla(5679,159,0,0);
                  lanza(5584,224,techo);
                  lanza(5776,224,techo);
                  lanza(5678,224,techo);
                  bicho(6250,64,-2,0);
                  bicho(6380,64,-1,0);
                  bicho(6400,128,-2,0);
                  bicho(6760,128,-1,0);
                  bicho(6100,256,-2,0);
                  bicho(6200,448,-2,0);
                  garrapata(7108,144,1,50);
                  creador=false;
                End
            If (x>7200)
                        signal(type ogro, s_kill);
                        signal(type esqueleto,s_kill);
                        signal(type planta, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        signal(type lanza, s_kill);
                        signal(type bicho, s_kill);
                        signal(type garrapata, s_kill_tree);
                        signal(type roca, s_kill_tree);
                        creador=true;
                End
            If (x>7140)
                        fin_nivel=true;
                End
            // Si estas en la fase nueve y te caes al fondo
                If (y>544)
                        muerte_prota();
                End
        End

        If (nivel==10)
            If (x<160)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type lava, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type cadena, s_kill_tree);
                        creador=true;
                End
                If (x>160 and x<2375 and creador==true)
                        esqueleto(640,320,-3,0);
                        esqueleto(1120,320,-3,0);
                        lanza(320,256,floor);
                        lanza(352,256,floor);
                        lanza(384,256,floor);
                        plataforma_metal(1200,256,1528,256,1,true);
                    plataforma_metal(1920,256,1592,256,1,true);
                    plataforma_metal(2128,320,2128,160,1,true);
                                cadena(1800,0,0,pi/48,pi/4);
                        antorcha(576,178,50);
                        antorcha(960,178,50);
                        antorcha(1344,178,50);
                        lava(1328,60);
                        lava(1840,50);
                        lava(2064,40);
                        lava(2194,35);
                        creador=false;
                End
                If (x>2375 and x<2425)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type cuchilla, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type lava, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type cadena, s_kill_tree);
                        signal(type pared, s_kill_tree);
                        creador=true;
                End
                If (x>2425 and x<4940 and creador==true)
                        antorcha(2752,242,50);
                        antorcha(3744,178,50);
                        esqueleto(2900,128,-3,0);
                        esqueleto(3500,320,-3,0);
                        demon(2640,90,100,80,4,64);
                        demon(3500,160,100,80,4,120);
                        plataforma_metal(2920,320,2750,320,1,true);
                        plataforma_metal(3150,180,3300,180,1,true);
                        idpared=pared(graficos_general,86,3000,80,50,1,2960,3040,2959,3041);
                        lanza(3072,33,techo);
                        cuchilla(3168,256,0,15);
                        cuchilla(3296,256,1,0);
                        lava(2962,60);
                        lava(3854,50);
                        lava(3894,60);
                        lava(4044,45);
                        lava(4086,40);
                        lava(4288,50);
                        lava(4432,40);
                        lava(4652,35);
                        lava(4694,45);
                        creador=false;
                End
                If (x>4940 and x<4990)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type cuchilla, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type lava, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type bola1, s_kill);
                        signal(type pared, s_kill_tree);
                        creador=true;
                End
                If (x>4990 and x<7600 and creador==true)
                        antorcha(5504,82,50);
                        antorcha(7104,242,50);
                        antorcha(7360,242,50);
                        esqueleto(7100,320,-3,0);
                        esqueleto(7350,320,-3,0);
                        demon(5760,120,100,80,4,60);
                        demon(5824,130,100,70,4,90);
                        demon(5888,140,100,60,4,110);
                        lanza(5568,32,techo);
                        lanza(5600,32,techo);
                        cuchilla(5200,160,0,15);
                        cuchilla(5300,160,0,20);
                        cuchilla(5400,160,0,25);
                    plataforma_metal(5948,224,5948,96,1,true);
                    plataforma_metal(6920,140,6920,270,1,false);
                bola1(7525,280,24,8);
                bola1(7100,88,24,8);
                        idpared=pared(graficos_general,86,7200,80,50,1,7160,7240,7159,7241);
                        idpared=pared(graficos_general,86,7400,80,50,1,7360,7440,7359,7361);
                        lava(6252,50);
                        lava(6294,45);
                        lava(6512,40);
                        lava(6672,35);
                        lava(6832,30);
                        creador=false;
                End
                If (x>7600 and x<7650)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type cuchilla, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type lava, s_kill);
                        signal(type bola, s_kill);
                        signal(type pared, s_kill_tree);
                        signal(type demon, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        signal(type bola1, s_kill);
                        creador=true;
                End
                If (x>7650 and x<9590 and creador==true)
                        bola(7700,-100);
                        idpared=pared(graficos_general,86,8288,208,50,1,8248,8328,8247,8329);
                        idpared=pared(graficos_general,86,8672,208,50,1,8632,8712,8631,8713);
                        idpared=pared(graficos_general,86,9056,208,50,1,9016,9096,9015,9097);
                        idpared=pared(graficos_general,86,9440,208,50,1,9400,9480,9399,9481);
                        creador=false;
                End
                If (x>9590)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type lava, s_kill);
                        signal(type bola, s_kill);
                        signal(type pared, s_kill_tree);
                        signal(type plataforma_metal, s_kill);
                        creador=true;
                        fin_nivel=true;
                End
                If (y>384 and y<440 and x<6920)
                        salplava(320);
                        graph=0;
                End
            If (y>480)
                    muerte_prota();
            End
        End

        If (nivel==11)
            If (x<160)
                signal(type esqueleto, s_kill);
                        signal(type bicho, s_kill);
                        signal(type lanza, s_kill);
                        signal(type antorcha, s_kill);
                        signal(type bola1, s_kill);
                        signal(type ogro, s_kill);
                        signal(type toposale, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        creador=true;
                End
                If (x>160 and x<2600 and creador==true)
                        antorcha(416,338,50);
                        antorcha(1312,274,50);
                        antorcha(1504,274,50);
                        antorcha(1696,274,50);
                        antorcha(2144,210,50);
                        bola1(2080,56,24,8);
                        bicho(400,224,-2,0);
                        bicho(540,96,-1,0);
                        bicho(680,96,-2,0);
                        ogro(1000,256,-2,0);
                        esqueleto(1600,192,-3,0);
                        lanza(608,128,techo);
                        lanza(672,128,techo);
                        lanza(384,112,der);
                        lanza(1856,0,techo);
                        lanza(1920,0,techo);
                        toposale(880,1360,401,90);
                        cuchilla(1536,352,0,20);
                        cuchilla(1728,352,0,25);
                        creador=false;
                End
                If (x>2600 and x<2700)
                signal(type bicho, s_kill);
                signal(type antorcha, s_kill);
                signal(type bola1, s_kill);
                signal(type esqueleto, s_kill);
                        signal(type lanza, s_kill);
                        signal(type ogro, s_kill);
                        signal(type pared, s_kill);
                        signal(type toposale, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        signal(type redjar, s_kill);
                        signal(type powerup, s_kill);
                        creador=true;
                End
                If (x>2700 and x<5670 and creador==true)
                        antorcha(3712,82,50);
                        antorcha(3904,82,50);
                        antorcha(5248,274,50);
                        antorcha(5376,274,50);
                        antorcha(5504,274,50);
                        bola1(3260,312,24,8);
                        bola1(3590,408,24,8);
                        bicho(3300,352,-2,0);
                        bicho(3900,320,-2,0);
                        ogro(5000,288,-2,0);
                        esqueleto(3800,160,-3,0);
                                esqueleto(4500,448,-3,0);
                        esqueleto(5000,448,-3,0);
                        esqueleto(5400,352,-3,0);
                        lanza(3648,336,der);
                        lanza(4128,192,izq);
                        lanza(5280,160,floor);
                        lanza(5312,160,floor);
                        lanza(5664,160,der);
                        toposale(2930,3100,401,120);
                        toposale(3590,4140,433,125);
                        toposale(3590,4140,433,90);
                        toposale(4530,4690,369,130);
                        idpared=pared(graficos_general,86,4256,400,50,1,4216,4296,4215,4297);
                        powerup(3200,322,24,8);
                        powerup(5160,130,24,8);
                        redjar(5220,130,24,8);
                        cuchilla(4004,225,2,15);
                        cuchilla(3908,225,2,20);
                        cuchilla(3812,225,2,25);
                        creador=false;
                End
                If (x>5670 and x<5720)
                signal(type bicho, s_kill);
                signal(type antorcha, s_kill);
                signal(type bola1, s_kill);
                signal(type esqueleto, s_kill);
                        signal(type lanza, s_kill);
                        signal(type ogro, s_kill);
                        signal(type pared, s_kill);
                        signal(type toposale, s_kill_tree);
                        signal(type cuchilla, s_kill);
                        signal(type redjar, s_kill);
                        signal(type powerup, s_kill);
                        signal(type ojo, s_kill);
                        creador=true;
                End
                If (x>5720 and x<6400 and creador==true)
                ojo(5952,280,0,340);
                ojo(6144,280,1,340);
                        creador=false;
                End
                If (x>5730 and x<6400 and !exists(type ojo))
                        Frame(1200);
                        fin_nivel=true;
                End
            If (y>640)
                    muerte_prota();
            End
        End

        If (nivel==12)
            If (x<160)
                signal(type esqueleto,s_kill);
                        signal(type saltopez, s_kill);
                        signal(type toposale, s_kill_tree);
                        signal(type roca, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type burbujas, s_kill);
                        creador=true;
                End
                If (x>160 and x<2500 and creador==true)
                        esqueleto(1000,208,-3,0);
                        esqueleto(1700,208,-3,0);
                        saltopez(480,510,90);
                        roca(1270,202,1220,1320,1219,1321);
                        toposale(1300,2200,193,120);
                        toposale(1300,2200,193,90);
                        demon(2340,160,100,60,4,60);
                        burbujas(2336,224,-256);
                        creador=false;
                End
                If (x>2500 and x<2550)
                signal(type esqueleto,s_kill);
                        signal(type rotor, s_kill);
                        signal(type rotor2, s_kill);
                        signal(type saltopez, s_kill);
                        signal(type toposale, s_kill_tree);
                        signal(type lanza, s_kill);
                        signal(type pared, s_kill);
                        signal(type roca, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type redjar, s_kill);
                        signal(type burbujas, s_kill);
                        creador=true;
                End
                If (x>2550 and x<5450 and creador==true)
                        redjar(3550,77,24,8);
                        esqueleto(3800,208,-3,0);
                        esqueleto(4400,208,-3,0);
                        rotor(3152,126,256);
                    rotor(3312,126,556);
                        rotor2(3152,126,256);
                    rotor2(3312,126,556);
                        demon(3360,40,100,60,4,16);
                        toposale(4170,4350,129,120);
                        toposale(5030,5220,193,90);
                        roca(3990,202,3940,4040,3939,4041);
                        lanza(4512,80,floor);
                        lanza(4704,80,floor);
                        lanza(4896,80,floor);
                        lanza(5088,80,floor);
                        idpared=pared(graficos_general,86,4608,160,50,1,4568,4648,4569,4649);
                        idpared=pared(graficos_general,86,4800,160,50,1,4760,4840,4759,4841);
                        idpared=pared(graficos_general,86,4992,160,50,1,4952,5032,4951,5033);
                        burbujas(3104,224,-256);
                        burbujas(3232,224,-256);
                        burbujas(3360,224,-256);
                        creador=false;
                End
                If (x>5450 and x<5500)
                signal(type esqueleto,s_kill);
                        signal(type lanza, s_kill);
                        signal(type rotor, s_kill);
                        signal(type rotor2, s_kill);
                        signal(type saltopez, s_kill);
                        signal(type pared, s_kill);
                        signal(type roca, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type toposale, s_kill_tree);
                        signal(type redjar, s_kill);
                        signal(type powerup, s_kill);
                        signal(type burbujas, s_kill);
                        creador=true;
                End
                If (x>5500 and x<8135 and creador==true)
                    powerup(7330,77,24,8);
                    rotor(7568,126,256);
                    rotor(7728,126,256);
                    rotor(7888,126,256);
                    rotor2(7568,126,256);
                    rotor2(7728,126,256);
                    rotor2(7888,126,256);
                           demon(7930,40,100,60,4,16);
                        toposale(6090,6740,161,120);
                        toposale(6090,6740,161,90);
                           saltopez(5760,5950,90);
                        saltopez(5760,5950,70);
                           saltopez(6880,6910,90);
                        burbujas(7536,224,-256);
                        burbujas(7664,224,-256);
                        burbujas(7792,224,-256);
                        burbujas(7920,224,-256);
                        creador=false;
                End
                If (x>8135 and x<8185)
                signal(type esqueleto,s_kill);
                        signal(type rotor, s_kill);
                        signal(type rotor2, s_kill);
                        signal(type saltopez, s_kill);
                        signal(type roca, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type toposale, s_kill_tree);
                        signal(type powerup, s_kill);
                        signal(type burbujas, s_kill);
                        creador=true;
                End
                If (x>8185 and x<9995 and creador==true)
                        esqueleto(8600,176,-3,0);
                        toposale(9220,9810,129,120);
                        toposale(9220,9810,129,90);
                        roca(8790,170,8740,8840,8739,8841);
                        creador=false;
                End
                If (x>9995 and x<10045)
                signal(type esqueleto,s_kill);
                        signal(type rotor, s_kill);
                        signal(type rotor2, s_kill);
                        signal(type saltopez, s_kill);
                        signal(type roca, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type toposale, s_kill_tree);
                        signal(type redjar, s_kill);
                        signal(type powerup, s_kill);
                        signal(type burbujas, s_kill);
                        creador=true;
                End
                If (x>10045 and x<12790 and creador==true)
                        powerup(12620,173,24,8);
                        redjar(12690,173,24,8);
                        esqueleto(11700,176,-3,0);
                    demon(10805,90,100,60,4,60);
                        toposale(11720,11900,97,120);
                    rotor(12240,126,256);
                    rotor(12400,126,256);
                    rotor(12304,-2,256);
                    rotor2(12240,126,256);
                    rotor2(12400,126,256);
                    rotor2(12304,-2,256);
                           saltopez(10270,10440,90);
                        saltopez(10440,10620,75);
                           saltopez(10270,10620,80);
                           saltopez(10980,11150,80);
                        saltopez(11150,11320,65);
                           saltopez(10980,11320,70);
                        burbujas(12192,224,-256);
                        burbujas(12320,224,-256);
                        burbujas(12448,224,-256);
                        creador=false;
                End
                If (x>12790)
                signal(type esqueleto,s_kill);
                        signal(type rotor, s_kill);
                        signal(type rotor2, s_kill);
                        signal(type saltopez, s_kill);
                        signal(type demon, s_kill_tree);
                        signal(type toposale, s_kill_tree);
                        signal(type redjar, s_kill);
                        signal(type powerup, s_kill);
                        signal(type burbujas, s_kill);
                        creador=true;
                        fin_nivel=true;
                End
            If (y>480)
                    muerte_prota();
            End
        End

        If (nivel==14)
                If (y>1280 and y<1336)
                        salplava(1216);
                        graph=0;
                End
            If (y>1376)
                    muerte_prota();
            End
        End

        ultima_y=y;   // Guarda y en ultima_y para comprobar luego si baja
        Frame;
    End
End

//------------------------------------------------------------------------------
// Proceso del protagonista cuando esta encima de una
// plataforma para que el protagonista se mueva a la
// vez que la plataforma.
// Entradas: `xrelativa`         Posicion relativa horizontal del
//                               protagonista respecto al centro
//                               de la plataforma
//           `id2`               Identificador de la plataforma
//           `tamanio_plataforma` Tamano (largo) de la plataforma
//           `incy`              Posicion relativa vertical del
//                               protagonista respecto al centro
//                               al centro de la plataforma
//-----------------------------------------------------------------------------

Process prota_plataforma(xrelativa,id2,tamanio_plataforma,incy);

Private

    id3;
        contador=0;     // Variable para ralentizar la animacion
    agachado=false;
    disparo=false;

Begin

    file=graficos_general;

    // Duerme al proceso padre(El que le ha llamado)
    // mientras esta este proceso activo
    signal(father,s_sleep);
    ctype=c_scroll;     // Hace que este dentro del scroll
    graph=100;          // Pone el grfico apropiado
    flags=father.flags; // Coge las banderas (izq./der.) que tenia el padre
    priority=1;         // Le da prioridad uno para que actualice
                        // antes al protagonista que al scroll
    scroll[0].camera=id;   // Hace que la camara le siga
    z=-220;
    cadencia=5;

    Loop
        cadencia=cadencia-1;
                If (cadencia<0)
                        cadencia=0;
                End
                If (cadencia<6)
                        disparo=false;
                End

        contador=contador+1;
        // Lee la tecla de la derecha y el joystick
        If ((jkeys_state[_JKEY_RIGHT]) AND velocidad<6 and disparo==false and (!jkeys_state[_JKEY_LEFT]))
            flags=0;
            If (!jkeys_state[_JKEY_DOWN])
                    velocidad+=2;       // Incrementa la velocidad a la derecha
              //Else
                      //velocidad=0;
              End
        Else
            If ((jkeys_state[_JKEY_LEFT]) AND velocidad>-6 and disparo==false and (!jkeys_state[_JKEY_RIGHT]))
                flags=1;                // Lo pone mirando para la izquierda
                If (!jkeys_state[_JKEY_DOWN])
                        velocidad-=2;     // Incrementa la velocidad a la izquierda
                //Else
                    //velocidad=0;
                End
            Else                        // Si no se ha pulsado ninguna direccion
                If (velocidad>0)
                    velocidad-=1;        // Frena a la derecha
                End
                If (velocidad<0)
                    velocidad+=1;        // Frena a la izquierda
                End
            End
        End

        xrelativa+=velocidad;         // Suma velocidad a la posicion relativa
        x=xrelativa+id2.x;            // Convierte la posicion relativa en real
        y=(id2.y-9)+incy;

        If (velocidad<>0)                   // Si el prota se esta moviendo
           If contador MOD 2 == 0 :      // Anima cada 2 frames
                   graph++;                     // Cambia el grfico paranianimarlo
                   if(graph<100 | graph>149)
                           graph=101;//fix, intentos de arreglar el problema del grafico del demonio rojo
                        end
                   If (graph>112)
                      graph=101;
                   End
                   contador=0;                         // Pone a 0 el contador de salto de 2 frames
           End
        End

        If (velocidad==0)             // Si esta parado
                If (disparo)              // ...y dispara
                        If (agachado==false)    // ...y esta de pie
                                If contador MOD 2 == 0 :
                                                                        if(graph<100 | graph>149)
                                                                           graph=140;//intento de arreglar el bug del demonio rojo
                                                                        end
                                        If (graph<148)
                                                graph+=1;
                                        End
                                        contador=0;
                                End
                        Else                  // ...o esta agachado
                                If contador MOD 2 == 0 :
                                                                        if(graph<100 | graph>149)
                                                                           graph=130;//intento de arreglar el bug del demonio rojo
                                                                        end
                                        If (graph<138)
                                                graph+=1;
                                        End
                                        contador=0;
                                End
                        End
                Else                           // Si esta parado y no dispara
                        graph=100;
                End
        End

        If ((jkeys_state[_JKEY_DOWN]) and disparo==false)           // Si pulsa la tecla de agachado
                agachado=true;
                velocidad=0;
                        If (disparo==false)
                                Graph=120;
                        End
        Else
                agachado=false;
        End

        If ((jkeys_state[_JKEY_A]) and cadencia==0)    // Si pulsa la tecla de disparo
                disparo=true;
                velocidad=0;
                cadencia=20;

                If (tipolatigo==0)
                        play_wav(s_whip,0);
                Else
                        play_wav(s_latigo2,0);
                End

                If (agachado==false)
                        If (flags==0)
                                latigo(40,-44);
                                graph=141;
                        Else
                                latigo(-40,-44);
                                graph=141;
                        End
                Else
                        If (flags==0)
                                latigo(36,-26);
                                graph=131;
                        Else
                                latigo(-36,-26);
                                graph=131;
                        End
                End
        End

        If (jkeys_state[_JKEY_Y] and cadencia==0 and super>0)
                suena_sonido(s_super,512,256);
                cinvencible=30;
                suena_sonido(s_super,512,256);
                If (flags==0)
                        super(x+8,y-32);
                Else
                        super(x-8,y-32);
                End
                cadencia=20;
                super-=1;
        End

        If (disparo2)                 // Si cae disparando
                velocidad=0;
                disparo=true;             // Se activan las condiciones "disparo en suelo"
                disparo2=false;           // Se desactivan las condiciones "disparo en aire"
                graph=oldgraph+19;          // Y salta al grfico "disparo en suelo" que toque
        End
        // Si se pulsa la tecla de salto
        If (jkeys_state[_JKEY_B] and disparo==false)
                 contadorsalto+=1;
        Else
                 contadorsalto=0;
        End
        If (contadorsalto>3)
                 contadorsalto=3;
        End

        If (contadorsalto==1)
        //If (jkeys_state[_JKEY_X] and disparo==false)
            signal(father,s_wakeup);                  // Despierta el proceso anterior (el padre)
            father.x=x;                               // Actualiza coordenada x
            father.y=y;                               // Actualiza coordenada y
            father.disparo2=false;
            father.velocidad=velocidad+id2.velocidad; // Actualiza la velocidad
            father.velocidad_gravedad=-12;            // Hace botar al protagonista
            father.flags=flags;                       // Actualiza banderas (izq./der.)
            play_wav(s_salto,0);                                  // Hace sonido de salto dos
            scroll[0].camera=father;                     // Hace que la camara le siga
            despertar=1;
            signal(id,s_kill);                        // Elimina el proceso actual
            Frame;
        End

        // Si el protagonista esta fuera de la plataforma
        If (abs(x-id2.x)>=tamanio_plataforma)
            signal(father,s_wakeup);                  // Despierta el proceso anterior
            father.x=x;                               // Actualiza x
            father.y=y;                               // Actualiza y
            father.disparo2=false;
            father.velocidad=velocidad+id2.velocidad; // Actualiza velocidad
            father.flags=flags;                       // Actualiza banderas (izq./der.)
            father.velocidad_gravedad=0;              // Deja al protagonista suspendido en el aire
            scroll[0].camera=father;                     // hace que la camara le siga
            despertar=1;
            signal(id,s_kill);                        // Elimina el proceso actual
            Frame;
        End

        // Comprueba si ha tocado las abejas o los fantasmas
        If (collision(Type scarab) or collision(Type avispa) or collision (Type disparo_cabeza) or collision(Type bichopared) or collision(Type lava1))
            y=y-4;
            signal(type latigo, s_kill);
            disparo=false;
                    disparo2=false;
                signal(father,s_wakeup);
                father.x=x;
                father.y=y-4;
                father.disparo2=false;
                father.velocidad=velocidad+id2.velocidad;
                father.flags=flags;
                father.velocidad_gravedad=0;
                scroll[0].camera=father;
                despertar=1;
                signal(id,s_kill);
                Frame;
        End

        If (collision(Type planta) or collision (Type parabolico2) or collision(Type ogro) or collision(Type hacha) or collision(Type ojo) or collision(Type rotor2))
            y=y-4;
            signal(type latigo, s_kill);
            disparo=false;
                    disparo2=false;
                signal(father,s_wakeup);
                father.x=x;
                father.y=y-4;
                father.disparo2=false;
                father.velocidad=velocidad+id2.velocidad;
                father.flags=flags;
                father.velocidad_gravedad=0;
                scroll[0].camera=father;
                despertar=1;
                signal(id,s_kill);
                Frame;
        End

        If (collision(Type bombas) or collision (Type laser) or collision(Type bala))
            y=y-4;
            signal(type latigo, s_kill);
            disparo=false;
                    disparo2=false;
                signal(father,s_wakeup);
                father.x=x;
                father.y=y-4;
                father.disparo2=false;
                father.velocidad=velocidad+id2.velocidad;
                father.flags=flags;
                father.velocidad_gravedad=0;
                scroll[0].camera=father;
                despertar=1;
                signal(id,s_kill);
                Frame;
        End

        If (collision(Type platout))
            y=y-6;
            signal(type latigo, s_kill);
            disparo=false;
                    disparo2=false;
                signal(father,s_wakeup);
                father.x=x;
                father.y=y-4;
                father.disparo2=false;
                father.velocidad=velocidad+id2.velocidad;
                father.flags=flags;
                father.velocidad_gravedad=0;
                scroll[0].camera=father;
                despertar=1;
                signal(id,s_kill);
                Frame;
        End

        If (id3=collision(Type bono))
            play_wav(s_bonos,0);        // Haz sonido
            bonos++;                    // Incrementa numero de bonos
            puntos+=1000;               // Suma puntos
            estrellas(id3.x,id3.y);     // Crea estrella vistosas
            signal(id3,s_kill);            // Elimina los bonos de pantalla
            If (bonos==20)              // Y si tiene mas de 20 bonos
                bonos=0;                  // Resta 20 bonos en la cuenta
                vidas++;                // Y suma una vida
                // Pone un mensaje de vida conseguida
                idtextovida=write_translated(fuente1,160,150,4,"EXTRA LIFE");
                contadortextovida=0;
                contextovida=1;
            End
        End

        If (id3=collision(Type powerup))
            play_wav(s_bonos,0);        // Haz sonido
            If (toques<3)
                    toques+=3;              // Incrementa el numero de toques en 3
            Else
                    toques=5;               // Si tiene ms de 2 que se quede en 5
            End
            puntos+=1000;               // Suma puntos
            estrellas(id3.x,id3.y);     // Crea estrella vistosas
            signal(id3,s_kill);         // Elimina el powerup
            // Pone un mensaje
            If (toques==5)
                    idtextotoke=write_translated(fuente1,160,140,4,"MAX ENERGY");
                    contadortextotoke=0;
                    contextotoke=1;
                End
        End

        If (id3=collision(Type redjar))
            play_wav(s_bonos,0);        // Haz sonido
            If (super<3)
                    super+=1;               // Suma un ataque a la reserva
            Else
                    super=3;                   // Pero que no tenga mas de 3
            End
            puntos+=1000;               // Suma puntos
            estrellas(id3.x,id3.y);     // Crea estrella vistosas
            signal(id3,s_kill);         // Elimina los bonos de pantalla
        End

        // Actualiza las coordenadas internas del scroll
        move_scroll(0);
        Frame;
    End
End

//------------------------------------------------------------------------------
// Handle Wiimote vibration
//------------------------------------------------------------------------------
Process rumba(int which, int ftime)
Begin
#ifdef WII_EXTENSIONS
    wpad_rumble(which, 1);  // Start rumbling
    FRAME(ftime);
    wpad_rumble(which, 0);
#endif
End;

//------------------------------------------------------------------------------
// Proceso del protagonista cuando le han alcanzado y le restan
// un punto de vida.
//-----------------------------------------------------------------------------

Process prota_tocado(x,y);

Private  //Masteries
    creador=false;
    contador=40;
    velocd=2;
    fuerza=12;
    gravity=1;//gravedad es un nombre de un proceso!
    int contfor; //contador para el bucle for

Begin
    file=graficos_general;

    contfor=y;
    priority=1;
    play_wav(s_queja,0);
    if(get_id(type latigo))
        signal(type latigo, s_kill);
    end
    ctype=c_scroll;     // Hace que este dentro del scroll
    flags=father.flags; // Coge las banderas (izq./der.) que tenia el padre
    //priority=2;         // Prioridad uno para actualizar a prota antes que scroll
    scroll[0].camera=id;   // Hace que la camara le siga
    z=-255;

    // Wiimote vibration
    rumba(0, 400);

    Loop
        contador=contador-1; // Empieza a contar hacia atrs

        If(contador%2==0)
                graph=149;
        Else
                graph=150;
        End

        // Si NO toca pared, hay incremento o decremento de X segun los flags


    // Parche para que se cumpla tambin con las paredes destructibles
        If (exists(Type pared))
                If ((idpared.x)-x>40)
                        If(flags==0)
                                If (map_get_pixel(graficos_fase,2,(x/2)-2,contfor/2)<>120)
                                        x-=velocd;
                                End
                        Else
                                If (map_get_pixel(graficos_fase,2,(x/2)+2,contfor/2)<>120)
                                    x+=velocd;
                                End
                        End
                End // Fin del parche ;)
        Else
            If(flags==0)
                        If (map_get_pixel(graficos_fase,2,(x/2)-2,contfor/2)<>120)
                                x-=velocd;
                        End
                Else
                        If (map_get_pixel(graficos_fase,2,(x/2)+2,contfor/2)<>120)
                                x+=velocd;
                        End
                End
        End

        y-=fuerza;
            fuerza-=gravity;
        for(contfor=y; contfor<=(y-fuerza); contfor+=1)
                If (map_get_pixel(graficos_fase,2,x/2,contfor/2)==136 or contador==0)
                if(flags==0)//evita que el personaje se quede atrapado en la pared
                    If (map_get_pixel(graficos_fase,2,(x/2),(y-5)/2)==120)
                        x+=2;
                            end
                else
                    If (map_get_pixel(graficos_fase,2,(x/2),(y-5)/2)==120)
                        x-=2;
                            end
                end
                    father.x=x;                                           // Actualiza coordenada x
                    father.y=y+8;                                       // Actualiza coordenada y
                    father.disparo2=false;
                    father.flags=flags;                                   // Actualiza banderas (izq./der.)
                    father.cinvencible=60;
                    father.file=2;
                    scroll[0].camera=father;
                        despertar=1;//permitir que el proceso padre continue                                     // Hace que la camara le siga
                    signal(id,s_kill);                                    // Elimina el proceso actual
                    Frame;
                End
        End
        If (toques==0)
                muerte_prota();
        End
        If (nivel==10 and y>384 and y<440 and x<6920)
                salplava(320);
                graph=0;
        End
        move_scroll(0);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para hacer la muerte del protagonista
//-----------------------------------------------------------------------------

Process muerte_prota()

Private
    incr_y=-12;                          // Variable para mover grafico poco a poco

Begin

    file=graficos_general;

    //idprota.creador=false;               // No crea mas monstruos hasta que se le diga
    signal(type latigo, s_kill);
    ctype=c_scroll;                      // Lo mete dentro del scroll
    graph=149;                           // Pone el grfico apropiado
    priority=2;                          // Le da prioridad mxima
    signal(father,s_sleep);              // Duerme al proceso padre (el del protagonista)
    x=father.x;                          // Coge x del protagonista (proceso padre)
    y=father.y;                          // Coge y
    z=-510;
    flags=father.flags;

    play_wav(s_caida,0);
    //     Si esta en el nivel uno
    //    If (nivel==1 or nivel==3)
    //  scroll[0].camera=id;                // Hace que la camara le siga
    //    End
    y-=12;                               // Mueve el grafico hacia abajo

    Repeat

        If(flags==0)
                x-=4;
        Else
                x+=4;
        End

        y+=incr_y;                           // Sigue bajando el grfico
        incr_y++;                            // Cada vez mas despacio
        Frame;
    Until (out_region(id,0));                   // Mientras no salga de pantalla
    // Apaga pantalla si le quedan vidas
    If (vidas>0)
        fade_off();
        while(fading)
            Frame;
        end;
    Else
        idprincipal.x=father.x;
        idprincipal.y=father.y;
        scroll[0].camera=idprincipal;
    End
    vidas--;
    If (vidas>-1)                       // Si quedan vidas
        toques=5;
        super=3;
        Switch (nivel)                  // Dependiendo de la fase
            Case 1:
                Switch(father.x)
                    Default:
                        idprota=prota(120,224);
                    End
                End
            End
            Case 2:
                    Switch(father.y)
                    Case 0..1200:
                                                idprota=prota(100,2362);
                    End
                    Case 1200..2400:
                        idprota=prota(100,2362);
                    End
                    Default:
                        idprota=prota(100,2362);
                    End
                End
            End
            Case 3:
                    Switch(father.x)                 // Segun donde se haya quedado
                    Case 0..2650:                    // crea un nuevo protagonista
                        idprota=prota(112,128);       // en la posicion adecuada
                    End
                    Case 2650..6400:
                        idprota=prota(2651,80);
                    End
                    Default:
                        idprota=prota(100,100);
                    End
                End
            End
            Case 4:
                Switch(father.y)             // Segun donde se haya quedado
                    Case 0..2370:         // crea un nuevo protagonista
                        idprota=prota(240,2048);   // en la posicion adecuada
                    End
                    Case 2370..4800:
                        idprota=prota(64,4768);
                    End
                    Default:
                        idprota=prota(64,4768);
                    End
                End
            End
            Case 5:
                Switch(father.x)
                    Default:
                        idprota=prota(256,288);
                    End
                End
            End
            Case 6:
                    Switch(father.x)
                            Case 0..3110:                    // crea un nuevo protagonista
                        idprota=prota(90,420);       // en la posicion adecuada
                    End
                    Case 3110..7200:
                        idprota=prota(3110,400);
                    End
                            Default:
                                idprota=prota(90,420);
                        End
                End
            End
            Case 7:
                    Switch(father.x)
                            Case 0..3860:
                                    idprota=prota(90,448);
                            End
                            Case 3860..7200:
                                    idprota=prota(3860,448);
                            End
                            Default:
                                idprota=prota(90,448);
                        End
                End
            End
            Case 8:
                    Switch(father.y)
                            Default:
                                idprota=prota(100,128);
                        End
                End
            End
            Case 9:
                    Switch(father.x)
                            Case 0..3400:
                                    idprota=prota(110,224);
                            End
                            Case 3400..7200:
                                    idprota=prota(3340,90);
                            End
                            Default:
                                idprota=prota(110,224);
                        End
                End
            End
            Case 10:
                    Switch(father.x)
                            Case 0..4990:
                                    idprota=prota(120,256);
                            End
                            Case 4990..9600:
                                    idprota=prota(4965,256);
                            End
                            Default:
                                idprota=prota(120,256);
                        End
                End
            End
            Case 11:
                    Switch(father.x)
                            Case 0..2700:
                                    idprota=prota(120,448);
                            End
                            Case 2700..6400:
                                    idprota=prota(2650,416);
                            End
                            Default:
                                idprota=prota(120,448);
                        End
                End
            End
            Case 12:
                    Switch(father.x)
                            Case 0..5500:
                                    idprota=prota(100,176);
                            End
                            Case 5500..12800:
                                    idprota=prota(5475,176);
                            End
                            Default:
                                idprota=prota(100,176);
                        End
                End
            End
            Case 13:                                        //Masteries nivel del Dragn
                    idprota=prota(256,288);
            End
            Case 14:
                idprota=prota(60,1024);
            End
        End
        signal(father,s_kill);          // Elimina el protagonista anterior
        //enciende pantalla
        fade_on();
        while(fading)
            Frame;
        end;
    Else
        signal(Type barra_energia,s_kill_tree); // Elimina la barra de final de
    End                                         // fase si hace falta.
End

//-----------------------------------------------------------------------------
// Proceso para calcular los suelos y la gravedad del prota
//-----------------------------------------------------------------------------

Process gravedad();

Private
    vgravedad;        // Variable para guardar temporalmente la gravedad

Begin
    // Coge la coordenada y a partir de la gravedad del protagonista (padre)
    vgravedad=(father.velocidad_gravedad++);   // Pero incrementada en 2
    If (vgravedad>16)                           // Si es mayor de 16
        father.velocidad_gravedad=16;           // Haz que sea 16 la gravedad del protagonista
        vgravedad=16;                           // Y tambien la variable temporal
    End

    If (vgravedad<0)                        // Si la gravedad es negativa
        While (vgravedad++!=0)              // Mientras no sea cero, la incrementa
            // Si no se da con el techo
            If (map_get_pixel(graficos_fase,2,father.x/2,(father.y-64)/2)<>252)
                father.y--;                 // Haz que el protagonista suba
            Else                            // Si no pon la gravedad a cero
                father.velocidad_gravedad=0;
                Break;
            End
        End
    Else                                    // Si la gravedad es cero o positiva
        father.y+=vgravedad;                // Se suma a la coordenada del protagonista
        // Comprueba el rango vertical del movimiento del protagonista
        From vgravedad=-16 To 7 Step 2;     // Acaba el proceso si se toca el suelo
            If (map_get_pixel(graficos_fase,2,father.x/2,(father.y+vgravedad)/2)==136)
                Break;                      // Sal si se encuentra con el suelo
            End
        End
        If (vgravedad<8)                    // Si se encuentra con el suelo
            father.y+=vgravedad;            // Se actualiza con el mximo que se pueda mover
            father.velocidad_gravedad=0;    // Y se pone la gravedad a 0
        End
    End

End

//-----------------------------------------------------------------------------
// Proceso para comprobar si se toca suelo
// Salidas: True/False, segun si se toca suelo o no
//-----------------------------------------------------------------------------

Process en_pantalla()

Begin

    If (map_get_pixel(graficos_fase,2,father.x/2,father.y/2)==136)
        Return(true);   // Si se toca suelo el proceso devuelve true
    Else
        Return(false);  // Si no, devuelve false
    End

End

//-----------------------------------------------------------------------------
// Proceso para los objetos de primer plano de la presentacin
// Entradas: 'graph'        numero de grafico
//           'xrelativa'    posicion horizontal relativa (x) del
//                          grafico respecto al scroll
//-----------------------------------------------------------------------------

Process primer_plano3(graph,x,yrelativa,flags);

Begin
    priority=1;
    file=graficos_general;
    //ctype=c_scroll;
    Loop
        y=(yrelativa-scroll[0].y0)*2;
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los objetos de primer plano
// Entradas: 'graph'        numero de grafico
//           'xrelativa'    posicion horizontal relativa (x) del
//                          grafico respecto al scroll
//-----------------------------------------------------------------------------

Process primer_plano(graph,xrelativa,yrelativa,flags);

Begin
    priority=1;
    file=graficos_fase;
    //ctype=c_scroll;
    Loop
        y=(yrelativa-scroll[0].y0)*1.2;
        x=(xrelativa-scroll[0].x0)*1.2;  // Halla la posicion relativa al scroll
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los objetos de primer plano (despl. horizontal mas rpido)
// Entradas: 'graph'        numero de grafico
//           'xrelativa'    posicion horizontal relativa (x) del
//                          grafico respecto al scroll
//-----------------------------------------------------------------------------

Process primer_plano2(graph,xrelativa,yrelativa,flags);

Begin
    priority=1;
    file=graficos_fase;
    Loop
        y=(yrelativa-scroll[0].y0);
        x=(xrelativa-scroll[0].x0)*1.6;  // Halla la posicion relativa al scroll
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el fondo del scroll
// Entradas: 'graph'        numero de grafico
//           'xrelativa'    posicion horizontal relativa (x) del
//                          grafico respecto al scroll
//-----------------------------------------------------------------------------

Process fondo_scroll(graph,yrelativa);

Begin
    file=graficos_fase;
    z=1024;
    ctype=c_scroll;
    priority=1;
    Loop
        y=((scroll[0].y0-scroll[0].y1))+yrelativa;
        x=(scroll[0].x0)+160;
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos que tapan otros
// Entradas: 'file'  fichero de grficos que se usa
//           'graph' numero de grfico
//           'x' 'y' Coordenadas 'x' e 'y' del grfico
//           'z'     Profundidad del grafico en pantalla
//           'ctype' Variable para ver si esta dentro del scroll
//-----------------------------------------------------------------------------

Process objeto(file,graph,x,y,z,ctype);

Begin
    Loop
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para las paredes destructibles
//-----------------------------------------------------------------------------

Process pared(file,graph,x,y,z,ctype,x1,x2,xb1,xb2);

Begin
        Loop
            If(idprota.x>x1 and idprota.x<x2 and idprota.y>y-56 and idprota.y<y+56)    //si el prota est en un area delimitada por x1,x2
                If(idprota.x<x)                             //si el prota est a la izquierda de la pared
                    If(idprota.x>xb1 and idprota.x<xb2)
                            idprota.x=xb1;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                Else                                                     //si est a la derecha
                    If(idprota.x<xb2 and idprota.x>xb1)
                            idprota.x=xb2;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                End
            End
                If (collision (type latigo) and (tipolatigo==0));
                play_wav(s_estrella,0);
                explopared(x,y);
                explosion(x-10,y-32);
                explosion(x+10,y-20);
                explosion(x+16,y+48);
                explosion(x-16,y-40);
                        If (nivel==1);
                                signal(type plataforma_metal, s_kill);
                        End
                Break;
        End
                Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para dibujar los puntos de vida del protagonista
// Entradas: 'file'  fichero de grficos que se usa
//           'x' 'y' Coordenadas 'x' e 'y' del grfico
//           'z'     Profundidad del grafico en pantalla
//           'ctype' Variable para ver si esta dentro del scroll
//-----------------------------------------------------------------------------

Process barra(file,x,y,z,ctype);

Begin
    Loop
            graph=toques+176;
        Frame(50);
    End
End

//-----------------------------------------------------------------------------
// Proceso para dibujar los superataques disponibles
// Entradas: 'file'  fichero de grficos que se usa
//           'x' 'y' Coordenadas 'x' e 'y' del grafico
//           'z'     Profundidad del grafico en pantalla
//           'ctype' Variable para ver si esta dentro del scroll
//-----------------------------------------------------------------------------

Process barra2(file,x,y,z,ctype);

Begin
    Loop
            graph=super+295;
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner el fuego de las antorchas
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process antorcha(x,y,z);

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=027;              // Pon el grafico inicial del grafico
    priority=2;
    file=graficos_general;

    Loop                    // Realiza la animacion de los graficos
        graph++;
        If (graph>058)
            graph=027;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner el fuego de las antorchas FIJAS
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process antorcha2(x,y,z);

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=027;              // Pon el grafico inicial del grafico
    priority=2;
    file=graficos_general;
    Loop                    // Realiza la animacion de los graficos
        graph++;
        If (graph>058)
            graph=027;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner las burbujas del pantano
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process burbujas(x,y,z);

Private

        contador=0;

Begin
    file=graficos_fase;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=061;              // Pon el grafico inicial del grafico
    priority=2;

    Loop                    // Realiza la animacion de los graficos
        contador++;
        If contador MOD 2 == 0 :
                graph++;
                If (graph>068)
                    graph=061;
                End
            contador=0;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los troncos giratorios con pinchos
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process rotor(x,y,z);

Private
        contador=0;

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    file=graficos_fase;
    graph=021;              // Pon el grafico inicial del grafico
    priority=2;

    Loop                    // Realiza la animacion de los graficos
                contador=contador+1;
        If contador MOD 3 == 0 :
                graph++;
                If (graph>040)
                    graph=021;
                End

            contador=0;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los pinchos de los troncos giratorios
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process rotor2(x,y,z);

Private
        contador=0;

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    file=graficos_fase;
    graph=041;              // Pon el grafico inicial del grafico
    priority=2;

    Loop                    // Realiza la animacion de los graficos
                contador=contador+1;
        If contador MOD 3 == 0 :
                graph++;
                If (graph>060)
                    graph=041;
                End
            contador=0;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de los bonos
// Entradas: 'x' 'y' Coordenadas de los objetos
//-----------------------------------------------------------------------------

Process bono(x,y);

Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=401;              // Pon el grafico inicial del grafico
    z=256;

    Loop                    // Realiza la animacion de los graficos
        graph++;
        If (graph>412)
            graph=401;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion(x,y);

Begin
    file=graficos_general;
    ctype=c_scroll;            // Haz que este dentro del scroll
    graph=004;
    z=-512;
    from graph=004 to 011;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion con llamaradas
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion2(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=167;
    z=-511;
    from graph=167 to 175;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion con muchas llamaradas
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion2b(x,y);

Private
        bucle;

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=167;
    z=-510;
    From bucle=1 to 15;
            explosion2((x+rand(-10,10)),(y+rand(-10,10)),100);
    Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion magica
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion3(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=182;
    z=-510;
    from graph=182 to 193;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion magica (azul)
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion4(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=194;
    z=-512;

    from graph=194 to 201;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una explosion verde
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process exploverde(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=268;
    z=-512;

    from graph=268 to 275;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una electrocucin
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion5(x,y,size,flags);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=238;
    z=-512;

    from graph=238 to 223;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear una electrocucin (ascensores)
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explosion6();

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=238;
    z=-512;

    from graph=238 to 223;x=father.x;y=father.y;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para generar la desaparicin de la pared-telaraa
// Entradas: 'x' 'y' Coordenadas de la misma
//-----------------------------------------------------------------------------

Process explopared(x,y);

Private
        cont;

Begin
    file=graficos_general;
    ctype=c_scroll;            // Haz que este dentro del scroll
    graph=202;
    z=-500;
        From cont=1 to 15;
                    If cont MOD 2 == 0 :
                        graph++;
                End
            Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para generar el salpicn de lava cuando el prota se cae
// Entradas: 'y' Coordenada (la 'x' es la del padre)
//-----------------------------------------------------------------------------

Process salplava(y);

Private
        cont;

Begin
    file=graficos_general;
    ctype=c_scroll;            // Haz que este dentro del scroll
    graph=210;
    x=father.x;
    z=-509;
        explosion2b(x,y+32);
        suena_sonido(s_estrella,256,256);
        From cont=1 to 7;
                    If cont MOD 1 == 0 :
                        graph++;
                End

            Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para generar la estela del hacha
// Entradas: 'x' e 'y'
//-----------------------------------------------------------------------------

Process estela(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=239;
    z=-510;
    from graph=239 to 246;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear el salpicon verde
// Entradas: 'x' 'y' Coordenadas del mismo
//-----------------------------------------------------------------------------

Process salpicon(x,y,size);

Begin
    file=graficos_general;
    ctype=c_scroll;
    graph=260;
    z=-510;

    from graph=260 to 267;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de las estrellas
// Entradas: 'x' 'y' Coordenadas de inicio de las estrellas
//-----------------------------------------------------------------------------

Process estrellas(x,y);

Private
    n_estrellas;               // Numero de estrellas (contador)
Begin

    From n_estrellas=0 To 11;            // Crea 12 estrellas iguales
         estrella(x,y);
    End
End


Process estrella(x,y)
Private
    incr_x;                    // Incremento horizontal
    n_estrellas;               // Numero de estrellas (contador)
Begin
    file=graficos_general;
    ctype=c_scroll;            // Haz que este dentro del scroll
    graph=024;                 // Pon el grfico inicial de la estrella
    incr_x=rand(-6,6);                      // Elige al azar el incremento horizontal
    velocidad_gravedad=rand(-24,-8);    // Y tambin el vertical
    n_estrellas=32;

    While (n_estrellas-->0);          // Mientras queden estrellas (n_estrellas = numero de estrellas)
        // Realiza la animacion de los grficos
        graph++;
        If (graph>026) graph=024; End
        x+=incr_x;                      // Mueve las estrellas horizontalmente
        y+=velocidad_gravedad;      // Y verticalmente

        velocidad_gravedad+=2;      // Y reduce el incremento vertical (gravedad)
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de los ogros
// Entradas:  'x' 'y' Coordenadas x e y de objeto
//            'incr_x'    Incremento horizontal (a der. e izq.
//-----------------------------------------------------------------------------

Process ogro(x,y,incr_x,flags);

Private
        contador=0;
        distancia;
        BYTE vida=2;        //este personaje necesita dos toques para morir
        BYTE temp=13;        //para que el ogro slo pueda recibir un latigazo por segundo
        BYTE ready=40;    //slo puede lanzar un hacha cada 40 cuadros
        BYTE detectar=0;

Begin
    file=graficos_general;
    graph=301;      // Numero de grafico
    ctype=c_scroll; // Lo mete dentro del scroll

    Loop
        //delete_text(all_text);//debug
        //clculo de la distancia al protagonista, si est a menos de 130 pxeles, le lanzamos un hacha
        If(ready==40 && detectar==0)//para qu calcular la distancia al personaje si todava no se le puede atacar
           If(flags==0)//x ogro> x prota
               //idprota3=get_id(type prota);
               If(idprota<>0)
                 If(x>(idprota.x))
                 distancia=x-idprota.x;
                   If(distancia<130 && distancia>0)
                     detectar=1;
                   End
                 End
               End
           Else//x prota>x ogro
               //idprota3=get_id(type prota);
               If(idprota<>0)
                If((idprota.x)>x)
                  distancia=idprota.x-x;
                    If(distancia<130 && distancia>0)
                      detectar=1;
                    End
                  End
               End
           End
        End
        //fin de la deteccin del protagonista
        contador=contador+1;

        If(detectar==0)                        //no camina mientras se prepara para atacar
           x+=incr_x;             // Mueve el grafico horizontalmente
        End

        // Si ha llegado al final de la plataforma o choca con algo
        If (NOT en_pantalla() or collision (type roca) or collision (type pared))
            incr_x=-incr_x;       // Cambia el incremento horizontal
            x+=incr_x*16;           // Mueve un poco el grafico
            // Da la vuelta al grafico
            If (flags==0)
                flags=1;
            Else
                flags=0;
            End
        End

        // Realiza la animacion de los graficos
      If(detectar==0)
        If contador MOD 2 == 0 :
        graph++;
        If (graph>312) graph=301; End; contador=0; End
        //fin de la animacin de caminar
      Else//animacin de lanzar el hacha; detectar==1
         If(ready==40)
             graph=313;
             ready=0;
         Else
         If contador MOD 2 == 0 :
          graph++;
         If (graph>320) graph=320; detectar=0; //get_real_point(1,offset xp,offset yp);
     hacha(x,y-50,flags); End; contador=0; End
         End
      End

        If(temp<13)
           temp++;
        End
        If(ready<40)
           ready++;
        End
        //colisin con el ltigo
        If (collision (type latigo) && temp==13);
          If (tipolatigo==1)
             play_wav(s_estrella,0);
             shock(-40);
          Else
                        If (vida>0)
                            shock_ogro(-40);
                          suena_sonido(s_ogro,128,256);
                  explosion(x,y-32);
                  explosion2(x,y-32,120);
                  explosion2b(x-16,y-32);
                  explosion(x+16,y-48);
                  vida--;
                  temp=0;
                        Else
                          suena_sonido(s_bang,512,256);
                  explosion(x,y-32);
                  explosion2(x,y-32,120);
                  explosion2b(x-16,y-32);
                  explosion(x+16,y-48);
              explosion2b(x-12,y-20);
                         explosion2b(x,y-32);
                    explosion2b(x,y-40);
              Break;
              End
          End
        End
        If (collision (type super))
                  suena_sonido(s_bang,512,256);
          explosion(x,y-32);
          explosion2(x,y-32,120);
          explosion2b(x-16,y-32);
          explosion(x+16,y-48);
            explosion2b(x,y);
            explosion2b(x+16,y-12);
            explosion2b(x-6,y+48);
          Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Masteries
// Proceso del guerrero esqueletico, necesita 2 toques del ltigo rojo
// Para morir, adems se cubre con su escudo si le atacas de frente
// Puede atacar de pie y agachado
//-----------------------------------------------------------------------------

Process esqueleto(x,y,incr_x,flags);

Private
        contador=0;
        distancia;
        xp;
        yp;
        BYTE defense=0;
        BYTE agachado=0;
        BYTE vida=2;        //este personaje necesita tres toques para morir
        BYTE temp=13;        //para que el ogro slo pueda recibir un latigazo por segundo
        BYTE ready=30;    //slo puede lanzar un hacha cada 30 cuadros
        BYTE detectar=0;
        BYTE undefense=0;
        BYTE latigo_rojo=0;

Begin
    file=graficos_general;
    graph=454;      // Numero de grafico
    ctype=c_scroll; // Lo mete dentro del scroll

    Loop
        //delete_text(all_text);//debug
        //es necesario cubrise con el escudo?
        if(undefense==0)
           If(flags==0)//x ogro> x prota
               If(idprota<>0 && idprota.graph>130 && idprota.graph<>no_graph)//el protagonista est atacando
                 If(x>(idprota.x))
                 distancia=x-idprota.x;
                   If(distancia<120 && distancia>0)
                     defense=1;
                     undefense=10;
                     if(idprota.graph==120 | ( (idprota.graph>130) && (idprota.graph<140) ) )
                         agachado=1;
                         graph=473;
                     else
                         agachado=0;
                         graph=466;
                     end
                     If(distancia<65 && distancia>0)
                        detectar=1;
                     End
                   End
                 End
               Else
                  defense=0;
               end
           Else//x prota>x ogro
               If(idprota<>0 && idprota.graph>130 && idprota.graph<>no_graph)
                If((idprota.x)>x)
                  distancia=idprota.x-x;
                    If(distancia<120 && distancia>0)
                      defense=1;
                      undefense=10;
                      if(idprota.graph==120 | ( (idprota.graph>130) && (idprota.graph<140) ) )
                         agachado=1;
                         graph=473;
                      else
                         agachado=0;
                         graph=466;
                      end
                      If(distancia<65 && distancia>0)
                       detectar=1;
                      End
                    End
                  End
               Else
                  defense=0;
               end
           End
         end
        //fin de la deteccin del ataque del protagonista
        if(undefense>0)
           undefense--;
        end
        //clculo de la distancia al protagonista, si est a menos de 76 pxeles le atacamos
        If(detectar==0 && defense==0 && ready==30)//para qu calcular la distancia al personaje si todava no se le puede atacar
           If(flags==0)//x ogro> x prota
               If(idprota<>0 && idprota.graph<>no_graph)
                 If(x>(idprota.x))
                 distancia=x-idprota.x;
                   If(distancia<59 && distancia>0)
                     detectar=1;
                     if(idprota.graph==120 | ( (idprota.graph>130) && (idprota.graph<140) ) )
                         agachado=1;
                     else
                         agachado=0;
                     end
                   End
                 End
               End
           Else//x prota>x ogro
               If(idprota<>0 && idprota.graph<>no_graph)
                If((idprota.x)>x)
                  distancia=idprota.x-x;
                    If(distancia<59 && distancia>0)
                      detectar=1;
                      if(idprota.graph==120 | ( (idprota.graph>130) && (idprota.graph<140) ) )
                         agachado=1;
                      else
                         agachado=0;
                      end
                    End
                  End
               End
           End
        End

        //fin de la deteccin del protagonista
        contador=contador+1;

        // Si ha llegado al final de la plataforma o choca con algo
        If (NOT en_pantalla() or collision (type roca) or collision (type pared) or latigo_rojo==1)
            incr_x=-incr_x;       // Cambia el incremento horizontal
            if(latigo_rojo==0)
            x+=incr_x*8;               // Mueve un poco el grafico
            else
            x+=incr_x*8;
            latigo_rojo=0;
            end
            // Da la vuelta al grafico
            If (flags==0)
                flags=1;
            Else
                flags=0;
            End
        End

        If(detectar==0 && defense==0)//moverse de iz a der
           x+=incr_x;             // Mueve el grafico horizontalmente
           If contador MOD 2 == 0 :
              graph++;
              If (graph>465)
                  graph=454;
              End
              contador=0;
           End
        end

        if(detectar==1 && ready==30)//atacar
           if(agachado==0)
               graph=466;
               ready=0;
               while(graph<472)
                  graph++;
                  frame;
                  frame;
               end
               graph=466;
               detectar=0;
           else
               graph=473;
               ready=0;
               while(graph<479)
                  graph++;
                  frame;
                  frame;
               end
               graph=473;
               detectar=0;
           end
        end

        If(temp<13)
           temp++;
        End
        If(ready<30)
           ready++;
        End
        //colisin con el ltigo
        If (collision (type latigo) && temp==13);
          If (tipolatigo==1)
             play_wav(s_estrella,0);
             shock(-40);
          Else
          if(defense==1)//se est cubriendo con el escudo y esto le hace invulnerable al ltigo rojo
                    if(graph==466)
                        get_real_point(1,offset xp,offset yp);
                                        If(!exists(type explosion2b))
                                                explosion2b(xp,yp);
                            play_wav(s_ogro,0);
                        End
                    else
                        get_real_point(1,offset xp,offset yp);
                                        If(!exists(type explosion2b))
                                                explosion2b(xp,yp);
                                            play_wav(s_ogro,0);
                                        End
                    End
          else//defense==0
                        If (vida>0)
                            shock_ogro(-40);
                          suena_sonido(s_golpe,128,256);
                  explosion(x,y-32);
                  explosion2(x,y-32,120);
                  explosion2b(x-16,y-32);
                  explosion(x+16,y-48);
                  vida--;
                  temp=0;
                  latigo_rojo=1;
                        Else
                          suena_sonido(s_bang,512,256);
                  explosion(x,y-32);
                  explosion2(x,y-32,120);
                  explosion2b(x-16,y-32);
                  explosion(x+16,y-48);
              explosion2b(x-12,y-20);
                         explosion2b(x,y-32);
                    explosion2b(x,y-40);
              Break;
              End
          End
        End
        end
        If (collision (type super))
                  suena_sonido(s_bang,512,256);
          explosion(x,y-32);
          explosion2(x,y-32,120);
          explosion2b(x-16,y-32);
          explosion(x+16,y-48);
            explosion2b(x,y);
            explosion2b(x+16,y-12);
            explosion2b(x-6,y+48);
          Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso de las lanzas trampa
// Entradas: 'x' 'y'       Coordenadas x e y del objeto
//           'posicion'    floor, der, izq, techo
//-----------------------------------------------------------------------------

Process lanza(x,y,posicion)//geiser

Private

        BYTE update=0;
        BYTE serie;

Begin
    file=graficos_general;
        ctype=c_scroll;
        graph=480;
        flags=0;//con transparencia

        If(posicion==floor)//la lanza sale desde el suelo
               angle=0;
        End
        If(posicion==der)//la lanza sale desde la pared derecha
               angle=90000;
        End
        If(posicion==techo)//la lanza sale desde el techo
               angle=180000;
        End
        If(posicion==izq)//la lanza sale desde la pared izquierda
               angle=270000;
        End
        z=-5;//se dibuja por encima de todo
        Frame(rand(1000,10000));
                serie=rand(1,4);

        Loop
                If(graph==481)
                    suena_sonido(s_lanza,50,256);
                End
                Frame;
               update++;
               If(update==2)
                        graph++;
                  update=0;
               End
               If(graph==488)
                  graph=480;
                  serie--;
                  If(serie==0)
                         Frame(rand(1000,4000));
                         serie=rand(1,3);
                  End
               End
        End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de las calabazas
// Entradas: 'x'        Coordenada x del objeto
//           'ultima_y' Coordenada y del objeto especial
//           'incr_x'       Incremento horizontal (direccion izq/der)
//-----------------------------------------------------------------------------

Process ojo(x,y,flags,graph)

Private

vulnerable;
contador;             // Mitica variable donde las haya
fuerzamax=18;      // La altura mxima que pillar la bola
sentido=1;          // Bajando o subiendo
incx=3;

Begin
    file=graficos_general;
        ctype=c_scroll;
        vulnerable=30;
        sentido=1;
        Loop
                vulnerable-=1;
                If (vulnerable<0) vulnerable=0; End
                If (flags==0)
                        x+=incx;
                Else
                        x-=incx;
                End

                If (nivel==8)
                        If (x>1220)flags=1; End
                        If (x<60)flags=0; End
                Else
                        If (x>6340)flags=1; End
                        If (x<5756)flags=0; End
                End

                If (sentido==0)     // Si el sentido es de cada
                    contador+=1;     // Esto se usa como un valor que aumente y hace las veces de la velocidad de caida en aumento por la aceleracin.
                    y+=contador;     // Esto sirve para que la pelota efectivamente baje, si baja rpido puenes poner y+=(contador/2) o algo similar
                    If (map_get_pixel(graficos_fase,2,x/2,y/2)==136)
                            sentido=1;
                            contador=fuerzamax;

                    End
                Else // Si me toca ascender
                    contador-=1;
                    y-=contador; // Pa que suba (recuerda lo de la velocidad)
                    If(contador<=0)
                            contador=0;
                            sentido=0;
                    End
                End
                If (collision (type latigo) and vulnerable==0)
                //play_wav(s_estrella,0);
                If (tipolatigo==1)
                        play_wav(s_estrella,0);
                        shock(-16);
                Else
                        play_wav(s_bang,0);
                        explosion(x,y);
                        explosion2b(x,y-16);
                    If (graph==340)
                            ojo(x,y-8,0,341);
                            ojo(x,y-8,1,341);
                    End
                    If (graph==341)
                            ojo(x,y-8,0,342);
                            ojo(x,y-8,1,342);
                    End
                    Break;
                End
            End
        If (collision (type super) and vulnerable==0)
                play_wav(s_bang,0);
            explosion(x,y);
                explosion2b(x,y-16);
                If (graph==340)
                        ojo(x,y-8,0,341);
                    ojo(x,y-8,1,341);
                End
                If (graph==341)
                    ojo(x,y-8,0,342);
                    ojo(x,y-8,1,342);
                End
                Break;
        End
                Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para el intervalo del disparo del topo
// Entradas:  'xa' y 'xb'       Desde donde hasta donde puede surgir el pez
//                        'pausa'                        Frames entre salto y salto
//-----------------------------------------------------------------------------

Process toposale(xa,xb,y,pausa);

Private

        contador;

Begin

    file=graficos_fase;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=0;
    contador=pausa;

    Loop
            contador-=1;
            If (contador<0)
                    x=rand(xa,xb);
                    If(idprota.x<x)
                            flags=0;
                    Else
                            flags=1;
                    End
                    contador=pausa;
                    topo(x,y,flags);
            End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los topos que salen del suelo
// Entradas: 'x' 'y'  Coordenadas del grafico
//           'flags'  Direccion hacia donde mira el grafico
//-----------------------------------------------------------------------------

Process topo(x,y,flags);

Private

        contador;
    int id_topo2;

Begin

    file=graficos_fase;
    ctype=c_scroll;                 // Haz que este dentro del scroll
    graph=301;
    z=10;
    contador=0;
    id_topo2=topo2(x,y,z);

    Loop
            contador++;
            If (contador<16)
                     If contador MOD 2 == 0 :
                             graph++;
                End
            End
            If (contador>16 and contador<20)
                            graph=308;
            End
            If (contador>20 and contador<24) graph=309; End
            If (contador==22)
                        suena_sonido(s_muelle,256,256);
                    suena_sonido(s_roca,128,256);
                    If (father.flags==0)
                            flecha(x-14,y-5,12);
                    Else
                            flecha(x+14,y-5,12);
                    End
            End
            If (contador>24 and contador<28)
                            graph=308;
            End
            If (contador>28)
                     If contador MOD 2 == 0 :
                             graph--;
                End
            End
        If (contador>43)
                signal(id_topo2, s_kill);
                Break;
        End
        If (collision (type latigo));
                play_wav(s_estrella,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        explosion(x,y);
                        explosion2b(x,y);
                    signal(id_topo2, s_kill);
                    Break;
                End
            End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                signal(id_topo2, s_kill);
                Break;
        End
        Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para la parte del topo que NO afecta al protagonista si colisiona
// Entradas: 'x' 'y' 'z' Coordenadas del padre (el topo)
//-----------------------------------------------------------------------------

Process topo2(x,y,z);

Private
        contador=0;

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    file=graficos_fase;
    //graph=014;              // Pon el grafico inicial del grafico

    Loop                    // Realiza la animacion de los graficos
                flags=father.flags;
                contador=contador+1;
        graph=father.graph+100;
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el intervalo del salto del pez
// Entradas:  'xa' y 'xb'       Desde donde hasta donde puede surgir el pez
//                        'pausa'                        Frames entre salto y salto
//-----------------------------------------------------------------------------

Process saltopez(xa,xb,pausa);

Private

        contador;

Begin

    file=graficos_fase;
    ctype=c_scroll;     // Hace que este dentro del scroll
    y=206;
    z=-11;
    contador=pausa;
    graph=200;

    Loop
            contador-=1;
            If (contador>20)
                    graph=0;
            End

          If (contador==20)
                  x=rand(xa,xb);
                  graph=200;
          End

          If (contador<20)
                  If contador MOD 3 == 0 :
                  graph++; End
                  If (graph>203)
                          graph=200;
                  End
          End

            If (contador<0)
                    If(idprota.x<x)
                            flags=1;
                    Else
                            flags=0;
                    End
                    //x=rand(xa,xb);
                    contador=pausa;
                    suena_sonido(s_splash,256,256);
                    lava2(x,200);
                    pez(x,y);
            End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para objetos tipo pez.
// Entradas:  'x'  Coordenada horizontal del grafico
//            'yrelativa' Coordenada vertical especial del grafico
//-----------------------------------------------------------------------------

Process pez(x,y);

Private

    fuerza;
    gravity=1;        // Gravedad es el nombre de un proceso!
    int contfor;     // Contador para el bucle for
    beta;
    contador=50;

Begin

    flags=father.flags;
    file=graficos_fase;
    graph=011;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-9;
    fuerza=rand(14,20);

    Loop
        graph++;
        If (graph>018)
                graph=011;
        End
        If (flags==0)
                x=x+2;
        Else
                x=x-2;
        End
        y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (y>224)
                     lava2(x,200);
                       suena_sonido(s_splash,256,256);
                       signal(id,s_kill);    // Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        If (collision (type latigo));
                play_wav(s_estrella,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        explosion(x,y);
                        explosion2b(x,y);
                    Break;
                End
            End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para reproducir sonidos
// Entradas: 'x'          Identificador del sonido
//           'volumen'    Volumen del sonido
//           'frecuencia' Frecuencia del sonido
//-----------------------------------------------------------------------------

Process suena_sonido(x,volumen,frecuencia);

Begin
    // Si el grafico esta dentro de la pantalla realiza el sonido
    If (NOT (out_region(father,0)))
        play_wav(x,0);
    End
End

//------------------------------------------------------------------------------
// Proceso para poner objetos de chapuzon de agua
// Entradas: 'x' 'y' Coordenadas del objeto
//------------------------------------------------------------------------------

Process chapuzon(x,y);

Begin
    file=graficos_fase;
    ctype=c_scroll;     // Pon el objeto dentro del scroll
    // Realiza la animacion de los graficos
    From graph=250 To 258;
    Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos arania
// Entradas: 'x' 'y'  Coordenadas del objeto
//           'height' Altura del objeto
//-----------------------------------------------------------------------------

Process arania(x,y,height);

Private
    contador;                             // Contador de uso general

Begin
    file=graficos_general;
    z=-11;
    ctype=c_scroll;                // Hace que este dentro del scroll
    graph=330;                     // Elige el grfico inicial
    height=(height/4)*4;           // Hace height mltiplo de cuatro

    Loop
        From contador=0 To 47;
            // Realiza la animacion de la arania de vez en cuando (rand)
            If (rand(0,10)==0)
                graph++;
                If (graph>335) graph=330; End
            End
            Frame;
        End

        // Haz el sonido de la arania
        //suena_sonido(s_arania,200,256);
        // Baja el objeto de 4 en 4 con el grafico inmovil
        For (contador=0;contador<height;contador+=4);
            y+=4;
            Frame;
        End

        // Sube el objeto de 1 en 1 con animacion de graficos
        For (contador=0;contador<height;contador++);
            y--;
            ++graph;
            If (graph>335)
                graph=330;
            End
            Frame;
        End
    End
End

//-----------------------------------------------------------------------------
// Proceso para los objetos de las cadenas
// Entradas: 'x' 'y' Coordenadas del objeto
//           'ang'   Angulo inicial del objeto
//           'iang'  Velocidad de incremento dentro del angulo
//           'foco'  Tamao total de angulo (min-max)
//-----------------------------------------------------------------------------

Process cadena(x,y,ang,iang,foco);

Begin
    file=graficos_general;
    priority=10;      // Pone un poco menos de prioridad que la plataforma
    ctype=c_scroll;   // Pone el grafico dentro del scroll
    graph=69;         // Coge el grafico de la cadena
    z=20;             // Pone el grafico por detras de la plataforma
    plataforma();     // Crea una plataforma

    Loop
        ang+=iang;    // Incrementa el angulo
        // Coge el angulo del coseno para hacer movimiento pendular con distintas velocidades
        angle=get_distx(ang,foco);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para objetos plataformas
//-----------------------------------------------------------------------------

Process plataforma()

Begin
    file=graficos_general;
    priority=9;         // Pone mas prioridad que a la cadena
    ctype=c_scroll;     // Pone el objeto dentro del scroll
    graph=70;           // Coge el grafico de la plataforma
    z=19;               // Pone el grafico por encima de la cadena

    Loop
        // Coge las coordenadas de la plataforma respecto a la cadena
        velocidad=father.x+get_distx(father.angle-pi/2,200)-x;
        x+=velocidad;
        y=father.y+get_disty(father.angle-pi/2,200);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para objetos de plataformas metalicas
// Entradas: 'x1' 'y1' Coordenadas iniciales de la plataforma
//           'x2' 'y2' Coordenadas finales de la plataforma
//           'ipaso'   Incremento (velocidad) en %
//-----------------------------------------------------------------------------

Process plataforma_metal(x1,y1,x2,y2,ipaso,_on);

Private
    paso;                    // Contador de proceso de movimiento (indica por donde va)

Begin
    file=graficos_general;
    priority=10;             // Le da una prioridad baja
    ctype=c_scroll;          // Pone el grfico en el scroll
    graph=012;               // Elige el grafico de la plataforma metalica
    x=x1;                    // Introduce las coordenadas iniciales
    y=y1;
    z=1;

    Loop
        If (collision(type latigo) and tipolatigo==1 and _on==false)
                _on=true;
            explosion6();
        End

        If (collision(type bomba2) and _on==false)
                _on=true;
            explosion6();
        End

        If (_on==true)
                // Actualiza las nuevas coordenadas
                x=(x1*paso+x2*(100-paso))/100;
                y=(y1*paso+y2*(100-paso))/100;
                // Suma el incremento necesario
                paso+=ipaso;
                // Si se ha llegado al cien por cien
                If (paso MOD 100==0)
                        ipaso=-ipaso;              // Cambia la direccion
                End
                        graph++;
                If (graph>13)
                    graph=12;
                End
        Else
                x=x2;
                y=y2;
                graph=012;
        End
    Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para objetos de plataformas de madera
// Entradas: 'x1' 'y1' Coordenadas iniciales de la plataforma
//           'x2' 'y2' Coordenadas finales de la plataforma
//           'ipaso'   Incremento (velocidad) en %
//-----------------------------------------------------------------------------

Process plataforma_madera(x1,y1,x2,y2,ipaso);

Private
    paso;            // Contador de proceso de movimiento (indica por donde va)

Begin
    file=graficos_general;
    priority=10;     // Le da una prioridad baja
    ctype=c_scroll;  // Pone el grafico en el scroll
    graph=079;       // Elige el grafico de la plataforma metalica
    x=x1;            // Introduce las coordenadas iniciales
    y=y1;
    z=1;

    Loop
        // Actualiza las nuevas coordenadas
        x=(x1*paso+x2*(100-paso))/100;
        y=(y1*paso+y2*(100-paso))/100;
        // Suma el incremento necesario
        paso+=ipaso;
        // Si se ha llegado al cien por cien
        If (paso MOD 100==0)
            ipaso=-ipaso;              // Cambia la direccion
        End
    Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para poner las plataformas del nivel final

// Entradas: 'file'  fichero de graficos que se usa
//           'graph' numero de grafico
//           'x' 'y' Coordenadas 'x' e 'y' del grfico
//           'z'     Profundidad del grafico en pantalla
//           'ctype' Variable para ver si esta dentro del scroll
//-----------------------------------------------------------------------------

Process plataforma2(file,graph,x,y,z,ctype);

Begin
    Loop
        If (collision (Type bomba2))
                platout(graficos_fase,017,x,y,z-1,ctype);
                play_wav(s_super,0);
                play_wav(s_bang,0);
                explosion(rand(x-48,x+48),rand(y-24,y+24));
                explosion(rand(x-48,x+48),rand(y-24,y+24));
                explosion3(rand(x-48,x+48),rand(y-24,y+24),100);
                explosion3(rand(x-48,x+48),rand(y-24,y+24),100);
                explosion3(rand(x-48,x+48),rand(y-24,y+24),100);
                Frame(600);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para expulsar al prota de una plataforma si esta se destruye
//-----------------------------------------------------------------------------

Process platout(file,graph,x,y,z,ctype);

Private

        contador=8;

Begin
        Loop
                contador--;
                If (contador==0)
                        Break;
                End
                Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para el objeto fuego
// Entradas: 'x' 'y' Coordenadas del objeto
//           'inc'   Maximo movimiento que realizara el objeto
//-----------------------------------------------------------------------------

Process fuego(x,y,inc)

Private
    contador;                           // Contador de uso general

Begin
    file=graficos_general;
    ctype=c_scroll;                     // Pon el grfico dentro del scroll
    Loop
        graph=0;                        // Elige un grfico nulo
        flags=0;                        // Sin ningn tipo de efecto espejo
        From contador=0 To 23;          // Pon 24 grficos
            Frame;
        End

        graph=420;                      // Elige grfico inicial
        suena_sonido(s_laser,50,128);   // Haz sonido de toque

        For (contador=-inc;contador<=inc;contador++);        // Realiza movimiento hasta el incremento (subida)
            If (graph==420)             // Alterna los grficos
                graph=421;              // Si esta quitado lo pone
            Else                        // Y si esta puesto
                graph=420;              // Lo quita
            End
            If (contador==1)            // Si ha llegado arriba
                flags=2;                // Da la vuelta al grfico (mirando hacia abajo)
            End
            Frame;
            y+=contador;                // Mueve objeto
        End

    End
End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la barra de energia
//-----------------------------------------------------------------------------

Process barra_energia();

Begin
    file=graficos_general;
    graph=83;                                   // Elige el grafico inicial
    x=82;                                          // Pon coordenadas
    y=260;
    z=-512;                                   // Pon la barra por encima de los graficos
    ctype=0;

    While (energia_enemigo>0)                   // Mientras se tenga energia
        // Sube barra energia desde fuera de la pantalla a su posicion
        If (y>225)
            y--;
        Else
          If (region!=10)                       // Si no tiene region creala
            region=10;
            objeto(graficos_general,84,82,225,-511,0);         // Crea detras el grafico de la barra vacia
          End
        End
        // Define la region respecto al tamanio de la barra de energa
        // y asi solo ver la zona que representa a la misma
        define_region(10,2,215,energia_enemigo,20);
        //define_region(int REGION, int X, int Y, int WIDE, int HIGH)
        Frame;
    End

    // Elimina el proceso de la barra que hay detras (barra vacia)
    signal(son,s_kill);
End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la conexion bola de pinchos
// Entradas: 'x' 'y' Coordenadas del objeto
//-----------------------------------------------------------------------------

Process bola_pin(x,y)

Begin
    file=graficos_fase;                    // Elige el primer fichero de grficos
    graph=20;                  // Elige el grafico inicial
    ctype=c_scroll;            // Pone el objeto dentro del scroll
    priority=100;              // Pone la prioridad baja para ligar a la cadena
    cadena_bola(id,20);        // Crea cadena de pinchos
    z=-20;                     // Pone por encima de la pantalla

    Loop
        angulo2+=pi/64;        // Mueve la cadena y la bola de pinchos
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto de cadena de bola de pinchos
// Entradas: 'primero'     Identificador a la conexion
//           'distancia'  Distancia a la conexion
//-----------------------------------------------------------------------------

Process cadena_bola(primero,distancia)

Begin
    file=graficos_fase;                             // Elige el primer fichero de grficos
    graph=21;                           // Elige el grfico inicial
    ctype=c_scroll;                     // Pone el objeto dentro del scroll
    z=-10;                              // Pone la cadena por detrs de la conexion

    If (distancia<80)                       // Si el tamanio restante es lo suficientemente grande
        cadena_bola(primero,distancia+20);  // Crea otra bola de cadena
    Else
        bola_final(primero,distancia+32);   // Si no crea la bola de pinchos final
    End

    Loop
        angulo2=primero.angulo2;                     // Coge el angulo de la conexion
        x=primero.x+get_distx(angulo2,distancia);    // Halla las coordenadas respecto
        y=primero.y+get_disty(angulo2,distancia);    // a la conexion y al angulo
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la bola de pinchos final
// Entradas: 'primero'     Identificador a la conexion
//           'distancia'  Distancia a la conexion
//-----------------------------------------------------------------------------

Process bola_final(primero,distancia)

Begin
    file=graficos_fase;                                      // Elige el fichero de grficos 1
    graph=22;                                    // Pon el grfico inicial
    ctype=c_scroll;                              // Dentro del scroll
    z=-20;                                       // Por delante de la cadena

    Loop
        angulo2=primero.angulo2;                    // Coge el angulo de la conexion
        x=primero.x+get_distx(angulo2,distancia);   // Actualiza coordenadas respecto a
        y=primero.y+get_disty(angulo2,distancia);   // la distancia a la conexion y el angulo
        // Haz sonido de estrellas;
        suena_sonido(s_estrella,10,768);
        Frame;
    End

End

//----------------------------------------------------------------------
// Proceso titulo
//----------------------------------------------------------------------

Process titulo(graph,x,y,z);

Begin
    file=graficos_general;
    Size=200;
    Repeat
        //angle+=pi/36;
        size+=-4;
        Frame;
    Until (size==100)
    Loop
        Frame;
    End

End
//----------------------------------------------------------------------
// Proceso tormenta
//----------------------------------------------------------------------

Process tormenta(gr,x,y,z);

Begin
    file=graficos_general;

    graph=gr;
    Loop
        If (rand(0,15)==0) graph=gr; else graph=0;End
        Frame;
    End
End
//-----------------------------------------------------------------------------
// Proceso para crear el latigo al disparar
// Entradas: 'x' 'y' Coordenadas
//-----------------------------------------------------------------------------

Process latigo(sumax,sumay);

Private
        contador=20;

Begin
    file=graficos_general;
    ctype=c_scroll;
    z=-224;
    flags=father.flags;
    If (tipolatigo==0)
            From graph=151 to 166; x=father.x+sumax;y=father.y+sumay;Frame;End
        Else
            From graph=421 to 436; x=father.x+sumax;y=father.y+sumay;Frame;End
    End

End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de los bichos
// Entradas:  'x' 'y' Coordenadas x e y de objeto
//            'incr_x'    Incremento horizontal (a der. e izq.
//-----------------------------------------------------------------------------

Process bicho(x,y,incr_x,flags);

Private
        contador=0;

Begin
    file=graficos_general;
    graph=71;      // Numero de grafico
    ctype=c_scroll; // Lo mete dentro del scroll
    Loop
        contador=contador+1;
        x+=incr_x;             // Mueve el grafico horizontalmente

        // Si ha llegado al final de la plataforma o colisiona con algo
        If (NOT en_pantalla() or collision (type roca) or collision (type pared))
            incr_x=-incr_x;        // Cambia el incremento horizontal
            x+=incr_x*16;       // Mueve un poco el grafico
            // Da la vuelta al grafico
            If (flags==0)
                flags=1;
            Else
                flags=0;
            End
        End

        // Realiza la animacion de los graficos
        If contador MOD 2 == 0 :
        graph++;
            If (graph>78) graph=71; End; contador=0; End

                If (collision (type latigo));
                        play_wav(s_estrella,0);
                        If (tipolatigo==1)
                                shock(-16);
                        Else
                                explosion(x,y);
                                explosion2b(x,y-16);
                            Break;
                        End
                    End
            If (collision (type super))
                play_wav(s_estrella,0);
                explosion(x,y);
                    explosion2b(x,y-16);
                  Break;
            End
        Frame;
    End
End
//-----------------------------------------------------------------------------
// Proceso para objetos avispa
// Entradas:  'gr'            Tipo de grafico (abejorro/fantasma)
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process avispa(gr,flags,xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;
    contador=30;

Begin
    file=graficos_general;
    graph=gr;            // Elige el grafico inicial apropiado
    ctype=c_scroll;      // haz que este dentro del scroll

    Loop
        contador=contador-1;
        If (contador<0)
                contador=0;
        End
        // Haz un sonido de vez en cuando
        If (rand(0,48)==0)
            // Sonido de fantasmas
            If (flags==4)
                //suena_sonido(s_fantasma,50,256);
            // Sonido de abejorros
            Else
                suena_sonido(s_abeja,150,256);
            End
        End
        If (contador<1)
                If (x<idprota.x)
                        flags=0;
                Else
                        flags=1;
                End
        End

        angulo2+=pi/incx;                 // Halla el tamanio de los incrementos
        angulo3+=pi/incy;                 // que se harn en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los grficos
        graph++;
        If (graph==gr+2)
            graph=gr;
        End
        If (collision (type latigo));
                play_wav(s_estrella,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        explosion(x,y);
                        explosion2b(x,y);
                    Break;
                End
            End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                Break;
        End
        Frame;
    End
End
//-----------------------------------------------------------------------------
// Proceso para objetos escarabajo
// Entradas:  'gr'            Tipo de grafico
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process scarab(gr,flags,x,yrelativa,incx,incy,lado,disty);

Private
    angulo3;
    id2;

Begin
    file=graficos_general;
    graph=gr;            // Elige el grafico inicial apropiado
    ctype=c_scroll;      // haz que este dentro del scroll
    z=-257;

    Loop
        If (rand(0,48)==0)
            suena_sonido(s_scarab,150,256);
        End

                angulo2+=pi/incx;    // Halla el tamanio de los incrementos
                angulo3+=pi/incy; // que se haran en las dos coordenadas

            If (lado==1)
                    x=x+4;
            else
                    x=x-4;
            End                        // Incrementa la coordenada x

                y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

                // Realiza la animacion de los graficos
                graph++;
                If (graph==gr+2)
                    graph=gr;
                End
                If (collision (type latigo));
                        play_wav(s_estrella,0);
                        If (tipolatigo==1)
                                shock(0);
                        Else
                                explosion(x,y);
                                explosion2b(x,y);
                            Break;
                        End
                    End
                If (collision (type super))
                    play_wav(s_estrella,0);
                    explosion(x,y);
                        explosion2b(x,y);
                      Break;
            End
                If((x-idprota.x)>340 or (idprota.x-x)>340)
                    Break;
                End
           Frame;
   End
End

//-----------------------------------------------------------------------------
// Proceso para objetos de garrapatas que escupen
// Entradas: 'x' 'y'  Coordenadas del grafico
//           'flags'  Direccion hacia donde mira el grafico
//           'pausa'  Numero de frames que esta en pausa
//-----------------------------------------------------------------------------

Process garrapata(x,y,flags,pausa);

Private

        int cadenciag;

Begin
    file=graficos_general;
    cadenciag=pausa;
    ctype=c_scroll;                 // Haz que este dentro del scroll
    z=2;                            // Pon al grafico por delante de otros
    graph=64;

    Loop
        cadenciag=cadenciag-1;
        If (cadenciag==12)
                graph=65; End
        If (cadenciag==8)
            graph=66; End
        If (cadenciag==4)
                graph=67;
            suena_sonido(s_laser,50,0);
            disparo_cabeza(x+20-flags*40,y-2,8-flags*16,flags);
            explosion3(x+20-flags*40,y-2,50);
        End
        If (cadenciag==3)
                graph=66; End
        If (cadenciag==2)
                graph=65; End
        If (cadenciag==1)
                graph=64;
                cadenciag=pausa;
        End
        If (collision (type latigo));
                play_wav(s_estrella,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        explosion(x,y);
                        explosion2b(x,y);
                    Break;
                End
            End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                Break;
        End
        Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para lanzamiento de las flechas del topo
// Entradas: 'x' 'y' Coordenadas del objeto
//           'incx'  Incremento horizontal (direccion)
//-----------------------------------------------------------------------------

Process flecha(x,y,incx);

Begin
    ctype=c_scroll;                  // Hace que este dentro del scroll
    file=graficos_fase;
    flags=father.flags;
    graph=300;                    // Elige el grafico apropiado

    Repeat
        If (flags==0)
                x-=incx;                 // Muevelo horizontalmente
        Else
                x+=incx;
        End
        Frame;
    Until (out_region(id,0))      // Hasta que salga de pantalla
End

//-----------------------------------------------------------------------------
// Proceso para lanzamiento de gotas horizontales
// Entradas: 'x' 'y' Coordenadas del objeto
//           'incx'  Incremento horizontal (direccion)
//           'flags' Posicion hacia la que mira el grfico
//                   horizontalmente
//-----------------------------------------------------------------------------

Process disparo_cabeza(x,y,incx,flags);

Begin
    file=graficos_general;
    ctype=c_scroll;                  // Hace que este dentro del scroll
    graph=63;                        // Elige el grafico apropiado

    Repeat
        x+=incx;                         // Muevelo horizontalmente
        Frame;
    Until (out_region(id,0))      // Hasta que salga de pantalla
End

//-----------------------------------------------------------------------------
// Proceso para los disparos del demonio volador
// Entradas: 'x' 'y' Coordenadas del objeto
//           'incx'  Incremento horizontal (direccion)
//           'flags' Posicion hacia la que mira el grfico
//                   horizontalmente
//-----------------------------------------------------------------------------

Process disparo_demon(x,y,incx,flags);

Begin
    file=graficos_general;
    ctype=c_scroll;                  // Hace que este dentro del scroll
    graph=220;                    // Elige el grafico apropiado

    Repeat
        x+=incx;                         // Muevelo horizontalmente
        Frame;
    Until (out_region(id,0))      // Hasta que salga de pantalla
End

//-----------------------------------------------------------------------------
// Proceso para el Final Boss de la fase 1
// Entradas:  'gr'            Tipo de grafico
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process bigboss(gr,flags,xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;
    contador=30;                     // Contador para esperar a que el prota est listo
    contador2=30;         // Contador que determina la pauta del disparo 1
    ataque=400;
    beta;                     // Variable 0 o 1 para los ataques aleatorios
    toque=16;                // Contador para los impactos del ltigo

Begin
    file=graficos_fase;
    graph=gr;                // Elige el grafico inicial apropiado
    ctype=c_scroll;          // haz que este dentro del scroll

    While (energia_enemigo>0)               // Mientras se tenga energia
        toque+=1;
        If (toque>16)
                toque=16;
        End
        contador=contador-1;
        contador2=contador2-1;
        ataque=ataque+1;
        If (contador<0)
                contador=0;
        End
        If (contador2<0)
                contador2=60;
        End
        If (ataque>2610)
                ataque=0;
        End

    If (ataque<830)

        // Haz un sonido de vez en cuando
        If (rand(0,48)==0)
                suena_sonido(s_scarab,150,256);
        End
        If (contador<1)
                If (x<idprota.x)
                        flags=0;
                Else
                        flags=1;
                End
        End
        If (x<(idprota.x-48) or x>(idprota.x+48))
                gr=4;
        Else
                gr=6;
        End

        angulo2+=pi/incx;                 // Halla el tamanio de los incrementos
        angulo3+=pi/incy;                 // que se harn en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los graficos
        graph++;
        If (graph==gr+2 or graph==gr+4)
            graph=gr;
        End
        If (x>64 and x<448)
                If (contador2==5 or contador2==10 or contador2==15 or contador2==20 or contador2==25)
                        play_wav(s_fiu,0);
                        loquesea(x,y+20);
                End
        End

    End
    If (ataque>830 and ataque<1050)
            y=y-4;
        If ataque MOD 2 == 0 :
                graph=6;
        Else
                graph=7;
        End
    End

    If (ataque>750 and ataque<1500)
            If ataque MOD 50 == 0 :
                If (rand(0,1)==0)
                        scarab(91,0,idprota.x-300,idprota.y-64,24,24,1,48);
                Else
                        scarab(91,1,idprota.x+300,idprota.y-64,24,24,0,48);
                End
        End
    End

    If (ataque>1450 and ataque<1455)
            graph=11;
            beta=rand(0,1);
    End

    If (ataque>1455 and ataque<1460)
            y=180;
            If (beta==0);
                    x=-32;
                flags=0;
        Else
                x=544;
                flags=1;
        End
    End

    If (ataque>1460 and ataque<1500)
            If (beta==0);
                    x=x+2;
            Else
                    x=x-2;
            End
    End

    If (ataque>1500 and ataque<2500)
        If (collision(type latigo))
                If (toque==16)
                             graph=12;
                             toque=0;
                         play_wav(s_estrella,0);
                        If (tipolatigo==1)
                                explosion(x,y);
                            energia_enemigo-=5;
                        Else
                                explosion(x,y);
                            energia_enemigo-=10;

                        End
                     Else
                             graph=8;
                     End
        End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                energia_enemigo-=3;
        End
        If (beta==0);
                If ataque MOD 20 == 0 :
                        play_wav(s_laser,0);
                        parabolico(x+10,y+20,0);
                    graph=8;
                End
                If (graph<11)
                    graph++;
                End
        Else
            If ataque MOD 20 == 0 :
                        play_wav(s_laser,0);
                        parabolico(x-10,y+20,1);
                    graph=8;
                End
                If (graph<11)
                    graph++;
                End
        End
    End

    If (ataque>2500 and ataque<2540)
        If (beta==0);
                    x=x-2;
            Else
                    x=x+2;
            End
    End

    If (ataque>2540 and ataque<2546)
            x=xrelativa+get_distx(angulo2,distx);                // Incrementa la coordenada x
        y=(yrelativa+get_disty(angulo3,disty))-256;        // Incrementa la coordenada y
    End

    If (ataque>2546 and ataque<2610)
        y=y+4;
        If ataque MOD 2 == 0 :
                graph=6;
        Else
                graph=7;
        End
    End
        Frame;
    End
    muertebigboss(x,y);
    signal(id,s_kill);
End

//-----------------------------------------------------------------------------
// Proceso para las plantas que escupen
// Entradas: 'x' 'y'  Coordenadas del grafico
//           'pausa'  Numero de frames que esta en pausa
//-----------------------------------------------------------------------------

Process planta(x,y,pausa,x1,x2,xb1,xb2);

Private

        int temp;
    BYTE vida=3;        //este personaje necesita cinco toques para morir
        BYTE temp2=17;        //para que la roca slo pueda recibir un latigazo por x tiempo

Begin
    file=graficos_general;
    temp=pausa;
    ctype=c_scroll;                 // Haz que este dentro del scroll
    z=-20;                          // Pon al grafico por delante de otros
    graph=94;

    Loop
        temp=temp-1;
        If(idprota.x>x1 and idprota.x<x2 and idprota.y>y-95 and idprota.y<y+20)    //si el prota est en un area delimitada por x1,x2
                If(idprota.x<x)                             //si el prota est caminando a la derecha
                    If(idprota.x>xb1 and idprota.x<xb2)
                            idprota.x=xb1;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                Else                                                     //si camina hacia la izquierda
                       If(idprota.x<xb2 and idprota.x>xb1)
                            idprota.x=xb2;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                End
            End

        If (temp==8 or temp==16 or temp==24 or temp==32 or temp==40)
                graph=93; End
        If (temp==7 or temp==15 or temp==23 or temp==31 or temp==39)
            graph=94; End
        If (temp==6 or temp==14 or temp==22 or temp==30 or temp==38)
                graph=95; End
        If (temp==5 or temp==13 or temp==21 or temp==29 or temp==37)
                graph=96;
            suena_sonido(s_laser,50,0);
            parabolico2(x,y-80);
        End
        If (temp==4 or temp==12 or temp==20 or temp==28 or temp==36)
                graph=95; End
        If (temp==3 or temp==11 or temp==19 or temp==27 or temp==35)
                graph=94; End
        If (temp==2 or temp==10 or temp==18 or temp==26 or temp==34)
                graph=93; End
        If (temp==1 or temp==9 or temp==17 or temp==25 or temp==33)
                graph=94;
        End
        If (temp==0)
                temp=pausa;
        End

        If(temp2<17)
           temp2++;
           graph=94;
        End

        //colisin con el ltigo
        If (collision (type latigo) && temp2==17);
              If (tipolatigo==0)
                                If (vida>0)
                                      play_wav(s_golpe,0);
                              vida--;
                              temp2=0;
                              graph=97;
                                Else
                                      play_wav(s_golpe,0);
                              explosion(x,y-32);
                              explosion2(x,y-32,120);
                              explosion2b(x-16,y-32);
                              explosion(x+16,y-48);
                  Break;
                      End
                Else
                      If(!exists(type explosion3))
                              explosion3(rand(x-20,x+20),rand(y-64,y),100);
                              explosion3(rand(x-20,x+20),rand(y-64,y),100);
                              explosion3(rand(x-20,x+20),rand(y-64,y),100);
                              play_wav(s_estrella,0);
                      End
                End
                End
        If (collision (type super))
                      play_wav(s_golpe,0);
              explosion(x,y-32);
              explosion2(x,y-32,120);
              explosion2b(x-16,y-32);
              explosion(x+16,y-48);
              Break;
        End
        Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para las bolas "switch"
// Entradas:  'gr'            Tipo de grafico
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process bola1(x,yrelativa,incy,disty);

Private
    angulo3;
    id2;
    contador=0;
    tocado=0;

Begin
    file=graficos_general;
    z=200;
    If (tipolatigo==1)
            graph=437;                 // Elige el grafico inicial apropiado
    End
    If (tipolatigo==0)
            graph=413;
    End
    ctype=c_scroll;          // haz que este dentro del scroll

    Loop
        tocado=tocado-1;
        If (tocado<0)
                tocado=0;
           End
        contador=contador+1;
        angulo3+=pi/incy;
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los graficos
        If (tipolatigo==0);
                If contador MOD 2 == 0 :
                        graph++;
                        If (graph>420)
                            graph=413;
                        End
                        contador=0;
                End
        End
        If (tipolatigo==1);
                If contador MOD 2 == 0 :
                        graph++;
                        If (graph>444)
                            graph=437;
                        End
                        contador=0;
                End
        End
        If (collision (type latigo) and tocado==0);
                play_wav(s_estrella,0);
                explosion3(x,y,100);
            tocado=20;
            If (tipolatigo==0)
                    tipolatigo=1;
                    graph=437;
            Else
                    tipolatigo=0;
                    graph=413;
            End
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para las bolas que suelta el primer "Big Boss"
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process loquesea(x,y);

Private

    fuerza=0;
    gravity=1;//gravedad es el nombre de un proceso!
    int contfor; //contador para el bucle for

Begin
    file=graficos_general;

    graph=68;
    ctype=c_scroll;     // Hace que este dentro del scroll
    priority=2;         // Prioridad uno para actualizar a prota antes que scroll
    z=-256;

    Loop
        y-=fuerza;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (map_get_pixel(graficos_fase,2,x/2,contfor/2)==136)
                     explosion4(x,y,100);

                       play_wav(s_estrella,0);
                       signal(id,s_kill);                                    // Elimina el proceso actual
                       Break;
                   End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los proyectiles parablicos que suelta el primer "Big Boss"
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process parabolico(x,y,flags);

Private

    fuerza=12;
    gravity=1;//gravedad es el nombre de un proceso!
    int contfor; //contador para el bucle for
    beta;
    contador=50;

Begin

    file=graficos_general;
    beta=rand(0,10);
    graph=80;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;

    Loop
        explosion3(x,y,100);
        If (flags==0)
                x+=beta;
        Else
                x-=beta;
        End
        y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (map_get_pixel(graficos_fase,2,x/2,contfor/2)==136)
                     explosion4(x,y,100);
                       play_wav(s_estrella,0);
                       signal(id,s_kill);                                    // Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los proyectiles que suelta los goblins voladores
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process parabolico3(x,y);

Private

    fuerza=12;
    gravity=1;        // Gravedad es el nombre de un proceso!
    int contfor;     // Contador para el bucle for
    beta;
    contador=50;

Begin

    file=graficos_general;
    beta=rand(0,10);
    graph=98;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;

    Loop
        If contador MOD 2 == 0 :
                explosion2(x,y,100);
        End
        If (father.flags==1)
                x+=beta;
        Else
                x-=beta;
        End
        y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (map_get_pixel(graficos_fase,2,x/2,(contfor/2)+4)==136)
                     salplava(y-16);
                       suena_sonido(s_estrella,256,256);
                       signal(id,s_kill);    // Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Hacha que lanza el ogro, movimiento parablico
// Entradas:  'x' e 'y'       Coordenadas (Masteries, basado en el proceso anterior)
//-----------------------------------------------------------------------------

Process hacha(x,y,flags)

Private

    fuerza=8;
    gravity=1;//gravedad es el nombre de un proceso!
    int contfor; //contador para el bucle for
    contador=50;

Begin

    file=graficos_general;
    angle=rand(0,200000);
    graph=89;
    ctype=c_scroll;     // Hace que est dentro del scroll
    z=-512;

    Loop
        estela(x,y,100);
        If (flags==0)
                x-=10;
                angle += 30000;
                        if(angle=>360000)
                           angle=0;
                        end
        Else
                x+=10;
                angle -= 30000;
                        if(angle=<-360000)
                           angle=0;
                        end
        End
                y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (map_get_pixel(graficos_fase,2,x/2,contfor/2)==136)
                       //play_wav(s_hacha,0);
                       angle=0;
                       graph=90;
                       frame(6000);//permanece un poco en el suelo antes de desaparecer
                       signal(id,s_kill);// Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los proyectiles parablicos que lanza la planta
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process parabolico2(x,y);

Private

    fuerza=12;
    gravity=1;//gravedad es el nombre de un proceso!
    int contfor; //contador para el bucle for
    beta;
    contador=50;

Begin

    file=graficos_general;
    beta=rand(-6,6);
    graph=259;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;

    Loop
        salpicon(x,y,100);
        x+=beta;
        y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (map_get_pixel(graficos_fase,2,x/2,contfor/2)==136)
                     exploverde(x,y,100);
                       suena_sonido(s_estrella,150,256);
                       signal(id,s_kill);                                    // Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        Frame;
    End
End

//------------------------------------------------------------------------------
// Proceso de electrocucin de los enemigos
//------------------------------------------------------------------------------

Process shock(incy);

Private

    contador=100;

Begin

    file=graficos_general;
    //play_wav(s_queja,0);
    signal(father,s_sleep); // Duerme al proceso padre

    ctype=c_scroll;     // Hace que este dentro del scroll
    flags=father.flags; // Coge las banderas (izq./der.) que tenia el padre
    x=father.x;
    y=father.y;
    z=(father.z-1);
    graph=father.graph;
    angle=father.angle;

    Loop
        contador=contador-1; // Empieza a contar hacia atrs

        If (contador%2==0)
                x+=2;
                y-=1;
        Else
            x-=2;
            y+=1;
        End

        If (contador==98 or contador==58 or contador==18)
                explosion5(x,(y+incy),rand(60,120),0);
        End

        If (contador==78 or contador==38)
            explosion5(x,(y+incy),rand(60,120),1);
        End

            If (contador==0)
                    signal(father,s_wakeup);                              // Despierta el proceso anterior (el padre)
                father.x=x;                                           // Actualiza coordenada x
                father.y=y;                                           // Actualiza coordenada y
                father.flags=flags;                                   // Actualiza banderas (izq./der.)
                signal(id,s_kill);                                    // Elimina el proceso actual
                Frame;
            End

        Frame;
    End

End

//------------------------------------------------------------------------------
// Proceso de impacto de los ogros
//------------------------------------------------------------------------------

Process shock_ogro(incy);


Private

    contador=4;

Begin

    file=graficos_general;
    //play_wav(s_queja,0);
    signal(father,s_sleep); // Duerme al proceso padre

    ctype=c_scroll;     // Hace que este dentro del scroll
    flags=father.flags; // Coge las banderas (izq./der.) que tenia el padre

    x=father.x;
    y=father.y;
    z=(father.z-1);
    graph=father.graph;

    Loop
        contador=contador-1; // Empieza a contar hacia atrs

        If (contador%2==0)
                x+=2;
                y-=1;
        Else
            x-=2;
            y+=1;
        End

            If (contador==0)
                    signal(father,s_wakeup);                              // Despierta el proceso anterior (el padre)
                father.x=x;                                           // Actualiza coordenada x
                father.y=y;                                           // Actualiza coordenada y
                father.flags=flags;                                   // Actualiza banderas (izq./der.)
                signal(id,s_kill);                                    // Elimina el proceso actual
                Frame;
            End

        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para la muerte del primer "Big Boss"
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process muertebigboss(x,y);

Private

    fuerza=18;
    gravity=1;                    //gravedad es el nombre de un proceso!
    contador=90;

Begin

    flags=father.flags;
    file=graficos_fase;
    graph=4;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-100;

    Loop
        If (rand(0,3)==0)
                play_wav(s_estrella,0);
        End

        If (flags==0)
                x+=5;
        Else
                x-=5;
        End

        y-=fuerza/4;
            contador-=1;
            fuerza-=gravity;
        explosion((x+rand(-50,50)),(y+rand(-50,50)));
             explosion2((x+rand(-50,50)),(y+rand(-50,50)),100);
             If (contador==0)
                 fin_nivel=true;
                 Break;
             End

             Frame;

    End
    signal(id,s_kill);
End

//-----------------------------------------------------------------------------
// Proceso para los bichos de las paredes (version saltarn)
// Entradas: 'x' 'y' Coordenadas, 'flags' dnde se encaran/direccin del salto
//-----------------------------------------------------------------------------

Process bichopared(x,y,flags);

Private

        contador=0;
    salto=false;
    fuerza=16;
    gravity=1;//gravedad es el nombre de un proceso!

Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=446;              // Pon el grafico inicial del grafico

    Loop                    // Realiza la animacion de los graficos
        contador=contador+1;

        If(idprota.y<(y+20) and idprota.y>(y-10))
                    If(flags==0)
                          If(idprota.x>x and idprota.x<(x+100))
                                salto=true;
                          End
                    Else
                          If(idprota.x<x and idprota.x>(x-100))
                                salto=true;
                          End
                    End
              End

        If (salto==false)
                If contador MOD 2 == 0 :
                graph++;
                        If (graph>453)
                            graph=446;
                        End
                        contador=0;
                End
        Else
            graph=445;
                    If(flags==0)
                            x+=4;
                            angle-=7000;
                    Else
                            x-=4;
                            angle+=7000;
                    End
                    y-=fuerza;
                    fuerza-=gravity;
                    If ((y-idprota.y)>200)
                            Break;
                    End
        End

        If (collision (type latigo));
                play_wav(s_estrella,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        explosion(x,y);
                        explosion2b(x,y);
                    Break;
                End
            End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
                explosion2b(x,y);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para las garras del desierto
// Entradas: 'x' 'y' Coordenadas, 'flags' dnde se encaran/direccin del salto
//-----------------------------------------------------------------------------

Process garra(x,y,flags,angle);
Private
    contador=0;
    salto=false;

Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=247;              // Pon el grafico inicial del grafico

    Loop                    // Realiza la animacion de los graficos
        contador++;
        If (contador>60) contador=0; End
        If(idprota.x<(x+100) and idprota.x>(x-100) and (contador>30) and (contador<60))
            salto=true;
        End

        If (salto==false)
            graph=247;
        Else
            If (contador%2 == 0)
                graph++;
                If (graph>258)
                    graph=247;
                    salto=false;
                End
                contador=0;
            End
        End

        If (collision (type latigo));
            play_wav(s_estrella,0);
            If (tipolatigo==1)
                shock(0);
            Else
                explosion(x,y);
                explosion2b(x,y);
                Break;
            End
        End
        If (collision (type super))
            play_wav(s_estrella,0);
            explosion(x,y);
            explosion2b(x,y);
            Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para las rocas-trampa del desierto
// Entradas: 'x' 'y' Coordenadas, 'flags' dnde se encaran/direccin del salto
//-----------------------------------------------------------------------------

Process roca(x,y,x1,x2,xb1,xb2);
Private
    salto=false;
    BYTE vida=3;        //este personaje necesita cinco toques para morir
    BYTE temp=17;        //para que la roca slo pueda recibir un latigazo por x tiempo


Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=276;              // Pon el grafico inicial del grafico

    Loop                    // Realiza la animacion de los graficos
        If(idprota.x<(x+100) and idprota.x>(x-100))
            salto=true;
        Else
            salto=false;
        End

        If (salto==false and graph<>276)
            graph--;
            If (graph<276)
                graph=276;
            End
        End

        If (salto==true)
            graph++;
            If (graph>289)
                graph=289;
            End
            If(idprota.x>x1 and idprota.x<x2 and idprota.y>y-100 and idprota.y<y+20)    //si el prota est en un area delimitada por x1,x2
                If(idprota.x<x)                             //si el prota est caminando a la derecha
                    If(idprota.x>xb1 and idprota.x<xb2)
                        idprota.x=xb1;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                Else                                                     //si camina hacia la izquierda
                    If(idprota.x<xb2 and idprota.x>xb1)
                        idprota.x=xb2;
                    End                                             //si el prota est en la zona bloqueada ponlo fuera
                End
            End
        End
        If(temp<17)
           temp++;
           //graph=276;
        End

        //colisin con el ltigo
        If (collision (type latigo) && temp==17);
            If (tipolatigo==0)
                If (vida>0)
                    graph=290;
                    play_wav(s_roca,0);
                    vida--;
                    temp=0;
                Else
                    play_wav(s_roca,0);
                    explosion(x,y-32);
                    explosion2(x,y-32,120);
                    explosion2b(x-16,y-32);
                    explosion(x+16,y-48);
                    rocas(x,y);
                    rocas(x,y);
                    rocas(x,y);
                    rocas(x,y);
                    rocas(x,y);
                    Break;
                End
            End
        End
        If (collision (type super))
            play_wav(s_roca,0);
            explosion(x,y-32);
            explosion2(x,y-32,120);
            explosion2b(x-16,y-32);
            explosion(x+16,y-48);
            rocas(x,y);
            rocas(x,y);
            rocas(x,y);
            rocas(x,y);
            rocas(x,y);
            Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para goblins voladores
// Entradas:  'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process goblin(xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;
    contador=30;         // Espera a que el prota est listo
    contador2=75;

Begin
    file=graficos_general;
    graph=87;            // Elige el grafico inicial apropiado
    ctype=c_scroll;      // haz que este dentro del scroll

    Loop
        contador=contador-1;
        contador2++;
        If (contador2>75)
                contador2=0;
        End
        If (contador<0)
                contador=0;
        End
        // Haz un sonido de vez en cuando
        If (rand(0,48)==0)
            If (flags==4)
            Else
                suena_sonido(s_scarab,150,256);
            End
        End

        If (contador2==70 or contador2==75)
                suena_sonido(s_laser,256,256);
                parabolico3(x,y);
        End

        If (contador<1)
                If (x<idprota.x)
                        flags=1;
                Else
                        flags=0;
                End
        End

        angulo2+=pi/incx;                 // Halla el tamanio de los incrementos
        angulo3+=pi/incy;                 // que se harn en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los graficos
        graph++;
        If (graph==89)
            graph=87;
        End
        If (collision (type latigo));
                play_wav(s_bang,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        suena_sonido(s_bang,256,256);
                        explosion(x,y);
                        explosion2b(x,y);
                    Break;
                End
            End
        If (collision (type super))
            suena_sonido(s_bang,256,256);
            explosion(x,y);
                explosion2b(x,y);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los cascotes cuando se destruyen las rocas
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process rocas(x,y);

Private
    fuerza=12;
    gravity=1;        //gravedad es el nombre de un proceso!
    beta;
    contador=50;

Begin
    file=graficos_general;
    beta=rand(-5,5);
    graph=rand(291,294);
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;

    Loop
                x+=beta;
        y-=(fuerza+rand(0,5));
            contador-=1;
            fuerza-=gravity;
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el super ataque
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process super(x,y);
Private
    contador=20;
Begin
    file=graficos_general;
    ctype=c_scroll;
    z=-509;
    graph=60;
    flags=father.flags;
    
    rumba(0, 600);

    Loop
        contador--;
        If (contador==2)
            explosion2b(x,y+32);
        End
        If (contador==8)
            explosion2b(x+16,y+20);
        End
        If (contador==11)
            explosion2b(x-6,y+16);
        End
        If (contador==5)
            explosion2b(x-12,y+12);
        End
        If (contador==14)
            explosion2b(x,y);
        End
        If (contador==17)
            explosion2b(x,y-8);
        End
        If (flags==0)
            angle=angle-18000;
            x=father.x+8;
            y=father.y-32;
        Else
            angle=angle+18000;
            x=father.x-8;
            y=father.y-32;
        End

        If (contador==0)
            signal(id,s_kill);
            Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los frascos de vida
// Entradas:  'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incy'   Frecuencia de giro en los dos ejes
//            'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------
Process powerup(x,yrelativa,incy,disty);
Private
    angulo;
    contador=0;

Begin
    file=graficos_general;
    graph=61;                 // Elige el grafico inicial apropiado
    ctype=c_scroll;          // haz que este dentro del scroll

    Loop
        contador=contador+1;
        angulo+=pi/incy;
        y=yrelativa+get_disty(angulo,disty);    // Incrementa la coordenada y
    Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los frascos de energia del superataque
// Entradas:  'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incy'   Frecuencia de giro en los dos ejes
//            'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process redjar(x,yrelativa,incy,disty)

Private
    angulo;
    contador=0;

Begin
    file=graficos_general;
    graph=62;                 // Elige el grafico inicial apropiado
    ctype=c_scroll;          // haz que este dentro del scroll

    Loop
        contador=contador+1;
        angulo+=pi/incy;
        y=yrelativa+get_disty(angulo,disty);    // Incrementa la coordenada y

    Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el agua de los pantanos
// Entradas:  'tipo'
//-----------------------------------------------------------------------------

process agua(byte tipo,int graph,int x,int y,int z)
begin
   file=graficos_fase;
   flags=128;
   ctype=c_scroll;
   switch(tipo)
      case 0://animacin del agua del lago
         loop
         z=512;//al fondo
         x=1;
         y=281;
         from graph=10 to 29;
            frame;
            frame;
         end
      end
      end
      case 1://sprite fijo que oculta de forma parcial al personaje
         z=-10;//al frente
         x=0;
         y=293;
         graph=40;
         loop
            frame;
         end
      end
      case 3:
         loop
            frame;
         end
      end
   end
end

//-----------------------------------------------------------------------------
// Proceso que dibuja el efecto que provoca el personaje en el agua
// Entradas:  'effect'
//                        'ind'
//-----------------------------------------------------------------------------

process drawwatereffect(BYTE effect,BYTE ind)
begin
ctype=c_scroll;
file=graficos_fase;
x=father.x;
switch(effect)
    case 0:
                z=-11;
                if(nivel==13)
                   y=father.y-23;//-32
                end
                if(nivel==12)
                   y=father.y-25;
                end
                switch(twef[ind])
                      case 0..2:
                         graph=200;
                      end
                      case 3..5:
                         graph=201;
                      end
                      case 6..8:
                         graph=202;
                      end
                      case 9..11:
                         graph=203;
                      end
                      case 12:
                         graph=200;
                         twef[ind]=0;
                      end
                end//fin switch
                twef[ind]++;
        frame;
    end
    case 5://efecto de saltar en el agua
        //play_wav(s[9],0);
        z=-12;//-11
        //y=father.y-23;
        if(nivel==13)
          y=287;//fix
        end
        if(nivel==12)
          y=205;
        end
        graph=250;
        while(graph<258)
           graph++;//graph inicial es 215
           frame;
           frame;
        end
    end
end
end

//-----------------------------------------------------------------------------
// Proceso para el dragn 'Big Boss' del nivel 13
// Entradas:  'x'
//                        'yy'
//-----------------------------------------------------------------------------

process dragon(x,yy);
private
xp;
yp;
tiempo=0;
idllamas;
BYTE reverse=0;
BYTE esquema=1;
BYTE cambiar_esquema=0;
BYTE ready=0;
BYTE ready2=0;
BYTE bolitas=0;
BYTE contador=90;
BYTE gravity=1;
BYTE fuerza=18;
BYTE anim=0;
BYTE pocion=1;
BYTE dir=izq;//vuela/camina hacia la izquierda
BYTE counter=0;
BYTE decision=0;
BYTE serie=1;
begin
ctype=c_scroll;
file=graficos_fase;
graph=100;
flags=0;
bolitas=rand(10,12);
if(dir==izq)
         flags=0;
      else
         flags=1;
end
y=-200;
while(energia_enemigo>0)
   //debug
   //delete_text(idtext);
   //idtext=write(0,100,100,4,counter);
   //control del dao
   If (collision (type super))
      play_wav(s_estrella,0);
      explosion(x,y);
      explosion2b(x,y);
      if(energia_enemigo>40)
      energia_enemigo-=2;
      else
      energia_enemigo-=1;
      end
   End
   If (collision (type latigo))
      play_wav(s_estrella,0);
      explosion((x+rand(-8,8)),(y+rand(-8,8)));
      energia_enemigo-=1;
   End
   If(energia_enemigo<40 && pocion==1)//el Dragn lleva una pocin de salud que se toma cuando est muy dbil
      pocion--;
      estrellas(x,y-60);
      estrellas(x,y-60);
      energia_enemigo += 60;//60
   end
   //comportamiento
   if(cambiar_esquema)
      cambiar_esquema=0;
      switch(esquema)
         case 1:
            esquema=2;
            counter=0;
            if(x>321)
                dir=izq;//debe ir hacia la izquierda
                flags=0;
                get_real_point(1,offset xp,offset yp);
                idllamas=bolita(x,y,2,dir);
            else
                dir=der;//debe ir hacia la derecha
                flags=1;
                get_real_point(1,offset xp,offset yp);
                idllamas=bolita(x,y,2,dir);
            end
         end
         case 3://2
            if(energia_enemigo<91)
                if(rand(0,1))
                   esquema=1;//4
                   bolitas=rand(10,12);
                   if(dir==izq)
                      y=-200;
                      x=90;
                      dir=der;
                      flags=1;
                   else
                      y=-200;
                      x=550;
                      dir=izq;
                      flags=0;
                   end
                else
                   esquema=1;//3
                   bolitas=rand(10,12);
                   if(dir==izq)
                      y=-200;
                      x=90;
                      dir=der;
                      flags=1;
                   else
                      y=-200;
                      x=550;
                      dir=izq;
                      flags=0;
                   end
                end
            else
               esquema=1;//3
               bolitas=rand(10,12);
               if(dir==izq)
                   y=-200;
                      x=90;
                      dir=der;
                      flags=1;
               else
                      y=-200;
                      x=550;
                      dir=izq;
                      flags=0;
               end
            end
         end
         case 2:
            esquema=3;
            decision=0;
            y = 0;
         end
         case 4://no se utiliza
            esquema=1;
            bolitas=rand(10,12);
            graph=100;
         end
         case 5://no se utiliza
            esquema=1;
            bolitas=rand(10,12);
            graph=100;
         end
      end//fin switch
   end


   if(esquema==1)
      if(y<yy)
         y += 4;
      end
      if(ready==25 && y==yy)//ready==45
         ready=0;
         if(energia_enemigo<91)
             if(rand(0,2)==1)
                if(serie==1)
                   get_real_point(1,offset xp,offset yp);
                   bolas_fuego=0;
                   bolita(xp,yp,1,dir);//triples bolitas, 2 de ellas desviadas +/- 45 grados
                   bolas_fuego=1;
                   bolita(xp,yp,1,dir);
                   bolas_fuego=2;
                   bolita(xp,yp,1,dir);
                   serie=2;//sin combinar bolitas de +/-45 y +/-20 el Dragn era muy fcil
                else
                   get_real_point(1,offset xp,offset yp);
                   bolas_fuego=3;
                   bolita(xp,yp,1,dir);//triples bolitas, 2 de ellas desviadas +/- 45 grados
                   bolas_fuego=4;
                   bolita(xp,yp,1,dir);
                   bolas_fuego=5;
                   bolita(xp,yp,1,dir);
                   serie=1;
              end
              bolitas--;
            else
                get_real_point(1,offset xp,offset yp);
                bolas_fuego=0;//elige la desviacin +/- 45 grados de la bolita, 0 es 0 grados de desviacin
                bolita(xp,yp,1,dir);
                bolitas--;
            end
         else
                get_real_point(1,offset xp,offset yp);
                bolas_fuego=0;//elige la desviacin +/- 45 grados de la bolita, 0 es 0 grados de desviacin
                bolita(xp,yp,1,dir);
                bolitas--;
         end
      end
      if(reverse==0 && anim==3)
         anim=0;
         graph++;
         if(graph==103)
            reverse=1;
         end
      end
      if(reverse==1 && anim==3)

         anim=0;
         graph--;
         if(graph==100)
            reverse=0;
         end
      end
      if(bolitas==0)
         cambiar_esquema=1;
      end
   end

   if(esquema==2)
      if(dir==izq)
          x -= 5;
          counter++;
          if(counter==130)
             cambiar_esquema=1;
          end
      else
          x += 5;
          counter++;
          if(counter==130)
             cambiar_esquema=1;
          end
      end
      if(exists(idllamas))//mover la llamarada junto con el Dragn
         get_real_point(1,offset xp,offset yp);//le pasamos el punto tag
         idllamas.x=xp;   idllamas.y=yp;
      end
      if(reverse==0 && anim==3)
         anim=0;
         graph++;
         if(graph==103)
            reverse=1;
         end
      end
      if(reverse==1 && anim==3)
         anim=0;
         graph--;
         if(graph==100)
            reverse=0;
         end
      end
   end

   if(esquema==3)//se lanza desde el cielo
      if(decision==0)
          decision=1;
          graph=104;
          frame(rand(9000,12000));
          if(idprota.x<165)
             dir=izq;
          end
          if(idprota.x>475)
             dir=der;
          end
          if(dir==izq)//posiciona al dragn en el cielo
              flags=0;
              x=idprota.x+100;//100
              y=79;//-200, 0
          else
              flags=1;
              x=idprota.x-100;//100
              y=79;
          end
      end//fin de decision
      if(decision==1)
          y += 9;
          if(dir==izq)
             x -= 4;
             if(jkeys_state[_JKEY_LEFT])
                x -= 1;
             end
          else
             x += 4;
             if(jkeys_state[_JKEY_RIGHT])
                x += 1;
             end
          end
          if(y>289)
             decision=2;
             ready2=0;
             graph=100;
             reverse=0;
             anim=0;
          end
      end
      if(decision==2)
         y -= 4;
         if(y<-50)//cambiar esquema
            cambiar_esquema=1;
         end
         if(ready2==10)//ready2==10    CADENCIA DEL VICIO DE LANZAR TRIPLES BOLITAS
           ready2=0;                  //cuanto ms alto es el nmero, ms frames tarda en lanzar otra tanda
           if(serie==1)               //tambin se ha de cambiar el nmero en if(ready2<"x") un poco ms abajo
              get_real_point(1,offset xp,offset yp);
              bolas_fuego=0;
              bolita(xp,yp,1,dir);//triples bolitas, 2 de ellas desviadas +/- 45 grados
              bolas_fuego=1;
              bolita(xp,yp,1,dir);
              bolas_fuego=2;
              bolita(xp,yp,1,dir);
              serie=2;//sin combinar bolitas de +/-45 y +/-20 el Dragn era muy fcil
           else
              get_real_point(1,offset xp,offset yp);
              bolas_fuego=3;
              bolita(xp,yp,1,dir);//triples bolitas, 2 de ellas desviadas +/- 45 grados
              bolas_fuego=4;
              bolita(xp,yp,1,dir);
              bolas_fuego=5;
              bolita(xp,yp,1,dir);
              serie=1;
           end
         end
      if(reverse==0 && anim==3)
         anim=0;
         graph++;
         if(graph==103)
            reverse=1;
         end
      end
      if(reverse==1 && anim==3)
         anim=0;
         graph--;
         if(graph==100)
            reverse=0;
         end
      end
      end
   end

   if(ready<25)//45
      ready++;
   end
   if(ready2<10)
      ready2++;
   end
   if(anim<3)
      anim++;
   end
   frame;
end        //el dragn ha sido derrotado
graph=113;
Loop
        If (rand(0,3)==0)
                play_wav(s_estrella,0);
        End
        If (flags==0)
                x+=5;
        Else
                x-=5;
        End

        y-=fuerza/4;
            contador-=1;
            fuerza-=gravity;
        explosion((x+rand(-50,50)),(y+rand(-50,50)));
             explosion2((x+rand(-50,50)),(y+rand(-50,50)),100);
             If (contador==0)
                 fin_nivel=true;
                 Break;
             End
             Frame;
    End
    signal(id,s_kill);
end

//-----------------------------------------------------------------------------
// Proceso para las bolas de fuego que dispara el dragn
// Entradas:  'x'
//                        'y'
//                        'tipo'
//                        'dir'
//-----------------------------------------------------------------------------

process bolita(x,y,BYTE tipo,BYTE dir)
private
idagua;
angulo;
BYTE sin_padre=0;
begin
ctype=c_scroll;
file=graficos_fase;
z=-512;
if(tipo==1)//bolitas de fuego
graph=121;
switch(bolas_fuego)
     case 0:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
     end
     case 1:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
          angulo -= 45000;
     end
     case 2:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
          angulo += 45000;
     end
     case 3:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
     end
     case 4:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
          angulo -= 20000;
     end
     case 5:
          angulo=fget_angle(x,y,idprota.x,idprota.y);
          angulo += 20000;
     end
end//fin del switch
loop
   graph=121;
   xadvance(angulo,6);
   //advance(6);
   explosion2(x,(y-4),100);
   if(idagua=collision(type agua))
      if(idagua.graph==40)
         break;
      end
   end
   if(collision(type latigo) | collision(type super))
      suena_sonido(s_bang,256,256);
      explosion(x,y);
      signal(id,s_kill);
   end
   frame;
   graph=120;
   xadvance(angulo,6);
   //advance(6);
   if(idagua=collision(type agua))
      if(idagua.graph==40)
         break;
      end
   end
   if(collision(type latigo) | collision(type super))
      suena_sonido(s_bang,256,256);
      explosion(x,y);
      signal(id,s_kill);
   end
   if(x<-100 | x>740 | y>320)//se ha salido de la pantalla
      signal(id,s_kill);
   end
   frame;
end
graph=122;
frame(200);
graph=123;
frame(200);
signal(id,s_kill);
frame;
end
if(tipo==2)//fogonazo
   flags=!father.flags;
   size=170;
   if(flags==0)
       angle=315000;//360-45
       //angle=45000;
   else
       //angle=315000;
       angle=45000;
   end
   loop
      graph=300;
      frame;
      frame;
      frame;
      graph=301;
      frame;
      frame;
      frame;
      if(dir==izq && sin_padre==0)//sin_padre sirve por si muere el Dragn, para que la llamarada se apague, antes se quedaba en el aire sin que hubiera un Dragn
          while(x>100)
             graph++;
             frame;
             frame;
             if(graph==305)
                graph=302;
             end
             if(father.graph==113)
                break;
                sin_padre=1;
             end
          end
      else
          while(x<530)//540
             graph++;
             frame;
             frame;
             if(graph==305)
                graph=302;
             end
             if(father.graph==113)
                break;
                sin_padre=1;
             end
          end
      end
      graph=306;
      while(graph<309)
         graph++;
         frame;
         frame;
         frame;
      end
      signal(id,s_kill);
      frame;
   end
   signal(id,s_kill);
   frame;
end
end

//-----------------------------------------------------------------------------
// Proceso para las cuchillas giratorias
// Entradas:  'x'
//                        'y'
//                        'flags' direccin del grfico
//                        'dir'        tiempo de pausa antes de arrancar
//-----------------------------------------------------------------------------

Process cuchilla(x,y,flags,pausa);
Private
        temp;
Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=501;              // Pon el grafico inicial del grafico
    priority=2;

    temp=501+pausa;

    Loop                    // Realiza la animacion de los graficos
            temp=temp+1;
                If (temp>500 and temp<520)
                        graph=temp;
                End
                If (temp>519 and temp<550)
                        graph=0;
                End
                If (temp>550)
                        temp=501;
                End
               If (graph==510)
                   suena_sonido(s_blade,50,256);
               End
           Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para crear la cola del salpicon de lava
// Entradas: 'x' 'y' Coordenadas
//-----------------------------------------------------------------------------

Process lava3(x,y);

Begin
    ctype=c_scroll;            // Haz que este dentro del scroll
    file=graficos_fase;
    graph=011;

    from graph=011 to 018;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para crear el chapuzon cuando salta la lava
// Entradas: 'x' 'y' Coordenadas
//-----------------------------------------------------------------------------

Process lava2(x,y);

Private
        contador=0;

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    file=graficos_fase;
    graph=250;              // Pon el grafico inicial del grafico
    priority=2;
    z=-11;

    Loop                    // Realiza la animacion de los graficos
                contador=contador+1;
        If contador MOD 2 == 0 :
                graph++;
                If (graph>258)
                    Break;
                End
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el salto del salpicon de lava
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process lava1(x,y);

Private

    fuerza;
    gravity=1;        // Gravedad es el nombre de un proceso!
    int contfor;     // Contador para el bucle for
    beta;
    contador=50;

Begin

    file=graficos_fase;
    graph=005;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;
    fuerza=rand(14,20);

    Loop
        lava3(x,y);
        y-=fuerza;
            contador-=1;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (y>352)
                     lava2(x,352);
                       suena_sonido(s_estrella,256,256);
                       signal(id,s_kill);    // Elimina el proceso actual
                       Break;
                   End
                 If (contador==0)
                         signal(id,s_kill);
                         Break;
                 End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el intervalo del salto del salpicon de lava
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process lava(x,pausa);

Private

        contador;

Begin

    ctype=c_scroll;     // Hace que este dentro del scroll
    y=352;
    z=-512;
    contador=pausa;

    Loop
            contador-=1;
            If (contador<0)
                    contador=pausa;
                    lava1(x,y);
                    lava2(x,y);
            End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para la bola aplastante giratoria
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process bola(x,y);

Private

        contador;
    velocd;
    sonido;

Begin

        ctype=c_scroll;
        z=-512;
        file=graficos_fase;
    graph=006;
    velocd=4;
    sonido=true;

        Loop
               contador+=1;                            // Contador para llevar cuenta del tiempo transcurrido
               If(y<208)
                       gravedad();
               Else
                       If(sonido==true)
                               play_wav(s_bang,0);
                               play_wav(s_ogro,0);
                               sonido=false;
                       End
                       If (contador==130)    // Cada vez que pasen 130 fotogramas aumentas velocidad
                               velocd+=1;
                               contador=0;
                       End
                       x+=velocd;              // Mueves la bola a la velocidad indicada
                       angle-=(1000*velocd);    // Giras la bola en proporcion a la velocidad
            If (x>9800)
                    Break;
            End
        End
          Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para la bola aplastante giratoria en el nivel 11
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process bolab(x,y);

Private

        contador;
    contador2;
    velocd;
    sonido;

Begin

        ctype=c_scroll;
        z=-512;
        file=graficos_fase;
    graph=006;
    velocd=4;
    sonido=true;
    contador2=30;

        Loop
               contador+=1;                            // Contador para llevar cuenta del tiempo transcurrido
               If(y<400)
                       gravedad();
               Else
                       If(sonido==true)
                               play_wav(s_bang,0);
                               play_wav(s_ogro,0);
                               sonido=false;
                       End
                       If (contador==130)    // Cada vez que pasen 130 fotogramas aumentas velocidad
                               velocd+=1;
                               contador=0;
                       End
                       x+=velocd;              // Mueves la bola a la velocidad indicada
                       angle-=(1000*velocd);    // Giras la bola en proporcion a la velocidad
            If (x>360 and x<368)
                    play_wav(s_bang,0);
                               play_wav(s_ogro,0);
            End
            If (x>368)                        // Destruccin de la bola
                    x=368;
                    contador2--;
                    If (rand(0,3)==0)
                                play_wav(s_estrella,0);
                            rocas(x,y);
                        End
                    If contador MOD 2 == 0 :
                            graph=0;
                    Else
                            graph=006;
                    End
                    explosion((x+rand(-50,50)),(y+rand(-50,50)));
                             explosion2((x+rand(-50,50)),(y+rand(-50,50)),100);
                    If (contador2<0)
                            Break;
                    End
            End
        End
          Frame;
        End
End

//-----------------------------------------------------------------------------
// Proceso para demonios voladores
// Entradas:  'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process demon(xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;
    contador=30;         // Espera a que el prota est listo
    contador2=75;
    int id_alas;

Begin
    file=graficos_general;
    graph=218;            // Elige el grafico inicial apropiado
    ctype=c_scroll;      // haz que este dentro del scroll
    id_alas=alas(x,y,z+1);

    Loop
        contador=contador-1;
        contador2++;
        If (contador2>55)
                contador2=0;
        End
        If (contador<0)
                contador=0;
        End
        // Haz un sonido de vez en cuando
        If (contador2==50)
                suena_sonido(s_laser,256,256);
            disparo_demon(x,y,-(8-flags*16),flags);
        End

        If (contador<1)
                If (x<idprota.x)
                        flags=1;
                Else
                        flags=0;
                End
        End

        angulo2+=pi/incx;                 // Halla el tamanio de los incrementos
        angulo3+=pi/incy;                 // que se harn en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los graficos
        graph++;
        If (contador2>47 and contador2<53)
            graph=219;
        Else
                graph=218;
        End
        If (collision (type latigo));
                play_wav(s_bang,0);
                If (tipolatigo==1)
                        shock(0);
                Else
                        suena_sonido(s_bang,256,256);
                        explosion(x,y);
                        explosion2b(x,y);
                    signal(id_alas, s_kill);
                    Break;
                End
            End
        If (collision (type super))
            suena_sonido(s_bang,256,256);
            explosion(x,y);
                explosion2b(x,y);
                signal(id_alas, s_kill);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner las alas de los demonios
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process alas(x,y,z);

Private
        contador=0;

Begin
    file=graficos_general;
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=014;              // Pon el grafico inicial del grafico

    Loop                    // Realiza la animacion de los graficos
                flags=father.flags;
                If(flags==0)
                        x=father.x+10;
                Else
                        x=father.x-10;
                End
                y=father.y-12;
                contador=contador+1;
        If contador MOD 2 == 0 :
                graph++;
                If (graph>023)
                    graph=014;
                End
            contador=0;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner la lluvia
// Efecto bajo consumo de cpu, pero algo ms de ram
//-----------------------------------------------------------------------------

Process lluvia()
Private
BYTE descenso=0;
Begin
ctype=c_screen;
file=graficos_fase;
graph=7;
x=0;
y=240;
z=-15;
   Loop
             x -= 8;//4
             y += 6;//3
             descenso++;//hasta 160, 160x3=480
             If(descenso==40)//80
                descenso=0;
                x=0;
                y=240;
             End
             Frame;
   End
End

//-----------------------------------------------------------------------------
// Proceso para la reina de la fase final
// Entradas:  'gr'            Tipo de grafico
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process queen(gr,flags,xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;
    contador=30;                     // Contador para esperar a que el prota est listo
    contador2=30;         // Contador que determina la pauta del disparo 1
    ataque=0;
    beta;                     // Variable 0 o 1 para los ataques aleatorios
    toque=16;                // Contador para los impactos del ltigo
    platform=false;                // Switch para comprobar si ya existen plataformas y no volverlas a crear

Begin
    file=graficos_fase;
    graph=gr;                // Elige el grafico inicial apropiado
    z=10;
    ctype=c_scroll;          // haz que este dentro del scroll

    While (energia_enemigo>0)               // Mientras se tenga energia
        toque+=1;
        If (toque>16)
                toque=16;
        End
        contador=contador-1;
        contador2=contador2-1;
        ataque=ataque+1;
        If (contador<0)
                contador=0;
        End
        If (contador2<0)
                contador2=60;
        End
        If (ataque>5180)
                ataque=500;
        End
        If (contador<1)
                If (x<idprota.x)
                        flags=1;
                Else
                        flags=0;
                End
        End
        magia(rand(x+20,x-20),rand(y,y+60));
    If (ataque<240)
        gr=005;
        size=80;
        x=320;
        y=930;
    End
    If (ataque>240 and ataque<280);
            If contador2 MOD 2 == 0 :
                    size++;
        End
    End

    If (ataque>280 and ataque<500)
            z=-256;
            graph=006;
            size=100;
        If (y>750)
                        y=y-4;
            Else
                    y=750;
            End
        If (ataque==330)
                    bomba2(200,600,0);
                play_wav(s_laser,0);
            End
            If (ataque==360)
                    bomba2(320,600,0);
                play_wav(s_laser,0);
            End
            If (ataque==390)
                    bomba2(440,600,0);
                play_wav(s_laser,0);
            End
    End

      If (ataque>500 and ataque<1500)
        yrelativa=750;
        xrelativa=320;
        graph=006;
        angulo2+=pi/incx;                 // Halla el tamao de los incrementos
        angulo3+=pi/incy;                 // que se haran en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        If (contador2==60)
                If (flags==0)
                        play_wav(s_laser,0);
                        explosion3(x+10,y-60,100);
                bala(x+10,y-60,45000);
                bala(x+10,y-60,90000);
                bala(x+10,y-60,135000);
                bala(x+10,y-60,180000);
                bala(x+10,y-60,225000);
                bala(x+10,y-60,270000);
                bala(x+10,y-60,315000);
                    bala(x+10,y-60,360000);
                Else
                    play_wav(s_laser,0);
                        explosion3(x-12,y-60,100);
                bala(x-10,y-60,45000);
                bala(x-10,y-60,90000);
                bala(x-10,y-60,135000);
                bala(x-10,y-60,180000);
                bala(x-10,y-60,225000);
                bala(x-10,y-60,270000);
                bala(x-10,y-60,315000);
                    bala(x-10,y-60,360000);
                End
        End
// ****************************************************************************************
// Condiciones de colision con el latigo segun el estado actual de la reina
// ****************************************************************************************
                If (collision(type latigo))
                        If (toque==16)
                                     toque=0;
                                 play_wav(s_estrella,0);
                                If (tipolatigo==1)
                                        explosion(x,y);
                                    energia_enemigo-=5;
                                Else
                                        explosion(x,y);
                                    energia_enemigo-=10;
                                End
                                 queen_tocada(x,y);
                                 ataque=2000;
                             End
                End
                If (collision (type super))
                        If (toque==16)
                                queen_tocada(x,y);
                                toque=0;
                            play_wav(s_estrella,0);
                            explosion(x,y);
                                explosion2b(x,y);
                                energia_enemigo-=15;
                            queen_tocada(x,y);
                                 ataque=2000;
                        End
                    End
// ****************************************************************************************
// Fin de las condiciones de colision temporales
// ****************************************************************************************
    End

    If (ataque>1500 and ataque<2000)    // Sube para situarse fuera de escena
            graph=005;
            If (y>-80)
                        y=y-4;
            Else
                    y=-80;
            End
            If ataque MOD 60 == 0 :                // Y mientras manda unos escarabajos voladores
                If (rand(0,1)==0)
                        scarab(91,0,idprota.x-300,idprota.y-64,24,24,1,48);
                Else
                        scarab(91,1,idprota.x+300,idprota.y-64,24,24,0,48);
                End
        End
// ****************************************************************************************
// Condiciones de colision con el latigo segun el estado actual de la reina
// ****************************************************************************************
                If (collision(type latigo))
                        If (toque==16)
                                     toque=0;
                                 play_wav(s_estrella,0);
                                If (tipolatigo==1)
                                        explosion(x,y);
                                    energia_enemigo-=5;
                                Else
                                        explosion(x,y);
                                    energia_enemigo-=10;
                                End
                                 queen_tocada(x,y);
                                 ataque=2000;
                             End
                End
                If (collision (type super))
                        If (toque==16)
                                queen_tocada(x,y);
                                toque=0;
                            play_wav(s_estrella,0);
                            explosion(x,y);
                                explosion2b(x,y);
                                energia_enemigo-=15;
                            queen_tocada(x,y);
                                 ataque=2000;
                        End
                    End
// ****************************************************************************************
// Fin de las condiciones de colision temporales
// ****************************************************************************************
    End

    If (ataque>2000 and ataque<2005)    // Se elige aleatoriamente la posicion de ataque
            graph=007;
            beta=rand(0,1);
    End

    If (ataque>2005 and ataque<2010)     // Se prepara a entrar por el lado elegido
            y=-80;
            If (beta==0);
                    x=600;
                flags=0;
        Else
                x=40;
                flags=1;
        End
    End

    If (ataque>2010 and ataque<2800)     // Entra en escena y ataca con onda vital ;)
        If (y<1360)
                        y=y+2;
            Else
                    y=1360;
            End
            If (!exists(type laser))
                    laser(x,y);
            End
// ****************************************************************************************
// Condiciones de colision con el latigo segun el estado actual de la reina
// ****************************************************************************************
                If (collision(type latigo))
                        signal(type laser, s_kill);
                        If (toque==16)
                                     toque=0;
                                 play_wav(s_estrella,0);
                                If (tipolatigo==1)
                                        explosion(x,y);
                                    energia_enemigo-=5;
                                Else
                                        explosion(x,y);
                                    energia_enemigo-=10;
                                End
                                 queen_tocada(x,y);
                                 ataque=2800;
                             End
                End
                If (collision (type super))
                        signal(type laser, s_kill);
                        If (toque==16)
                                queen_tocada(x,y);
                                toque=0;
                            play_wav(s_estrella,0);
                            explosion(x,y);
                                explosion2b(x,y);
                                energia_enemigo-=15;
                            queen_tocada(x,y);
                                 ataque=2800;
                        End
                    End
// ****************************************************************************************
// Fin de las condiciones de colision temporales
// ****************************************************************************************
    End

    If (ataque>2800 and ataque<2805)     // Se prepara a entrar por el lado elegido
            y=1360;
            If (beta==0)
                    x=40;
                flags=1;
        Else
                x=600;
                flags=0;
        End
    End

    If (ataque>2805 and ataque<3700)     // Entra en escena y ataca con onda vital (2) ;)
        If (y>-160)
                        y=y-2;
            Else
                    y=-160;
            End
            If (!exists(type laser))
                    laser(x,y);
            End
// ****************************************************************************************
// Condiciones de colision con el latigo segun el estado actual de la reina
// ****************************************************************************************
                If (collision(type latigo))
                        signal(type laser, s_kill);
                        If (toque==16)
                                     toque=0;
                                 play_wav(s_estrella,0);
                                If (tipolatigo==1)
                                        explosion(x,y);
                                    energia_enemigo-=5;
                                Else
                                        explosion(x,y);
                                    energia_enemigo-=10;
                                End
                                 queen_tocada(x,y);
                                 ataque=3700;
                             End
                End
                If (collision (type super))
                        signal(type laser, s_kill);
                        If (toque==16)
                                queen_tocada(x,y);
                                toque=0;
                            play_wav(s_estrella,0);
                            explosion(x,y);
                                explosion2b(x,y);
                                energia_enemigo-=15;
                            queen_tocada(x,y);
                                 ataque=3700;
                        End
                    End
// ****************************************************************************************
// Fin de las condiciones de colision temporales
// ****************************************************************************************
    End

    If (ataque>3700 and ataque<3705)    // Se elige aleatoriamente la posicion de ataque
            graph=005;
            signal(type laser, s_kill);
            beta=rand(0,1);
    End

    If (ataque>3705 and ataque<3710)     // Se prepara a entrar por el lado elegido
            y=112;
            If (beta==0)
                    x=-80;
                flags=1;
        Else
                x=720;
                flags=0;
        End
    End

    If (ataque>3710 and ataque<3780)     // Entra en escena... otra vez...
        y=112;
        If (beta==0)
                If (x<128)
                                x=x+3;
                    Else
                            x=128;
                End
            Else
            If (x>512)
                                x=x-3;
                    Else
                            x=512;
                End
        End
    End

    If (ataque>3780 and ataque<4800)            // Y ataca con bombas parabolicas
        yrelativa=112;
        If (beta==0)
                xrelativa=128;
        Else
                xrelativa=512;
        End
        graph=006;
        angulo2+=pi/incx;                    // Halla el tamao de los incrementos
        angulo3+=pi/incy;                    // que se haran en las dos coordenadas

        x=xrelativa+get_distx(angulo2,distx);        // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);        // Incrementa la coordenada y

        If (contador2==15 or contador2==30 or contador2==45 or contador2==60)
                If (flags==0)
                        play_wav(s_laser,0);
                        explosion3(x+12,y-60,100);
                bombas(x+12,y-60,rand(-1,-6));
                Else
                    play_wav(s_laser,0);
                        explosion3(x-12,y-60,100);
                bombas(x-12,y-60,rand(1,6));
                End
        End
// ****************************************************************************************
// Condiciones de colision con el latigo segun el estado actual de la reina
// ****************************************************************************************
                If (collision(type latigo))
                        signal(type laser, s_kill);
                        If (toque==16)
                                     toque=0;
                                 play_wav(s_estrella,0);
                                If (tipolatigo==1)
                                        explosion(x,y);
                                    energia_enemigo-=5;
                                Else
                                        explosion(x,y);
                                    energia_enemigo-=10;
                                End
                                 queen_tocada(x,y);
                                 ataque=5000;
                             End
                End
                If (collision (type super))
                        signal(type laser, s_kill);
                        If (toque==16)
                                queen_tocada(x,y);
                                toque=0;
                            play_wav(s_estrella,0);
                            explosion(x,y);
                                explosion2b(x,y);
                                energia_enemigo-=15;
                            queen_tocada(x,y);
                                 ataque=5000;
                        End
                    End
// ****************************************************************************************
// Fin de las condiciones de colision temporales
// ****************************************************************************************
    End

    If (ataque>4800 and ataque<5000)            // Sale de la escena...
        y=112;
        If (beta==0)
                If (x>-80)
                                x=x-3;
                    Else
                            x=-80;
                End
            Else
            If (x<720)
                                x=x+3;
                    Else
                            x=720;
                End
        End
    End

    If (ataque>5000 and ataque<5005)            // Se teletransporta al fondo...
        x=320;
            y=1360;
    End

    If (ataque>5005 and ataque<5180)            // Y sube hasta el centro de la pantalla
        x=320;
            graph=005;
        If (y>750)
                        y=y-3;
            Else
                    y=750;
            End
            If ataque MOD 60 == 0 :                // Y mientras manda unos escarabajos voladores
                If (rand(0,1)==0)
                        scarab(91,0,idprota.x-300,idprota.y-64,24,24,1,48);
                Else
                        scarab(91,1,idprota.x+300,idprota.y-64,24,24,0,48);
                End
        End
    End
        Frame;
    End
    muertebigboss(x,y);
    fin_nivel=true;
    signal(id,s_kill);
End

//------------------------------------------------------------------------------
// Proceso de la reina cuando la han alcanzado y le restan vida.
//-----------------------------------------------------------------------------

Process queen_tocada(x,y);

Private
    creador=false;
    contador=60;
    fuerza=18;
    gravity=2;            //gravedad es un nombre de un proceso!

Begin
    file=graficos_fase;
    priority=1;
    play_wav(s_shout,0);
    signal(father,s_sleep);     // Duerme al proceso padre
    ctype=c_scroll;                 // Hace que este dentro del scroll
    flags=father.flags;             // Coge las banderas (izq./der.) que tenia el padre
    z=father.z;

    Loop
        graph=008;
        magia(rand(x+20,x-20),rand(y,y+60));
        contador=contador-1;     // Empieza a contar hacia atrs
        If (contador<10)
                If(contador%2==0)
                        graph=008;
                Else
                        graph=000;
                End
        End
        y-=fuerza/4;
            fuerza-=gravity;

        If (energia_enemigo>0)
                If (contador==0)
                    signal(father,s_wakeup);
                    father.flags=flags;
                    father.x=x;
                    father.y=y;
                    Break;
                End
                If (flags==0)
                        x+=2;
                Else
                        x-=2;
                End
                Frame;
        Else
                If (rand(0,3)==0)
                        play_wav(s_estrella,0);
                End
            If (x<320)
                        flags=0;
                        x+=4;
                Else
                        flags=1;
                        x-=4;
                End
                       explosion((x+rand(-50,50)),(y+rand(-50,50)));
                     explosion2((x+rand(-50,50)),(y+rand(-50,50)),100);
                     If (contador==0)
                         signal(father,s_wakeup);
                    father.flags=flags;
                    father.x=x;
                    father.y=y;
                         //fin_nivel=true;
                         Break;
                     End
                     Frame;
                End
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner el polvo magico de la reina ;)
// Entradas: 'x' 'y' Coordenadas
//-----------------------------------------------------------------------------

Process magia(x,y);

Begin
    ctype=c_scroll;            // Haz que este dentro del scroll
    file=graficos_fase;
    graph=009;
    z=12;
    From graph=009 to 016;
    Frame;End
End

//-----------------------------------------------------------------------------
// Proceso para las bombas de la reina
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process bombas(x,y,incx);

Private

    fuerza;
    gravity=1;
    int contfor;     // Contador para el bucle for
    beta;
    contador=50;

Begin
    file=graficos_fase;
    graph=080;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;
    fuerza=14;

    Loop
        estela2(x,y-16);
        If contador MOD 2==0 :
                graph=019;
        Else
                graph=020;
        End
            contador-=1;
            If (contador<0)
                    contador=50;
            End
        y-=fuerza/2;
            x+=incx;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (y>1300)
                       signal(id,s_kill);    // Elimina el proceso actual
                       Break;
                   End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para las bombas que destruyen las plataformas
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process bomba2(x,y,incx);

Private

    fuerza;
    gravity=1;
    int contfor;     // Contador para el bucle for
    beta;
    contador=50;

Begin
    file=graficos_fase;
    graph=080;
    ctype=c_scroll;     // Hace que este dentro del scroll
    z=-512;
    fuerza=14;

    Loop
        estela2(x,y-16);
        If contador MOD 2==0 :
                graph=019;
        Else
                graph=020;
        End
            contador-=1;
            If (contador<0)
                    contador=50;
            End
        y-=fuerza/2;
            x+=incx;
            fuerza-=gravity;
             For(contfor=y; contfor<=(y-fuerza); contfor+=1)
                     If (y>1300)
                       signal(id,s_kill);    // Elimina el proceso actual
                       Break;
                   End
             End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para generar la estela de las bombas
// Entradas: 'x' e 'y'
//-----------------------------------------------------------------------------

Process estela2(x,y);

Begin
    file=graficos_fase;
    ctype=c_scroll;
    graph=070;
    z=-510;
    from graph=070 to 078;
    frame;end
End

//-----------------------------------------------------------------------------
// Proceso para los disparos con angulo de la reina
// Entradas:  'x' e 'y'       Coordenadas
//-----------------------------------------------------------------------------

Process bala(x,y,angle)

Private

        contador;

Begin
    file=graficos_fase;
    ctype=c_scroll;                  // Hace que este dentro del scroll
    graph=018;                    // Elige el grafico apropiado
    contador=150;

    Loop
        contador--;
        graph++;
        If (graph>020)
                graph=018;
        End
        xadvance(angle,4);
        If (contador<0)
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso de la 'onda vital' de la reina
// Entradas: 'x' 'y' Coordenadas
//-----------------------------------------------------------------------------

Process laser(x,y);

Private

        contador;

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    file=graficos_fase;
    graph=061;              // Pon el grafico inicial del grafico
    z=-100;
    contador=30;

    Loop                    // Realiza la animacion de los graficos
                contador--;
                If (contador<0)
                        contador=30;
                        play_wav(s_onda,0);
                End
                flags=father.flags;
                If(flags==0)
                        x=father.x-35;
                Else
                        x=father.x+35;
                End
                y=father.y-36;
        graph++;
        If (graph>068)
            graph=061;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner las capas de scroll en los creditos finales
// Entradas: 'x' 'y' 'z'
//-----------------------------------------------------------------------------

Process scrollcrd(x,y,z,graph,incx);

Begin
    file=graficos_fase;

    Loop                    // Realiza la animacion de los graficos
        x-=incx;
        If (x<-160)
                scrollcrd(480,y,z,graph,incx);
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner al prota cabalgando en los crditos
// Entradas: 'x' 'y' Coordenadas de las antorchas
//-----------------------------------------------------------------------------

Process caballo(x,y);

Begin
    file=graficos_fase;
    graph=100;              // Pon el grafico inicial del grafico
    z=-500;
    priority=2;

    Loop                    // Realiza la animacion de los graficos
        graph++;
        If (graph>110)
            graph=100;
        End
        If (jkeys_state[_JKEY_A])
                signal(type fondo, s_kill);
                signal(type credits, s_kill);
                signal(Type scrollcrd,s_kill);
                fin_nivel=true;
                Break;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner el fondo negro de los creditos
// Entradas: ninguna
//-----------------------------------------------------------------------------

Process fondo();

Private

        contador=0;

Begin
    file=graficos_fase;
    graph=8;
    z=-510;
    x=159;
    y=120;
    Loop
        contador++;
        If (contador>180 and contador<260)
                        x+=2;
        End
        If (contador>282)
                contador=282;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner las capas de scroll en los creditos finales
// Entradas: 'x' 'y' 'z'
//-----------------------------------------------------------------------------

Process credits(y,graph);

Private

        contador=0;

Begin
    file=graficos_fase;
    z=-512;
    x=160;

    Loop                    // Realiza la animacion de los graficos
        contador++;
        If (contador>261)
                contador=261;
        End
        If (contador>60)
                y--;
        End
        If (contador>180 and contador<260)
                        x++;
        End
        If (y<-200)
                Break;
        End
        Frame;
    End
End

// Dado un directorio, intenta crear todos los directorios que
// estn por encima de l si no existen
// Debera ser equivalente a "mkdir -p" en unix.
Process crear_jerarquia(string nuevo_directorio)                // Mejor Function que Process aqu
Private
    string directorio_actual="";
    string rutas_parciales[10];     // Slo acepta la creacin de un mximo de 10 directorios
    int i_max=0, i=0;

Begin
    directorio_actual = cd();                        // Recuperamos el directorio actual de trabajo, para volver luego a l
    if(chdir(nuevo_directorio) == 0)    // El directorio ya existe!
        cd(directorio_actual);
        return 0;
    end
    i_max = split("[\\/]", nuevo_directorio, &rutas_parciales, 10);
    chdir("/");
    while (i<i_max)
        while(rutas_parciales[i] == "")         // Se salta partes en blanco
                if(i++ >=i_max)
                       cd(directorio_actual);
                       return 0;
                end
        end
        if(chdir(rutas_parciales[i]) == -1)
                if(mkdir(rutas_parciales[i]) == -1)        // Error al intentar crear el directorio
                        cd(directorio_actual);
                        return -1;
                end
                chdir(rutas_parciales[i]);
        end;
        i++;
    end
    chdir(directorio_actual);
    return 0;
End

